UNIT vdomhlp;

INTERFACE

USES  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, StdCtrls, vdomus0,  vzlocom, vstdcons;

TYPE
  TForm3 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Label1: TLabel;
    PROCEDURE Button1Click(Sender: TObject);
  PRIVATE
    { Private declarations }
  PUBLIC
    { Public declarations }
  END;

CONST
{*}GeneralH1_n:INTEGER = 5;
   GeneralH1:ARRAY[1..10] OF STRING = (
'The purpose of VDOMUS is the analysis of 3-dimensional diffraction',
'spectra s(N,x,y), where N = time of flight, x and y are angles in',
'the position-sensitive detector plane:',
'find the 3-dimensional peaks and estimate their volumes, positions',
'and widths in N,x,y axes, and current theta and dk.',
' ணࠬ VDOMUS -  3- ࠪ樮 ᯥ஢',
's(N,x,y),  N = ६ ஫, x  y 㣫  ᪮ 樮 -',
'⢨⥫쭮 ⥪,:',
' 3-嬥   業  ꥬ,  (業) ',
'ਭ  N,x,y ,  ⥪騥 (ॠ) theta  dk.'
);
{*}MenuComm_n:INTEGER =12;
   MenuComm:ARRAY[1..24] OF STRING = (
'FILE    = for input of spectra and INI-files.',
'SETTING = for setting such data as spectrum bounds, graph modes and',
'          TOF-information',
'GRAPH   = for displaying graphs of spectrum and its convolutions',
'MARK    = for clicking with the mouse on the spectrum points, which',
'          e.g. peaks, will be used for the analysis.',
'OPERATION = to perform different type of spectrum analysis, including',
'            peak search, calculation of their volumes, positions, dk,',
'            theta etc.',
'INFO      = to view and/or edit all possible spectrum and peak',
'            information, input or obtained from the analysis',
'HELP    = comments to the VDOMUS program.',
'FILE    =   ᯥ஢  INI-䠩',
'SETTING =  ⠭ ⠪   ࠭  ᯥ, ०',
'          䨪, TOF-ଠ樨',
'GRAPH   =  ᢥ稢 䨪 ᯥ   ᢥ⮪',
'MARK    =  clicking   窠 ᯥ, ',
'          ਬ, ,  ᯮ짮  .',
'OPERATION = 믮 ࠧ  ࠡ⪨, ',
'             , ᫥  ꥬ, , dk,',
'            theta  ..',
'INFO      =  ᬮ / ।஢ ࠧ筮 ଠ樨',
'            ,  祭  室 ',
'HELP    = ਨ  ணࠬ VDOMUS.'
);
{*}OperGrph_n:INTEGER = 20;
   OperGrph:ARRAY[1..40] OF STRING = (
'A 3-dimensional spectrum s(N,x,y), N=1..1024, x=1..32, y=1..8 is ',
'graphed as a sequence of 8 bands (y-variable), each point of which',
'has coordinates (N-horizontal, x-vertical). Spectrum intensity is',
'coded by brightness of the point. Additionally, below,',
'a 1-dimensional section s(N,xc,yc) is graphed (xc,yc = fixed).',
'3 scales are possible: normal, sqrt,log. With 5 EDIT indicators above',
'one can set:  N1,N2 (click on Set N1,N2); xc,yc (click on Set X,Y);',
'              N section (Set section).',
'One can also look the sections through by clicking on buttons',
'Section Up, Section Down.',
'Clicking on the graph point shows its coordinates and spectrum value.',
'Using command Mark Set of Points one can manually point to the peak',
'positions; analysis then starts, which estimates volume, positions,',
'widths, theta, L current, and d (interplanar distance).',
'This information is stored and saved by command: File Save Results.',
'  ->BMP-file = to save the graph as a BMP-file, which can be then put',
'               to a WORD-document etc.',
'  OK = to terminate the process of point marking',
'  Cancel = to cancel the previous errorroneous marking',
'Convolutions (summing in X; Y; X,Y) are graphed only for viewing.',
'3- ᯥ s(N,x,y), N=1..1024, x=1..32, y=1..8 ࠦ  ',
'䨪  ᫥⥫쭮 8  ( y),  窠 ன',
' न (N- ਧ⠫, x- ⨪). ⥭ᨢ',
'ᯥ  મ 祪.⥫쭮,  ୮',
'祭 s(N,xc,yc) 뢮  䨪 (xc,yc = 䨪஢).',
'3 誠 : ଠ쭠, sqrt,log. 5 EDIT ࠬ ',
' ⠭:N1,N2 (click  Set N1,N2); xc,yc(click  Set X,Y);',
'                 N 祭 (Set section).',
' ᬮ 祭    clicking  :',
'Section Up, Section Down.',
'Clicking  窥 䨪   न  祭 ᯥ  ',
' Mark Set of Points   㪠  ;',
'᪠ ,  業 ꥬ, , ਭ',
'theta, ⥪饥 L,  d (᪮⭮ ﭨ).',
' ଠ ᯠᠥ : File, Save Results.',
'  ->BMP-file = ᯠ 䨪  BMP-䠩,    ⥬',
'                 WORD-㬥,  ..',
'  OK =   ⬥⪨ 祪.',
'  Cancel = ⬥ 訡 ⬥ 窨.',
'⪨ (㬬  X; Y; X,Y) 뤠  䨪 ⮫쪮  ᬮ.'
);
{*}GetStart_n:INTEGER =14;
   GetStart:ARRAY[1..28] OF STRING = (
'VDOMUS output file has standard name d+(day+hour+min).res. It is kept',
'in ASCII file vdomus.fn; then, if changed, automatically updated.',
'The simplest analysis can be carried out as follows.',
'*/ Input the spectrum and the effective spectrum (FILE commands)',
'   normalize the spectrum by the effective one; (OPERATION commands)',
'   Graph the spectrum (GRAPH commands)',
'*/ Set the needed TOF - information (SETTINGS command)',
'*/ Find the peaks automatically (OPERATION commands)',
'*/ See the results (INFO about peaks command); save them to output',
'   file if needed;',
'To customize all sorts of VDOMUS analysis one should try different',
'modes; one should bear in mind: VDOMUS does not damage the spectrum',
'and other files, so that one can experiment with different options',
'without any fear.',
'VDOMUS: ⠭⭮  室 䠩 d+(day+hour+min).res.',
' ᮤন  䠩 vdomus.fn  ⮬᪨ .',
'⥩訩  ⢫ ⠪:',
'*/  ᯥ  䥪⨢ ᯥ ( FILE)',
'   ଠ ᯥ  䥪⨢; ( OPERATION)',
'   ந 䨪 ᯥ ( GRAPH)',
'*/ ⠭ ॡ㥬 TOF - ଠ ( SETTINGS)',
'*/  ⮬᪨  ( OPERATION)',
'*/ ᬮ १ (INFO about peaks); ᯠ   室',
'   䠩, ᫨ ;',
' ᢮ ࠧ ० VDOMUS    ஡.',
'᫥ : VDOMUS   ᯥ  㣨 䠩, ⠪ ',
' ᯥਬ஢  ࠧ묨 ﬨ  直 ᥭ',
'- ᯮ.'
);
{*}DFindP_n:INTEGER = 11;
   DFindP:ARRAY[1..22] OF STRING = (
'For automatic finding the peaks one should set the following',
'variables:',
'1. Coefficient for getting a smoothed spectrum copy, default=0.5.',
'2. Sensitivity - default is 1;',
'                 if weak peaks are missed take smaller sensitivity',
'                 if too many peaks found, take larger sensitivity',
'3. Resolution - default is 1;',
'4. Bounds for N,X,Y-widths (in channel)',
'5. Minimal peak hypervolume (in counts) - if less, peak is annuled.',
'1-dimensional peaks are serched in convolution in X,Y(function of N);',
'The found peaks are analyzed. For results see: INFO about Peaks',
' ⮬᪮ ᪠   ᫥騥 ६',
'',
'1. 樥  祭 ᣫ  ᯥ, default=0.5.',
'2. ⢨⥫쭮 - default = 1;',
'        ᫨ ய᪠ ᫠ ,   ⢨⥫쭮',
'        ᫨ 室 ᫨誮  ,  .',
'3. 襭 - default = 1;',
'4. ࠭  N,X,Y-ਭ ( )',
'5.  ꥬ ( )-  訬 ய᪠.',
'1-    ᢥ⪥  X,Y (㭪樨 N);',
'  ࠡ뢠.  १ ᬮ: INFO about Peaks'
);
{*}Asshkls_n:INTEGER = 7;
   Asshkls:ARRAY[1..14] OF STRING = (
'There a file of sample hkls should be input by this command.',
'The structure of this file is as follows:  1st line is (comment)=',
'* h   k   l   0   d ,',
'then lines each of which contains:',
'  h   k   l   0   d',
'where d is sample interplanar distance',
'Then the max deviation (in A) of found d and sample d is needed.',
'⮩   䠩  hkl-ﬨ.',
' ⮣ 䠩 ᫥:  1  (਩)=',
'* h   k   l   0   d ,',
'⥬ ,    ᮤন:',
'  h   k   l   0   d',
' d ᪮⭮ ﭨ. ⥬  ॡ ᨬ쭮 ',
'⪫ ( A) d   d 室.'
);
{*}SimSp_n:INTEGER = 2;
   SimSp:ARRAY[1..4] OF STRING = (
'The spectrum is simulated on the basis of random information.',
'4 peaks are produced.',
' ᨬ㫨  ᭮ 砩 ⮩ ଠ樨.',
' 4 .'
);
{*}SetSpB_n:INTEGER = 2;
   SetSpB:ARRAY[1..4] OF STRING = (
'The bounds in N (time of flight), x,y (angles) axes are set (chan.)',
'only for the spectrum analysis.',
'⠭ ࠭   N (६ ஫), x,y (㣫)( .)',
'⮫쪮   ᯥ.'
);
{*}SScaleM_n:INTEGER = 3;
   SScaleM:ARRAY[1..6] OF STRING = (
'The scales are set only for graphs, the spectrum is not changed.',
'Trimming coefficient means the cut-off level (between 0 and 1 of max)',
'of graphed spectrum amplitudes.',
'⠡ ⮫쪮  䨪, ᠬ ᯥ  .',
'樥 trimming (१) 砥 ஢ ( 0  1)',
' ᨬ㬠 뢮  䨪  ᯥ.'
);
{*}SetToF_n:INTEGER = 2;
   SetToF:ARRAY[1..4] OF STRING = (
'The ToF information is needed for the spectrum transformation to the',
'reversed space and conversion of 3-dimensional peak channels to d.',
'ToF ଠ 㦭  ८ࠧ ᯥ    ⭮',
'࠭⢥  ᨨ  3   d.'
);
{*}SmooSp_n:INTEGER = 4;
   SmooSp:ARRAY[1..8] OF STRING = (
'Spectrum is smoothed by 3dimensional generalization of Lanzos filter',
'Coefficient for smoothing ranges between 0 and 1.',
'Output: quadratic difference of initial and smoothed spectra',
'        smoothness value',
' ᣫ 3 饭 䨫 .',
'樥 ᣫ 祭  0  1.',
'室 ଠ:   ࠧ 室  ᣫ',
'ᯥ  祭 ⥯ .'
);
PROCEDURE ActivateForm3(ix,iw,ih:LONGINT);
VAR
  Form3: TForm3;

IMPLEMENTATION

{$R *.DFM}
PROCEDURE TForm3.Button1Click(Sender: TObject);
BEGIN Close;
END;
PROCEDURE ActivateForm3(ix,iw,ih:LONGINT);
BEGIN WITH Form3 DO
 BEGIN Close; Left:=exs(ix); Top:=0; Width:=exs(iw); Height:=exs(ih);
 Color:=clGreen; Font.Size:=fntsize;
 Make_Memo(Memo1,ix,iw-10);
 MaketheButton(Form3.Button1,200,390,80,20,'OK');
 END;
END;

END.


{*}_n:INTEGER = ;
   :ARRAY[1..] OF STRING = (
);
{*}_n:INTEGER = ;
   :ARRAY[1..] OF STRING = (
);
{*}InfIniF_n:INTEGER = -3;
   InfIniF:ARRAY[1..3] OF STRING = (
'The input INI-file may be edited and saved.',
'Asterisc at the line 1st position means comment line;',
'only numerical data and file names between these comment lines matter.'
);
{*}SavIni_n:INTEGER = -10;
   SavIni:ARRAY[1..10] OF STRING = (
'The ini-file contains:',
'Commands for setting the number of spectra and phases',
'Commands for the input of the last analyzed spectrum, variance,',
'eff.spectrum; the normalization and correction for absorption.',
'Commands for input phase and atomic information',
'Command for forming hkls',
'Command for forming Rietveld parameter array.',
'The created ini-file can be edited in usual way by any text editor.',
'One can use the ini-file to avoid routine operations in the future',
'with data input and preparation for fitting.'
);
{*}OutSp_n:INTEGER = -5;
   OutSp:ARRAY[1..5] OF STRING = (
'This command outputs the spectrum 1 (counts or errors) as a file of',
'a specified type:',
'1/ as a binary 2 bytes per word file',
'2/ as a binary 4 bytes per word file',
'3/ as an ASCII free field format file'
);
{*}EntBMPFN_n:INTEGER = -5;
   EntBMPFN:ARRAY[1..5] OF STRING = (
'Specify the BMP-file name where the current graph picture will be',
'saved. This file can be later used in programs for working with',
'graphs, as,e.g., WORD, etc.',
'Reversing the colors, i.e. transforming the graph to colors',
'"white background, black picture" is needed for a black/white printer.'
);
{*}SavFitR_n:INTEGER = -3;
   SavFitR:ARRAY[1..3] OF STRING = (
'The main fit results - refined lattice and atom parameters are saved',
'in a file whose name should be here specified.',
'To save all the rifined parameters use command Update Parameter File.'
);
{*}IShelp_n:INTEGER = -21;
   IShelp:ARRAY[1..21] OF STRING = (
'The following spectrum file types (length < 16385) are admissible:',
'    binary file, 2 bytes per word',
'    binary file ,4 bytes per word',
'              X,  counts, [ error]',
'While inputting the spectrum, unless the latter type is used,',
'the Poisson variance (squared errors) is formed:',
'           var(i) = sp(i) + 1  in each channel i.',
'Other than Poisson variance should be input separately after',
'the spectrum input.',
'It is needed if the scale of the data is inconvenient',
'The corresponding TOF information should be specified for each',
'spectrum analyzed (also for effective one). These are:',
'Channel width in mks; Spectrum delay in channels;',
'Bragg angle in degrees; Time of Flight in meter.',
);
