UNIT vmriaup; {UPEAK module.  Jun 14 2001}
INTERFACE

USES Windows,  Messages, SysUtils, Classes,  Graphics, Controls, Forms,
     Dialogs,  StdCtrls, ExtCtrls, Grids,    vzlocom,  vmria0,   vmria2,
     vmriarit, vmriafl,  vmriahlp, vspectr,  vmriainf, varfun,
     vmriasgm, vpmodel,  vpeaksr,  vgfit,    vstdcons, vmria00;
PROCEDURE FindthePeaks;
PROCEDURE UPEAKAnalysis;
PROCEDURE PrepareUpPar;
PROCEDURE PrepareExpPar;
PROCEDURE UpFitting;
PROCEDURE ShowUpFitResults;
PROCEDURE regup(iit:INTEGER);
PROCEDURE SuminOutput;
PROCEDURE SmirnovAnalysis;
PROCEDURE ReduceModAssign;
PROCEDURE TurnHKLtoPeaks;
PROCEDURE MakeConExFit;
VAR  i:INTEGER;
     c_strar:ARRAY[1..5] OF STRING[11];

IMPLEMENTATION
PROCEDURE MakeParOut(n:INTEGER);
VAR i:INTEGER; s:STRING;
BEGIN WITH gfit DO WITH LB1rec DO
 BEGIN ConvertStr(rb.chi2,10,2); ar[1]:='      Chi^2 = '+sedz;
 ConvertStr(rb.chipl,10,2); ar[2]:='      Chi+  = '+sedz; ar[3]:=' ';
 FOR i:=1 TO n DO
  BEGIN ConvertStr(par[i].p,10,3); s:=sedz; ConvertStr(par[i].e,10,3);
  ar[3+i]:=c_strar[i]+' = '+s+' +- '+sedz;
  END;
 Writeln(fout); Writeln(fout,'    Exponential analysis;');
 FOR i:=1 TO n+3 DO Writeln(fout,ar[i]);
 END;
END;
PROCEDURE MakeConExFit;
VAR   i,im:INTEGER; cmax:REAL; s:STRING;
LABEL Lag;
BEGIN{***} WITH parar[1] DO
 BEGIN pl:=10; p:=10; pu:=10;
 END;
WITH parar[2] DO
 BEGIN pl:=1000; p:=120000; pu:=1E15;
 END;
WITH parar[3] DO
 BEGIN pl:=90; p:=110; pu:=120;
 END;
WITH parar[4] DO
 BEGIN pl:=15; p:=15; pu:=15;
 END;
WITH parar[5] DO
 BEGIN pl:=21; p:=45; pu:=70;
 END;
Lag: L0rec:=''; MakeForm(0);
s:='Enter initial parameters';
OuttoLabel(Form2.Label5,5,10,clMaroon,clWhite,s);
strgrW[0]:=50;  strgrW[1]:=80; strgrW[2]:=80; strgrW[3]:=80;
strgrT[1]:='B'; strgrT[2]:='A'; strgrT[3]:='T'; strgrT[4]:='Sig';
strgrT[5]:='t_0';
FOR i:=1 TO 5 DO WITH parar[i] DO
 BEGIN strgrNn[i,1]:=pl; strgrNn[i,2]:=p; strgrNn[i,3]:=pu;
 END;
s:='Par_name   Low_bound   Curr_value  Up_bound';
OuttoLabel(Form2.Label5,5,10,clBlue,clWhite,s);
PuttoTable(10,50,5,5,4,8);
WITH CB1rec DO
 BEGIN nitems:=2; indx:=morozm+1;
 ar[1]:='Resolution fit';
 ar[2]:='Fit t_0 mode';
 END;
MakeRadioGroup(1,0,20,240,270,60);

WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 morozm:=RadioGroup1.ItemIndex;
 FOR i:=1 TO 5 DO WITH StringGrid1 DO WITH parar[i] DO
  BEGIN Zval(Cells[1,i-1],p); Zval(Cells[0,i-1],pl);
  Zval(Cells[2,i-1],pu);
  END;
 END;
WITH gfit DO WITH LB1rec DO
 BEGIN cb:=cw; npar:=5; cb.gnit:=200; cb.step:=0.95; cb.damp:=0.05;
 FOR i:=1 TO npar DO WITH parar[i] DO
  BEGIN n:=i; a:=1; b:=0; com:=strgrT[i]; {cb.ipr:=1;}
  END;
 FOR i:=1 TO 5 DO par[i]:=parar[i];
 LeastSquaresFit(ConExAr,TestRegul);
 FOR i:=1 TO 5 DO parar[i]:=par[i];
 MakeFormV(170,0,400,430,1);
 c_strar[1]:='Background ';
 c_strar[2]:='Amplitude  ';
 c_strar[3]:='Halflife   ';
 c_strar[4]:='Resolution ';
 c_strar[5]:='T_0        ';
 MakeParOut(5); nitems:=8;
 MakeListBox(10,0,380,370); Form2.ShowModal;
 {prifch; Fitting characteristics}
 GOTO Lag;
 END;
END;
PROCEDURE UPEAKAnalysis;  {Version Feb 4 2002}
VAR   i,j,iop,m:INTEGER; ss:STRING;
LABEL Lbeg;
BEGIN iop:=1; IF(npeak<>0)THEN iop:=3; IF(nexp<>0)THEN iop:=4; sinf:='';
WITH spec[numsp] DO
 BEGIN ic1:=a11; ic2:=a22; m:=ic2-ic1+1;
 END;
gfit.mpoint:=m;
Lbeg: SaveHelp(Ufit_n,Ufit);
L0rec:='PEAK / EXPONENTIAL  FITTING'; MakeForm(1);
s:=selops; OuttoLabel(Form2.Label1,5,30,clGreen,clWhite,s);
IF(sinf<>'')THEN OuttoLabel(Form2.Label5,50,260,clBlue,clWhite,sinf);
WITH CB1rec DO
 BEGIN indx:=iop; nitems:=8;
 ar[1]:=' Find the peaks';
 ar[2]:=' Turn hkls to peaks';
 ar[3]:='    Prepare peak parameters';
 ar[4]:='    Prepare expon. parameters';
 ar[5]:=' Make the fitting';
 ar[6]:=' Show the Fitted Parameters';
 ar[7]:=' Exit and show graphs';
 ar[8]:='    Make convoluted_expo fitting';
 MakeRadioGroup(1,0,10,50,290,180);
 END;

sinf:=''; WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 GetRealUpNMod(nupmod); i:=RadioGroup1.ItemIndex;
 END;
CASE i OF
0: BEGIN IF(NOT psclass)THEN peaksr:=TPeakSearch.Create; psclass:=true;
   FindthePeaks; iop:=3;
   END;
1: BEGIN TurnHKLtoPeaks; iop:=3;
   END;
2,3:
   BEGIN CheckSavings(ok,ss); IF(NOT ok)THEN Exit; mriamode:=3;
   CheckSpecErr(numsp); IF(ModalRes=0)THEN Exit;
   L0rec:='Preparing parameter array'; MakeFormV(170,0,400,430,0);
   IF(i=2)THEN PrepareUpPar ELSE PrepareExpPar; MakeParComments;
   IF(ModalRes<>0)THEN
    BEGIN WITH gfit DO FOR i:=1 TO npar DO par[i]:=parar[i];
    WITH cw DO {Fit controls}
     BEGIN IF(NOT cb_init[mriamode+1])THEN
      BEGIN gfit.FormCB; cw:=gfit.cb; step:=0.98; damp:=0.02; gnit:=7;
      IF(gfit.npar>nmmax)THEN cmprs:=1 ELSE cmprs:=0;
      END;
     END;
    ShowParameterArray;
    SetNoPrep(13,true); noprep[4]:=false; SetNoFit(13,true); iop:=5;
    END;
   END;
4: BEGIN IF(noprep[4])THEN
    BEGIN ShowInfo('First prepare parameters'); iop:=3; GOTO Lbeg;
    END;
   ShowFitControls; gfit.cb:=cw; SaveHelp(Ufit_n,Ufit);
   positexp:=false; UpFitting; nosavedU:=true; grst:=2; iop:=6;
   FOR i:=0 TO 3 DO inipar[i]:=0; SetIniPar(3,1);
   END;
5: BEGIN IF(nofit[4])THEN
    BEGIN ShowMess('First make the fitting'); iop:=5; GOTO Lbeg;
    END;
   ShowUpFitResults; iop:=7;
   END;
6: Exit;
7: BEGIN positexp:=true; mriamode:=3; MakeConExFit; nofit[4]:=false;
   grst:=2; iop:=7;
   END;
ELSE END;
GOTO Lbeg;
END;
PROCEDURE TurnHKLtoPeaks;
VAR i,j,k,iph,np:INTEGER; r:REAL;
BEGIN np:=0; FOR iph:=1 TO nph DO FOR i:=1 TO lat[iph].nhkl DO
 WITH spec[numsp] DO
  BEGIN r:=dtoch(hkla[i,iph].dk); IF(rinfun(Round(r),a11,a22))THEN
   BEGIN Inc(np); onl[np]:=r; tam[iph]:=iph;
   END;
  END;
FOR i:=1 TO np-1 DO FOR j:=1 TO np-1-i DO IF(onl[j]>onl[j+1])THEN
 BEGIN r:=onl[j+1]; onl[j+1]:=onl[j]; onl[j]:=r;
 k:=tam[j+1]; tam[j+1]:=tam[j]; tam[j]:=k;
 END;
FOR i:=1 TO np-1 DO IF(ABS(onl[i+1]-onl[i])<=1)THEN
 BEGIN onl[i+1]:=(onl[i+1]+onl[i])*0.5; onl[i]:=0;
 END;
k:=0; FOR i:=1 TO np DO IF(onl[i]<>0)THEN
 BEGIN Inc(k); onl[k]:=onl[i]; tam[k]:=tam[i];
 END;
np:=k; FOR i:=1 TO np DO marka[i]:=onl[i]; npeak:=np;
sinf:=IntToStr(npeak)+' peaks formed';
END;
PROCEDURE UpFitting;
{Purpose: to make the UPEAK fitting. Version: Feb 13 2002}
VAR   i,l2:INTEGER; boo:BOOLEAN;
LABEL L21,L32;
{ ---------------------------------------------------------------}
BEGIN {CheckParameters;} IF(ModalRes=0)THEN Exit; l2:=0; Nittot:=0;
L21: dispbut:=true; MakeCurrInfo; Form2.Caption:='Peak Fit'; Form2.Show;
WITH gfit DO
 BEGIN GetNFreePar(i); IF(i>npmax)THEN
  BEGIN ShowMess('More than '+IntToStr(npmax)+' free parameters');
  Modalres:=0; Exit;
  END;
 cb.ipr:=0; IF(debugV.cbipr)THEN cb.ipr:=1;
 LeastSquaresFit(arpeak,regup); Nittot:=Nittot+rb.gnit;
 Form2.Close; CheckConvergence;
 boo:=NOT((nocnv)OR(noinv)OR(noch)OR(noeps)OR(noequ));
 IF(boo OR(l2<>0))THEN GOTO L32; rincc;
 {if process did not converge, an attempt to minimize once more}
 l2:=1; GOTO L21;
 L32: FOR i:=1 TO npar DO parar[i]:=par[i];
 FOR i:=1 TO 6 DO spec[numsp].bkpar[i]:=parar[i].p;
 END;
{Form fitted graph}
{FOR i:=1 TO 16384 DO spec[numsp].x[i]:=0;
i1:=spec[numsp].a11; i2:=spec[numsp].a22; FOR i:=i1 TO i2 DO
 BEGIN spec[numsp].x[i]:=0; xx:=i-i1+1; xarg:=xx+i1-1; sarg:=numsp;
 arpeak(r,r,v,Round(xx),4);
 spec[numsp].x[i]:=v; spec[0].x[i]:=rb0[1];
 END;}
MakeForm(1); WITH LB1rec DO WITH spec[numsp] DO
 BEGIN ar[1]:=' '; ar[3]:=' ';
 ar[2]:='   INTERVAL = '+IntToStr(a11)+' -'+IntToStr(a22);
 END;
i:=3; MakeFitResLB(i); MakeListBox(5,10,305,260);
MakeBevel(5,270,300,90,1); WITH CB1rec DO
 BEGIN ar[1]:=' Repeat fitting with smaller step'; nitems:=1;
 END;
MakeCheckListBox(20,280,270,19);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 IF(CheckListBox1.Checked[0])THEN
  BEGIN gfit.cb.step:=cw.step*0.5; GOTO L21;
  END;
 END;
UpdateSpectroInfo;
SetNoFit(13,true); nofit[4]:=false; inipar[3]:=0;
indi:='     '; indi[numsp+1]:='x'; WITH gfit DO
 BEGIN cb.gnit:=cw.gnit; cb.step:=cw.step; cb.damp:=cw.damp;
 END;
END;
PROCEDURE PrepareUpPar;
VAR   i,j,k,np,i1,i2,ia,ip,ia1,ip1,ips:INTEGER; ok:BOOLEAN; d,c,r:REAL;
LABEL Lend;
BEGIN MakeBevel(5,9,380,110,1);
OuttoLabel(Form2.Label5,10,10,clGreen,clAqua,
 'Enter accuracies for positions, width0, width1');
strgrW[0]:=120; FOR i:=1 TO 4 DO strgrW[i]:=60;
strgrT[1]:=' Delta Pos(chan)'; FOR i:=1 TO 4 DO strgrNn[1,i]:=dpos[i];
strgrT[2]:=' Delta W0(chan)';  FOR i:=1 TO 4 DO strgrNn[2,i]:=dwi0[i];
strgrT[3]:=' Delta W1(chan)';  FOR i:=1 TO 4 DO strgrNn[3,i]:=dwi1[i];
OuttoLabel(Form2.Label6,125,28,clGreen,clWhite,
 'Model_1 Model_2 Model_3 Model_4');
PuttoTable(10,48,3,3,4,8);
OuttoLabel(Form2.Label7,3,120,clGreen,clWhite,
 'Select the background mode');
IF(keyBck=1)THEN spec[numsp].dback:=6;
CB1rec:=DBackRec; CB1rec.indx:=spec[numsp].dback+2;
MakeRadioGroup(1,0,5,136,150,210);
OuttoLabel(Form2.Label8,220,148,clGreen,clWhite,
 IntToStr(npeak)+'  marked peak(s)');
IF(npeak=0)THEN OuttoLabel(Form2.Label9,160,168,clGreen,clWhite,
  'Warning: Only background fitting');
WITH LB1rec DO
 BEGIN nitems:=5;
 ar[1]:=' If peaks have different';
 ar[2]:=' models,';
 ar[3]:=' make model assignment';
 ar[4]:='     Command:';
 ar[5]:=' MARK, assign the models';
 END;
MakeListBox(170,210,210,90);
WITH CB1rec DO
 BEGIN ar[1]:='   Use available parameter array'; nitems:=1;
 END;
MakeCheckListBox(50,350,270,20);
IF(inipar[3]=1)THEN Form2.CheckListBox1.Checked[0]:=true;

Form2.ShowModal; IF(ModalRes=0)THEN Exit;
j:=Form2.RadioGroup1.ItemIndex-1;
spec[numsp].dback:=j; IF(j=6)THEN keyBck:=1 ELSE keyBck:=0;
nexp:=0; GetRealUpNMod(nupmod);
FOR i:=1 TO nupmod DO IF(pmod[i].typ=6)THEN
 BEGIN j:=MessageDlg(
  'Peak model '+IntToStr(i)+' exponential. Proceed?',MtWarning,
   [mbYes,mbNo],0);
 IF(j=mrNo)THEN
  BEGIN ModalRes:=0; Exit;
  END;
 END;
pararmod:=3; i:=2*npeak+14; IF(use_m2)THEN i:=i+2;
IF(Form2.CheckListBox1.Checked[0])THEN
 BEGIN IF(i<>npold)THEN
  ShowMess('New number of parameters differs from old');
 GOTO Lend;
 END;
FOR i:=1 TO 4 DO Zval(Form2.StringGrid1.Cells[i-1,0],dpos[i]);
FOR i:=1 TO 4 DO Zval(Form2.StringGrid1.Cells[i-1,1],dwi0[i]);
FOR i:=1 TO 4 DO Zval(Form2.StringGrid1.Cells[i-1,2],dwi1[i]);
WITH spec[numsp] DO {arrange the components in an increasing order}
 BEGIN i1:=a11; i2:=a22; gfit.mpoint:=i2-i1+1;
 FOR i:=2 TO npeak DO FOR j:=1 TO npeak-i+1 DO
  IF(marka[j]>=marka[j+1])THEN
   BEGIN r:=marka[j+1]; marka[j+1]:=marka[j]; marka[j]:=r;
   k:=tam[j+1]; tam[j+1]:=tam[j]; tam[j]:=k;
   END;
 FOR i:=1 TO npeak-1 DO IF(marka[i]=marka[i+1])THEN marka[i]:=-1;
 k:=0; FOR i:=1 TO npeak DO IF(rinfun(marka[i],Float(i1),Float(i2)))THEN
  BEGIN Inc(k); marka[k]:=marka[i]; tam[k]:=tam[i];
  END;
 npeak:=k; GetRealUpNMod(nupmod);
 IF(w0=0)THEN
  BEGIN ShowMess('Width0 = 0. See: INFO about spectrum');
  noprep[4]:=true; Exit;
  END;
 END;
GetNumofPar(np,3); FOR j:=1 TO np DO WITH parar[j] DO
 BEGIN n:=j; a:=1; b:=0; p:=0; pl:=-1E12; pu:=1E12; e:=0;
 END;
{Form background parameters} MakeBackPars(1);
{Form amplitudes} FOR j:=1 TO npeak DO WITH parar[6+j] DO
 BEGIN r:=marka[j]; k:=Round(r); r:=AMAX1(spec[numsp].y[k],10);
 p:=r; pl:=SQRT(r)/2;
 END;
ReduceModAssign; {Form peak positions}
FOR j:=1 TO npeak DO WITH parar[npeak+6+j] DO
 BEGIN p:=marka[j]; k:=tam[j]; r:=dpos[k]; pl:=p-r; pu:=p+r;
 END;
FOR j:=1 TO 4 DO {Form width parameters}
 BEGIN WITH parar[2*npeak+6+j] DO
  BEGIN k:=tam[j]; p:=spec[numsp].w0; r:=dwi0[k]; pl:=AMAX1(p-r,1);
  pu:=p+r; IF(j>nupmod)THEN
   BEGIN pl:=0; p:=0; pu:=0;
   END;
  END;
 WITH parar[2*npeak+10+j] DO
  BEGIN k:=tam[j]; p:=spec[numsp].w1; r:=dwi1[k]; pl:=p-r; pu:=p+r;
  IF(j>nupmod)THEN
   BEGIN pl:=0; p:=0; pu:=0;
   END;
  END;
 END;
IF(use_m2)THEN
 BEGIN ips:=GetNAddiPar(2); FOR i:=ips+1 TO ips+2 DO WITH parar[i] DO
  BEGIN pl:=-1E15; p:=0; pu:=1E15;
  END;
 END;
IF(npeak>1)THEN {correction of peaks boundaries}
 BEGIN FOR i:=1 TO npeak-1 DO
  BEGIN ia:=i+6; ip:=ia+npeak; ia1:=ia+1; ip1:=ip+1;
  d:=1/SQRT(AMAX1((parar[ia].p+parar[ia1].p),0.5))*2;
  c:=(parar[ip].p+parar[ip1].p)/2; r:=ABS(parar[ip1].p-parar[ip].p);
  IF(r<(d*2))THEN
   BEGIN parar[ip].pu:=parar[ip].p; parar[ip1].pl:=parar[ip1].p;
   END       ELSE
    BEGIN IF(parar[ip].pu>parar[ip1].pl)THEN
     BEGIN parar[ip].pu:=c-d; parar[ip1].pl:=c+d;
     END;
    END;
  END;
 END;
Lend: GetNumofPar(npold,3); gfit.npar:=npold;
END;
PROCEDURE PrepareExpPar;
VAR   i,j,ip:INTEGER; r:REAL;
LABEL Lend;
BEGIN WITH CB1rec DO
 BEGIN ar[1]:='   Use available parameter array'; nitems:=2;
 ar[2]:='   Make standard exponential models';
 END;
MakeCheckListBox(50,2,280,38);
IF(inipar[3]=1)THEN Form2.CheckListBox1.Checked[0]:=true;
Form2.CheckListBox1.Checked[1]:=true;
CB1rec:=Num4Rec; CB1rec.indx:=MAX0(1,nexp);
OuttoLabel(Form2.Label8,10,43,clGreen,clWhite,
 'Select the number of exponentials');
MakeRadioGroup(2,4,50,60,280,40);
OuttoLabel(Form2.Label7,10,173,clGreen,clWhite,
 'Select the background mode');
CB1rec:=DBackRec; WITH CB1rec DO
 BEGIN nitems:=2; indx:=spec[numsp].dback+2;
 END;
MakeRadioGroup(1,0,100,190,200,60);
MakeBevel(5,255,380,115,1);
OuttoLabel(Form2.Label5,10,260,clGreen,clAqua,
 'Enter half-lives and their accuracies');
strgrW[0]:=120; FOR i:=1 TO 4 DO strgrW[i]:=60;
r:=0; ip:=spec[numsp].a11; WITH spec[numsp] DO FOR i:=a11 TO a11+30 DO
 IF(y[i]>r)THEN
  BEGIN r:=y[i]; ip:=i;
  END;
strgrT[1]:='2 Half-Life(chan)'; FOR i:=1 TO 4 DO strgrNn[1,i]:=dpos[i];
strgrT[2]:=' Delta (chan)';  FOR i:=1 TO 4 DO strgrNn[2,i]:=dwi0[i];
strgrT[3]:=' Position (chan)';  FOR i:=1 TO 4 DO strgrNn[3,i]:=ip;
OuttoLabel(Form2.Label6,130,280,clGreen,clWhite,
 'Exp_1    Exp_2     Exp_3     Exp_4');
PuttoTable(10,298,3,3,4,8);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
spec[numsp].dback:=MIN0(0,Form2.RadioGroup1.ItemIndex-1);
nexp:=Form2.RadioGroup2.ItemIndex+1; FOR i:=1 TO nexp DO tam[i]:=i;
gfit.npar:=2*nexp+14; npeak:=nexp;
IF(Form2.CheckListBox1.Checked[1])THEN FOR i:=1 TO nexp DO
 BEGIN pmod[i].typ:=6; pmod[i].makesm;
 END;
IF(Form2.CheckListBox1.Checked[0])THEN
 BEGIN IF((2*nexp+14)<>npold)THEN
  ShowMess('New number of parameters differs from old'); GOTO Lend;
 END;
FOR i:=1 TO nexp DO Zval(Form2.StringGrid1.Cells[i-1,0],dpos[i]);
FOR i:=1 TO nexp DO Zval(Form2.StringGrid1.Cells[i-1,1],dwi0[i]);
FOR i:=1 TO nexp DO Zval(Form2.StringGrid1.Cells[i-1,2],posa[i]);
FOR j:=1 TO gfit.npar DO WITH parar[j] DO
 BEGIN n:=j; a:=1; b:=0; p:=0; pl:=-1E12; pu:=1E12; e:=0;
 END;
ip:=spec[numsp].a11;
CASE spec[numsp].dback OF {form background}
-1:   BEGIN FOR i:=1 TO 6 DO
       BEGIN parar[i].p:=0; parar[i].pl:=0; parar[i].pu:=0;
       END;
      END;
0: BEGIN parar[1].pl:=0; amn:=spec[numsp].y[ip]/100;
   FOR i:=2 TO 6 DO
    BEGIN parar[i].pl:=0; parar[i].pu:=0;
    END;
   END;
ELSE END;
FOR j:=1 TO nexp DO WITH parar[6+j] DO {Form amplitudes}
 BEGIN ip:=Round(posa[j]); r:=spec[numsp].y[ip]; p:=r; pl:=SQRT(r)/2;
 END;
FOR j:=1 TO nexp DO WITH parar[nexp+6+j] DO {Form positions}
 BEGIN r:=posa[j]; p:=r; pl:=r; pu:=r;
 END;
FOR j:=1 TO 4 DO {Form widths}
 BEGIN WITH parar[2*nexp+6+j] DO
  BEGIN p:=dpos[j]; pl:=AMAX1(p-dwi0[j],1); pu:=p+dwi0[j];
  IF(j>nexp)THEN
   BEGIN pl:=0; p:=0; pu:=0;
   END;
  END;
 WITH parar[2*nexp+10+j] DO
  BEGIN p:=0; pl:=0; pu:=0;
  END;
 END;
Lend: npold:=gfit.npar;
END;
PROCEDURE SuminOutput;
VAR i,j,m:INTEGER; xx,v,ex,w,ew,vt,ff,fz,fzz:REAL;
BEGIN {j:=ic1; xx:=0; WITH spec[numsp] DO
 BEGIN FOR i:=a1 TO a2 DO
  BEGIN y[i]:=y[i]*100; e[i]:=e[i]*100;
  END;
 m:=a2-a1+1; spx:=spx*100; spn:=spn*100; dback:=0; FOR i:=a1 TO a2 DO
  BEGIN onl[i]:=spec[numsp].x[i]; onl[i+m]:=i; sa[i]:=onl[i];
  END;
 FOR i:=a11 TO a22 DO IF(y[i]>xx)THEN
  BEGIN xx:=y[i]; j:=i;
  END;
 END;
npeak:=1; marka[1]:=j;
dwi1[1]:=0;
PrepareUpPar; IF(ModalRes=0)THEN Exit;
UpFitting; IF(ModalRes=0)THEN Exit; nosavedU:=true; grst:=2;
FOR i:=0 TO 3 DO inipar[i]:=0; SetIniPar(3,1);
IF(nofit[4])THEN
 BEGIN ShowMess('No fitting was performed'); Exit;
 END;
L0rec:='Sumin Result Output'; MakeFormV(170,0,300,430,1);
SaveHelp(Ufit_n,Ufit);
WITH LB1rec DO WITH gfit DO
 BEGIN ar[1]:=' Interval '+IntToStr(ic1)+' - '+IntToStr(ic2);
 ConvertStr(rb.chi2,10,2); ar[2]:='      Chi^2 = '+sedz;
 ConvertStr(rb.chipl,10,2); ar[3]:='      Chi+  = '+sedz;
 ar[4]:=' ';
 ConvertStr(par[7].p,8,1); s:=sedz;
 ConvertStr(par[7].e,7,1); AdjustSt(s,8); Compress(sedz);
 ar[5]:=' Amplitude '+' = '+s+' +- '+sedz;
 ar[6]:=' ';
 xx:=par[8].p; ex:=par[8].e;
 ConvertStr(xx,9,2); s:=sedz;
 ConvertStr(ex,7,2); AdjustSt(s,8); Compress(sedz);
 ar[7]:=' Position '+' = '+s+' +- '+sedz;
 ar[8]:=' ';
 w:=par[9].p; ew:=par[9].e;
 ConvertStr(w,9,2); s:=sedz;
 ConvertStr(ew,7,2); AdjustSt(s,8); Compress(sedz);
 ar[9]:=' Width '+' = '+s+' +- '+sedz; ar[10]:=' ';

 lapin(onl,m,xx,v); ConvertStr(v,9,2); s:=sedz;
 SLanz(m,Round(xx),ff,fz,fzz); vt:=ABS(fz)*ex;
 ConvertStr(vt,9,2); AdjustSt(s,8); Compress(sedz);
 ar[11]:=' Energy = '+s+' +- '+sedz;

 lapin(onl,m,xx+(w/2),v); ConvertStr(v,9,2); s:=sedz;
 SLanz(m,Round(xx+w/2),ff,fz,fzz);
 vt:=ABS(fz)*SQRT(SQR(ex)+0.25*SQR(ew));
 ConvertStr(vt,9,2); AdjustSt(s,8); Compress(sedz);
 ar[12]:=' E(P+W/2)= '+s+' +- '+sedz;
 nitems:=12;
 END;
REPEAT MakeListBox(10,0,280,370);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
IF(ListBsav)THEN
 BEGIN nosavedU:=false; Exit;
 END        ELSE
 BEGIN s:='Results not saved. Return?';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN Exit;
 END;
UNTIL false;}
END;
PROCEDURE regup(iit:INTEGER);
{A special regularizer program for displaying intermediate fit results}
VAR s,s1:STRING;
BEGIN ConvertStr(gfit.rb.chi2,25,2); Compress(sedz);
s:=' Iteration= '+IntToStr(gfit.rb.gnit); s1:='         Chi2= '+sedz;
IF(dispbut)THEN
 BEGIN L0rec:='Peak Fit'; Form2.Timer1.Interval:=1; Wait(click1);
 OuttoLabel(Form2.Label5,15,30,clGreen,clWhite,s);
 OuttoLabel(Form2.Label6,50,50,clGreen,clAqua,s1);
 END       ELSE Form2.Caption:=s+s1;
END;
PROCEDURE FindthePeaks;
VAR i,j:INTEGER;
BEGIN FOR i:=1 TO nph DO IF(pmod[i].typ=6)THEN
 BEGIN j:=MessageDlg('Peak model '+IntToStr(i)+' exponential. Proceed?',
 MtWarning,[mbYes,mbNo],0); IF(j=mrNo)THEN Exit;
  END;
ModalRes:=1; IF(spec[numsp].NoSpectrum(numsp))THEN
 BEGIN ModalRes:=0; Exit;
 END;
L0rec:='Find the Peaks'; MakeForm(1); SaveHelp(Ufindp_n,Ufindp);
s:='Set the control data for peak search';
OuttoLabel(Form2.Label5,15,70,clGreen,clWhite,s);
strgrW[0]:=210; strgrW[1]:=80; WITH spec[numsp] DO
 BEGIN strgrT[1]:=' Width at the beginning (chan)'; strgrNn[1,1]:=w0;
 strgrT[2]:=' Width at the end(chan)'; strgrNn[2,1]:=w1;
 strgrT[3]:=' Width accuracy(chan)'; strgrNn[3,1]:=dw0;
 END;
strgrT[4]:=' Sensitivity (0.5 - 3)'; strgrNn[4,1]:=sens;
strgrT[5]:=' Resolution (1-3)'; strgrNn[5,1]:=res;
strgrT[6]:=' Small statistics'; strgrNn[6,1]:=smast;
PuttoTable(10,90,6,6,1,8);
WITH LB1rec DO
 BEGIN nitems:=4; ar[1]:='         Warning.';
 ar[2]:='The quality of peak search';
 ar[3]:='strongly depends on the accuracy';
 ar[4]:='of width estimates.';
 END;
MakeListBox(30,260,270,70);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 6 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 IF(har[1]<=0)THEN ShowMess('Erroneous width')
              ELSE spec[numsp].w0:=har[1];
 IF(har[2]<=0)THEN ShowMess('Erroneous width')
              ELSE spec[numsp].w1:=har[2];
 IF(har[3]<=0)THEN ShowMess('Erroneous width accuracy')
              ELSE spec[numsp].dw0:=har[3];
 IF(har[4]<=0)THEN ShowMess('Erroneous sensitivity')
              ELSE sens:=har[4];
 IF(har[5]<=0)THEN ShowMess('Erroneous resolution')
              ELSE res:=har[5];
 smast:=har[6];
 END;
mriamode:=3; WITH peaksr DO WITH spec[numsp] DO
 BEGIN deb:=false; ic1:=a11; ic2:=a22;
 cw1:=(w1-w0)/(ic2-ic1); cw0:=w0-cw1*ic1;
 MarkTheIntervals(spec[numsp],ic1,ic2,w0,w1,dw0);
 END;
inipar[3]:=0; FOR i:=1 TO npeak DO tam[i]:=1;

MakeFormV(170,20,330,430,1);
s:=' Edit the list of marked peaks by command: ';
OuttoLabel(Form2.Label5,10,6,clMaroon,clWhite,s);
s:=' Info about Set of Points ';
OuttoLabel(Form2.Label6,75,22,clWhite,clBlack,s);
WITH LB1rec DO
 BEGIN nitems:=3+npeak; ar[1]:=IntToStr(npeak)+'  peaks found';
 fltostr(sens,10,sedz); Compress(sedz); ar[2]:='Sensitivity= '+sedz;
 fltostr(res,10,sedz); Compress(sedz); ar[3]:='Resolution= '+sedz;
 FOR i:=1 TO npeak DO ar[3+i]:=IntToStr(Round(marka[i]));
 END;
MakeListBox(20,50,270,320); Form2.ShowModal;
SetNoFit(15,true); noprep[4]:=true;
END;
PROCEDURE ShowUpFitResults;
VAR i,j,k:INTEGER; pp,ep:REAL; wa,ew:ARRAY[1..4] OF REAL;
BEGIN L0rec:='Output of fitting results'; MakeFormV(150,0,450,430,1);
SaveHelp(Ufit_n,Ufit); WITH LB1rec DO WITH gfit DO
 BEGIN ar[1]:=' Interval '+IntToStr(ic1)+' - '+IntToStr(ic2);
 ConvertStr(rb.chi2,10,2); ar[2]:='      Chi^2 = '+sedz;
 ConvertStr(rb.chipl,10,2); ar[3]:='      Chi+  = '+sedz;
 ar[4]:=' '; ar[5]:='  Background parameters  ';
 FOR i:=1 TO 6 DO
  BEGIN ConvertStr(par[i].p,8,1); s:=sedz; ConvertStr(par[i].e,6,1);
  AdjustSt(s,8); Compress(sedz);
  ar[5+i]:=' Bck_'+IntToStr(i)+' = '+s+' +- '+sedz;
  END;
 ar[12]:=' '; ar[13]:='  Peak amplitudes (areas if W1=0)';
 FOR i:=1 TO 4 DO WITH par[i+6+2*npeak] DO  {Get widths for areas}
  BEGIN wa[i]:=p; ew[i]:=e;
  END;
 FOR i:=1 TO npeak DO WITH par[i+6] DO
  BEGIN ConvertStr(p,8,1); s:=sedz;
  ConvertStr(e,7,1); AdjustSt(s,8); Compress(sedz);
  s:=' Amp.'+IntToStr(i)+' = '+s+' +- '+sedz;
  pp:=ABS(p*wa[tam[i]]); ep:=SQRT(SQR(e*wa[tam[i]])+SQR(ew[tam[i]]*p));
  ConvertStr(pp,12,0); Compress(sedz); s:=s+'  ('+sedz+' +- ';
  ConvertStr(ep,10,0); Compress(sedz); ar[13+i]:=s+sedz+')';
  END;
 j:=14+npeak; ar[j]:=' '; Inc(j); ar[j]:='  Peak positions ';
 FOR i:=1 TO npeak DO WITH par[i+6+npeak] DO
  BEGIN ConvertStr(p,9,2); s:=' Pos.'+IntToStr(i)+' = '+sedz;
  ConvertStr(e,7,2); ar[j+i]:=s+' +-'+sedz;
  END;
 j:=j+npeak+1; ar[j]:=' '; Inc(j); ar[j]:='  Widths (2 half-lives) ';
 FOR i:=1 TO 4 DO WITH par[i+6+2*npeak] DO
  BEGIN ConvertStr(p,9,2); s:=sedz; ConvertStr(e,7,2); AdjustSt(s,8);
  Compress(sedz); ar[j+i]:=' W_0 mod.'+IntToStr(i)+' = '+s+' +- '+sedz;
  END;
 j:=j+4; ar[j+1]:=' '; FOR i:=1 TO 4 DO WITH par[i+10+2*npeak] DO
  BEGIN ConvertStr(p,9,2); s:=sedz; ConvertStr(e,7,2); AdjustSt(s,8);
  Compress(sedz);
  ar[j+i+1]:=' W_1 mod.'+IntToStr(i)+' = '+s+' +- '+sedz;
  END;
 j:=j+5; IF(use_m2)THEN
  BEGIN FOR i:=1 TO 2 DO WITH par[2*npeak+14+i] DO
   BEGIN ar[j+1]:=bblank;
   ConvertStr(p,9,2); s:=sedz; ConvertStr(e,7,2); AdjustSt(s,8);
   Compress(sedz); ar[j+i+1]:=' '+com+' = '+s+' +- '+sedz;
   END;
  j:=j+3;
  END;
 nitems:=j;
 END;
MakeListBox(10,0,430,370); Form2.ShowModal; IF(ModalRes=0)THEN Exit;
IF(ListBsav)THEN nosavedU:=false;
END;
PROCEDURE SmirnovAnalysis;
VAR i,j,m,nf,iloop:INTEGER; yy,v,w,cmax:REAL; fg,fd:TEXTFILE; s:STRING;
BEGIN L0rec:='Smirnov Analysis; Enter file list name'; mriamode:=3;
fn:='c:\zlok\sm.txt'; GetFilename(fn,0);
MakeForm(0);
s:=selops; OuttoLabel(Form2.Label5,5,20,clMaroon,clWhite,s);
strgrW[0]:=120; strgrW[1]:=100;
strgrT[1]:='Position= '; strgrNn[1,1]:=70;
strgrT[2]:='Width= '; strgrNn[2,1]:=5;
strgrT[3]:='File Type= '; strgrNn[3,1]:=4;
PuttoTable(25,40,3,3,1,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 END;
AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
i:=0; WHILE(NOT EoF(ft))DO
 BEGIN Inc(i); EnterStr(ft); strgrT[i]:=sedz;
 END;
CloseFile(ft);
ExtractFN(fn,s); AssignFile(fo,s+'.pos'); ReWrite(fo);

MakeForm(0);
nf:=i; WITH LB1rec DO
 BEGIN nitems:=nf; ar[1]:=IntToStr(nf)+' files';
 FOR i:=1 TO nf DO ar[i+1]:=strgrT[i];
 END;
MakeListBox(40,40,220,300); Form2.ShowModal;
numsp:=1; FOR iloop:=1 TO nf DO WITH spec[numsp] DO
 BEGIN smosp:=Round(har[3]); GetDir(0,s);
 sfn:=s+'\'+strgrT[iloop];
 ExtractFN(sfn,s); j:=Length(s)-3; s[j]:='e';
 AssignFile(fd,s+'.dat'); ReWrite(fd); s[j]:='g'; s[j+1]:='a';
 AssignFile(fg,s+'.dat'); ReWrite(fg);
 a1:=1; a2:=1000; spvar:=0; InputSpectrumData(1);
 a11:=a1; a22:=a2; dback:=5;
 ic1:=a11; ic2:=a22; cadl:=ic2-ic1+1;
 spin:=true; effn:=false; absn:=false; tofang:=2; npeak:=1;
 WITH gfit DO
  BEGIN npar:=16; mpoint:=Round(a22-a11+1);
  FormCB; FormParameters; WITH cb DO
   BEGIN gnit:=15; step:=0.98; damp:=0.02; delta:=1; beta:=0.1;
   END;
  {Exact parameters}
  par[1].p:=30; par[1].pl:=1; par[1].pu:=1000000000;
  FOR i:=3 TO 6 DO
   BEGIN par[i].p:=0; par[i].pl:=0; par[i].pu:=0;
   END;
  par[7].p:=30000; par[7].pl:=10; par[7].pu:=1000000000;
  par[8].p:=har[1]; par[8].pl:=har[1]-5; par[8].pu:=har[1]+5;
  par[9].p:=har[2]; par[9].pl:=1; par[9].pu:=9;
  FOR i:=10 TO 16 DO
   BEGIN par[i].p:=0; par[i].pl:=0; par[i].pu:=0;
   END;
  noprep[4]:=false; spec[numsp].dback:=1; tam[1]:=1;
  LeastSquaresFit(arpeak,regup);
  Writeln(fo,iloop:5,par[8].p:10:3,par[8].e:10:3,rb.chi2:10:2);
  END;
 FOR i:=1 TO 6 DO gfit.par[i].p:=0;
 FOR i:=ic1 TO ic2 DO
  BEGIN sarg:=numsp; xarg:=i; arpeak(yy,w,v,i-ic1+1,4);
  spec[2].y[i]:=v; spec[2].e[i]:=1;
  r:=spec[1].y[i]-v; spec[3].e[i]:=spec[1].e[i]; spec[3].y[i]:=r;
  Writeln(fg,i:5,v:10:3);
  Writeln(fd,i:5,r:10:3,spec[1].e[i]:10:3);
  END;
 spec[2].spin:=true; spec[3].spin:=true;
 spec[2].fismax1; spec[3].fismax1; nosavedU:=false;
 CloseFile(fg); CloseFile(fd);
 END;
SetNoFit(15,true); nofit[4]:=false; inipar[3]:=0; CloseFile(fo);
ShowMess('Finished');
END;
PROCEDURE ReduceModAssign;
VAR   i,j:INTEGER;
LABEL Lend;
BEGIN FOR i:=1 TO nupmod DO
 BEGIN FOR j:=1 TO npeak DO IF(tam[j]=i)THEN GOTO Lend;
 FOR j:=1 TO npeak DO Dec(tam[j]); FOR j:=i+1 TO 4 DO
  BEGIN dpos[j-1]:=dpos[j]; dwi0[j-1]:=dwi0[j]; dwi1[j-1]:=dwi1[j];
  END;
 Lend:;
 END;
END;
{---------------}
BEGIN nexp:=0;
END.
