UNIT vactiv2;

INTERFACE

USES Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,   CheckLst, vactiv3,
     vzlocom, vstdcons;

TYPE
  TForm2 = CLASS(TForm)
    StringGrid2: TStringGrid;
    StringGrid1: TStringGrid;
    {OK}Button1: TButton;
    {Cancel}Button2: TButton;
    {Help}Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    {Save}Button6: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ListBox1: TListBox;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Edit1: TEdit;
    Image1: TImage;
    Image2: TImage;
    ComboBox1: TComboBox;
    Memo1: TMemo;
    CheckListBox1: TCheckListBox;
    PROCEDURE Button1Click(Sender: TObject);
    PROCEDURE Button2Click(Sender: TObject);
    PROCEDURE Button3Click(Sender: TObject);
    PROCEDURE Button6Click(Sender: TObject);
    PROCEDURE FormCreate(Sender: TObject);
    PROCEDURE FormKeyPress(Sender: TObject; VAR Key: Char);
  PRIVATE
    { Private declarations }
  PUBLIC
    { Public declarations }
  END;
PROCEDURE MakeHeader(cl:LONGINT);
PROCEDURE ActivateForm2(ix,iw,ih:LONGINT);
PROCEDURE MakeFormV(x,y,w,h,bm:INTEGER);
PROCEDURE MaketheButtons(x,y,w:INTEGER);
PROCEDURE MakeHelp(m:INTEGER);
PROCEDURE MakeListBox(ix,it,iw,ih:LONGINT);
PROCEDURE PuttoTable(x,t,nf,n,mm,ndig:LONGINT);
PROCEDURE MakeRadioGroup(ng,m,x,y,w,h:LONGINT);
PROCEDURE MakeCheckListBox(ix,it,iw,ih:LONGINT);
PROCEDURE GetFilename(VAR fn:STRING; mo:INTEGER);
PROCEDURE DisplayInfo3(n:INTEGER);
PROCEDURE MakeCombo(x,y,w:LONGINT);
PROCEDURE MakeMemo(x,w:INTEGER);

VAR
  Form2: TForm2;

IMPLEMENTATION

{$R *.DFM}

PROCEDURE TForm2.FormCreate(Sender: TObject);
BEGIN KeyPreview:=true;
END;
PROCEDURE TForm2.FormKeyPress(Sender: TObject; VAR Key: Char);
BEGIN {IF(Key=#13)THEN Button1Click(Self);}
IF(Key=#27)THEN Button2Click(Self);
END;
PROCEDURE MaketheButtons(x,y,w:INTEGER);
BEGIN MaketheButton(Form2.Button1,x,y,w,20,'OK');
MaketheButton(Form2.Button2,x+w+2,y,w,20,'Cancel');
MaketheButton(Form2.Button3,x+2*w+4,y,w,20,'Help');
Form2.Button1.Default:=true;
END;
PROCEDURE MakeMemo(x,w:INTEGER);
BEGIN Make_Memo(Form2.Memo1,x,w);
END;
PROCEDURE DisplayInfo3(n:INTEGER);
VAR ii,i:INTEGER; jj,ll:LONGINT;
BEGIN ll:=20*n; jj:=0; FOR i:=1 TO n DO
 BEGIN ii:=Length(LB1rec.ar[i]); IF(ii>jj)THEN jj:=ii;
 END;
LB1rec.nitems:=n; jj:=MIN0(MAX0(8*ii,285),400); jj:=450;
ActivateForm2(100,jj,ll+80); Form2.Top:=Screen.Height-(ll+175);
MakeListBox(5,5,jj-15,ll);
MaketheButton(Form2.Button1,(jj DIV 2)-30,ll+15,60,20,'OK');
Form2.ShowModal;
END;
PROCEDURE ActivateForm2(ix,iw,ih:LONGINT);
BEGIN WITH Form2 DO
 BEGIN Close; Left:=exs({Form1.Top+}ix); Top:=exs({Form1.Top+}20);
 Width:=exs(iw); Height:=exs(ih); Caption:=''; Color:=clGreen;
 Label1.Visible:=false; Label2.Visible:=false; Label3.Visible:=false;
 Label4.Visible:=false; {Label5.Visible:=false; Label6.Visible:=false;
 Label7.Visible:=false; Label8.Visible:=false; Label9.Visible:=false;
 Label10.Visible:=false;}
 Button1.Visible:=false; Button2.Visible:=false; Button3.Visible:=false;
 Button4.Visible:=false; Button5.Visible:=false; Button6.Visible:=false;
 {Button7.Visible:=false;}
 Edit1.Visible:=false; {Edit2.Visible:=false; Edit3.Visible:=false;
 Edit4.Visible:=false;}
 RadioGroup1.Visible:=false; RadioGroup2.Visible:=false;
 ListBox1.Visible:=false;  ComboBox1.Visible:=false;
 Memo1.Visible:=false; Image1.Visible:=false; Image2.Visible:=false;
 StringGrid1.Visible:=false; StringGrid2.Visible:=false;
 CheckListBox1.Visible:=false;
 ModalRes:=1;
 END;
END;
PROCEDURE MakeFormV(x,y,w,h,bm:INTEGER);
VAR i:INTEGER;
BEGIN IF(bm=1)THEN ListBsav:=false; ActivateForm2(x,w,h);
{L0rec->}MakeHeader(0);
i:=(w DIV 2)-90; IF(bm=1)THEN i:=i-30; MaketheButtons(i,375,60);
IF(bm=1)THEN WITH Form2.Button6 DO
 BEGIN Left:=exs(i+180+5); Top:=exs(375); Width:=exs(60);
 Height:=exs(20); Visible:=true;
 END;
SaveHelp(blankH_n,blankH);
END;
PROCEDURE MakeHeader(cl:LONGINT);
VAR i:INTEGER;
BEGIN WITH Form2.Font DO
 BEGIN Color:=cl; Style:=[fsBold]; Pitch:=fpFixed; Size:=fntsize;
 s:='   '; Form2.Caption:=s+L0rec;
 END;
END;
PROCEDURE TForm2.Button1Click(Sender: TObject);
BEGIN Close; ModalRes:=1;
END;
PROCEDURE TForm2.Button2Click(Sender: TObject);
BEGIN Close; ModalRes:=0;
END;
PROCEDURE TForm2.Button3Click(Sender: TObject);
BEGIN Button1.Enabled:=false; Button2.Enabled:=false;
Button3.Enabled:=false; MakeHelp(0);
END;
PROCEDURE TForm2.Button6Click(Sender: TObject);
VAR i:INTEGER;
BEGIN IF(ListBsav OR(NOT debugV.activ))THEN Exit;
s:=Caption; Writeln(fout,s);
WITH ListBox1 DO FOR i:=0 TO Items.Count-1 DO
 Writeln(fout,Items[i]); ListBsav:=true;
END;
PROCEDURE PuttoTable(x,t,nf,n,mm,ndig:LONGINT);
BEGIN
MakeStringGrid(Form2.StringGrid1,Form2.StringGrid2,x,t,nf,n,mm,ndig);
END;
PROCEDURE MakeRadioGroup(ng,m,x,y,w,h:LONGINT);
BEGIN IF(ng=1)THEN BuildRG(Form2.RadioGroup1,m,x,y,w,h)
              ELSE BuildRG(Form2.RadioGroup2,m,x,y,w,h);
END;
PROCEDURE MakeHelp(m:INTEGER);
VAR i:INTEGER;
BEGIN ActivateForm3(0,590,450); WITH Form3 DO
 BEGIN FOR i:=1 TO MIN0(lhelp,100) DO Memo1.Lines.Add(helpa[i]);
 Button1.Default:=true;
 {IF(m=1)THEN WITH Form4.Label1 DO
  BEGIN Left:=exs(330); Top:=exs(395); Caption:='  To be continued  ';
  Visible:=true;
  END;}
 ShowModal;
 END;
WITH Form2 DO
 BEGIN Button1.Enabled:=true; Button2.Enabled:=true;
 Button3.Enabled:=true;
 END;
END;
PROCEDURE MakeListBox(ix,it,iw,ih:LONGINT);
BEGIN Make_ListBox(Form2.ListBox1,ix,it,iw,ih);
END;
PROCEDURE MakeCheckListBox(ix,it,iw,ih:LONGINT);
BEGIN Make_CheckListBox(Form2.CheckListBox1,ix,it,iw,ih);
END;
PROCEDURE MakeCombo(x,y,w:LONGINT);
BEGIN MakeComboBox(Form2.ComboBox1,x,y,w);
END;
PROCEDURE GetFilename(VAR fn:STRING; mo:INTEGER);
{mo=0 - file name for reading
    1 - file name for writing
    2 - get a string }
VAR   s:STRING; i:INTEGER;
LABEL L1;
BEGIN s:=fn; IF(mo>=1)THEN GOTO L1;     {Read}
fn:=ExtractFileName(s); i:=Pos(s,fn); IF(i<>0)THEN Delete(s,i,100);
ModalRes:=1; WITH Form2.OpenDialog1 DO
 BEGIN Title:=L0rec; FileName:=fn; InitialDir:=s;
 Options:=Options-[ofAllowMultiSelect];
 IF(Execute)THEN s:=FileName
            ELSE
  BEGIN ModalRes:=0; Exit;
  END;
 Compress(s);
 IF(NOT FileExists(s))THEN
  BEGIN ShowMess('No file '+s); ModalRes:=0;
  END                 ELSE fn:=s;
 END;
Exit;
L1: MakeFormV(250,20,330,430,0); {Write}
OuttoLabel(Form2.Label1,5,30,clMaroon,clWhite,L1rec);
MakeEdit(Form2.Edit1,30,50,260,fn);
Form2.ShowModal; IF(ModalRes=0)THEN Exit; fn:=Form2.Edit1.Text;
IF(mo=2)THEN Exit; {String}
Compress(fn); ExtractFN(fn,sedz); IF(Length(sedz)=0)THEN
 BEGIN ShowMess('Empty string'); ModalRes:=0;
 END;
IF((mo=1)AND(FileExists(fn)))THEN
 BEGIN s:='File '+fn+' already exists. Overwrite?';
 i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN ModalRes:=0;
 END;
END;


END.
