UNIT vdomus1;

INTERFACE

USES Windows,  Messages, SysUtils, Classes,  Graphics, Controls, Forms,
     Dialogs,  Menus,    ExtCtrls, ComCtrls, StdCtrls, vzlocom,
     vdomus0,  vdomfl,   vdoman,   vdomus2,  vdomhlp,  vstdcons,
     vpeaksr,  vpmodel;

TYPE
  TForm1 = CLASS(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;       {File}
     ReadtheSpectrum1: TMenuItem;
     ReadaLargeSpectrum1: TMenuItem;
     ReadtheEffectiveSpectrum1: TMenuItem;
     SimulatetheSpectrum1: TMenuItem;
     N2: TMenuItem;
     InputtheInifile1: TMenuItem;
     SavetheInputdata1: TMenuItem;
     SavetheResults1: TMenuItem;
     N1: TMenuItem;
     Exit1: TMenuItem;
    Settings1: TMenuItem;   {Settings}
     Setthebounds1: TMenuItem;
     Setthescale1: TMenuItem;
     SettheTOFData1: TMenuItem;
     FormandFontSizes1: TMenuItem;
    Graph1: TMenuItem;
     GraphtheSpectrum1: TMenuItem;
     GraphtheConvolutions1: TMenuItem;
    Mark1: TMenuItem;  {Mark}
     SetofPoints1: TMenuItem;
    Calculate1: TMenuItem;  {Operation}
     NormalizebyEffSpectrum1: TMenuItem;
     TransformtoReversedSpace1: TMenuItem;
     SmooththeSpectrum1: TMenuItem;
     FindthePeaks1: TMenuItem;
     AssigntheHKLs1: TMenuItem;
    Output1: TMenuItem; {Info}
     abouttheSpectrum1: TMenuItem;
     aboutthePeaks1: TMenuItem;
    Help1: TMenuItem;    {Help}
     General1: TMenuItem;
     GettingStarted1: TMenuItem;
     GraphOperations1: TMenuItem;
     MenuMeanings1: TMenuItem;

    OpenDialog1: TOpenDialog;
    Image1: TImage; {Main}
    Image2: TImage; {Above}
    Image3: TImage; {Sidelong}
    ProgressBar1: TProgressBar;
    Edit1: TEdit; {X}
    Edit2: TEdit; {Y}
    Edit3: TEdit; {N sect}
    Edit4: TEdit; {t1}
    Edit5: TEdit; {t2}
    Button1:TButton; Button2:TButton; Button3:TButton; Button4:TButton;
    Button5:TButton; Button6:TButton; Button7:TButton; Button8:TButton;
    Button9:TButton; Button10:TButton;
    Label1: TLabel; Label2: TLabel;
    PROCEDURE Button1Click(Sender: TObject);
    PROCEDURE Button2Click(Sender: TObject);
    PROCEDURE Button3Click(Sender: TObject);
    PROCEDURE Button4Click(Sender: TObject);
    PROCEDURE Button5Click(Sender: TObject);
    PROCEDURE Button6Click(Sender: TObject);
    PROCEDURE ReadtheSpectrum1Click(Sender: TObject);
    PROCEDURE ReadtheEffectiveSpectrum1Click(Sender: TObject);
    PROCEDURE SimulatetheSpectrum1Click(Sender: TObject);
    PROCEDURE SavetheInputdata1Click(Sender: TObject);
    PROCEDURE SavetheResults1Click(Sender: TObject);
    PROCEDURE Exit1Click(Sender: TObject);
    PROCEDURE Setthebounds1Click(Sender: TObject);
    PROCEDURE GraphtheSpectrum1Click(Sender: TObject);
    PROCEDURE GraphtheConvolutions1Click(Sender: TObject);
    PROCEDURE Setthescale1Click(Sender: TObject);
    PROCEDURE NormalizebyEffSpectrum1Click(Sender: TObject);
    PROCEDURE SettheTOFData1Click(Sender: TObject);
    PROCEDURE TransformtoReversedSpace1Click(Sender: TObject);
    PROCEDURE SmooththeSpectrum1Click(Sender: TObject);
    PROCEDURE FindthePeaks1Click(Sender: TObject);
    PROCEDURE AssigntheHKLs1Click(Sender: TObject);
    PROCEDURE SetofPoints1Click(Sender: TObject);
    PROCEDURE Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    PROCEDURE abouttheSpectrum1Click(Sender: TObject);
    PROCEDURE aboutthePeaks1Click(Sender: TObject);
    PROCEDURE Button7Click(Sender: TObject);
    PROCEDURE General1Click(Sender: TObject);
    PROCEDURE GettingStarted1Click(Sender: TObject);
    PROCEDURE GraphOperations1Click(Sender: TObject);
    PROCEDURE MenuMeanings1Click(Sender: TObject);
    PROCEDURE InputtheInifile1Click(Sender: TObject);
    PROCEDURE FormandFontSizes1Click(Sender: TObject);
    PROCEDURE ReadaLargeSpectrum1Click(Sender: TObject);
    PROCEDURE FormClose(Sender: TObject; var Action: TCloseAction);
  PRIVATE { Private declarations }
  PUBLIC  { Public declarations }
  END;
PROCEDURE BrushArea(x1,y1,x2,y2,c:LONGINT; s:TBrushStyle);
PROCEDURE DotArea(x1,y1,y2,kn:INTEGER);
PROCEDURE MakeAbscissae(x1,y1,kn:INTEGER);
PROCEDURE GraphNSection;
PROCEDURE HideComponents;
PROCEDURE MakeBitmaps;
PROCEDURE ArrangeButtons(S: TForm1);
PROCEDURE ExecuteChange(mo:INTEGER);
PROCEDURE EnableM(m:BOOLEAN);
PROCEDURE LabelOut(CONST s1,s2:STRING);
PROCEDURE RemovePeaks;

VAR
  Form1: TForm1;

IMPLEMENTATION
{$R *.DFM}
PROCEDURE TForm1.ReadaLargeSpectrum1Click(Sender: TObject);
VAR  i,j,k,ii,jj,kk,ll:INTEGER; fb:FILE OF LONGWORD;
     bufl:ARRAY[1..1024] OF LONGWORD;
BEGIN HideComponents;
OpenDialog1.Title:='   Select the file'; OpenDialog1.FileName:=sfn;
IF(OpenDialog1.Execute)THEN sfn:=OpenDialog1.FileName ELSE Exit;
IF(NOT FileExists(sfn))THEN
 BEGIN ShowMess('No file '+sfn); Exit;
 END                   ELSE ;
L0rec:='Input '+sfn; MakeFormV(250,20,330,430,0);
s:='Set bounds'; OuttoLabel(Form2.Label5,5,10,clMaroon,clWhite,s);
strgrW[0]:=120; strgrW[1]:=100;
strgrT[1]:='X_min='; strgrNn[1,1]:=xl1;
strgrT[2]:='X_max='; strgrNn[2,1]:=xl2;
strgrT[3]:='D_X=';   strgrNn[3,1]:=dxl;
strgrT[4]:='Y_min='; strgrNn[4,1]:=yl1;
strgrT[5]:='Y_max='; strgrNn[5,1]:=yl2;
strgrT[6]:='D_Y=';   strgrNn[6,1]:=dyl;
strgrT[7]:='Max ordinate=';  strgrNn[7,1]:=olmax;
PuttoTable(20,40,7,7,1,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 END;
FOR i:=1 TO 7 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]); {c,r}
xl1:=Round(har[1]); xl2:=Round(har[2]); dxl:=Round(har[3]);
yl1:=Round(har[4]); yl2:=Round(har[5]); dyl:=Round(har[6]);
olmax:=Round(har[7]);
AssignFile(fb,sfn); Reset(fb);
FOR i:=1 TO 1024 DO FOR j:=1 TO 32 DO FOR k:=1 TO 8 DO ssp[i,j,k]:=0;
FOR k:=1 TO 64 DO FOR j:=1 TO 128 DO
  IF((infun(j,xl1,xl2))AND(infun(k,yl1,yl2)))THEN
 BEGIN jj:=MIN0(32,(j-1)DIV dxl+1); kk:=MIN0(8,(k-1)DIV dyl+1);
 BlockRead(fb,bufl,1024,ll);
 FOR ii:=1 TO 1024 DO ssp[ii,jj,kk]:=ssp[ii,jj,kk]+AMAX0(0,bufl[ii]);
 END;
spx:=0; spn:=0; FOR i:=1 TO 1024 DO
 FOR j:=1 TO 32 DO FOR k:=1 TO 8 DO
  BEGIN ssp[i,j,k]:=Round(ssp[i,j,k]/Float(olmax));
  sp[i,j,k]:=Round(ssp[i,j,k]);
  spx:=AMAX1(spx,ssp[i,j,k]); spn:=AMIN1(spn,ssp[i,j,k]);
  END;
CloseFile(fb); {fismax3(0);} snor:=spx;
msinf:='Spectrum '+ExtractFileName(sfn)+' input';
IF(spx=0)THEN
  BEGIN msinf:='++++ Error, the spectrum is zero-valued'; Exit;
  END    ELSE
   BEGIN Convolute; {SetTheMaxima;}
   npk:=0; noefsc:=true; norevers:=true; nosaved:=false;
   END;
LabelOut(msinf,'');
END;
PROCEDURE RemovePeaks;
BEGIN
END;
PROCEDURE BrushArea(x1,y1,x2,y2,c:LONGINT; s:TBrushStyle);
{Clear an area}
BEGIN WITH Bitmap.Canvas DO
 BEGIN Brush.Color:=c; Brush.Style:=s;
 FillRect(Rect(exs(x1),exs(y1),exs(x2),exs(y2)));
 END;
END;
PROCEDURE DotArea(x1,y1,y2,kn:INTEGER);
VAR i,k:INTEGER; li,lj:LONGINT;
BEGIN WITH Bitmap.Canvas DO
 BEGIN Pen.style:=psSolid; Pen.Color:=clBlue;
 Brush.Color:=clBlack; FOR i:=1 TO kn DO
  BEGIN li:=exs(x1+1+(i-1)*50); IF(li<exs(512))THEN
   BEGIN lj:=exs(y1+1); Moveto(li,lj); lj:=exs(y2); Lineto(li,lj);
   END;
  END;
 END;
END;
PROCEDURE MakeAbscissae(x1,y1,kn:INTEGER);
VAR i,k:INTEGER; li:LONGINT;
BEGIN WITH Bitmap.Canvas DO
 BEGIN Brush.Color:=clBlue; Font.Color:=clWhite; FOR i:=1 TO 12{kn} DO
  BEGIN li:=1+1+(i-1)*50; k:=1+(li-1-1)*2;
  IF((li>15)AND(li<=512))THEN TextOut(li-20,y1,' '+InttoStr(k)+' ');
  END;
 END
END;
PROCEDURE GraphNSection;
VAR n1,n2,i,n,ix1,iy1,ix2,iy2:INTEGER; lspx,locx,z,r,sx:REAL;
    li,lj:LONGINT;
BEGIN locx:=0; WITH Form1.Image1.Canvas DO
 BEGIN Brush.Color:=0; Brush.Style:=bsSolid;
 FillRect(Rect(0,307,520,350));
 END;
n1:=((i1-1) DIV 2)+1; n2:=((i2-1) DIV 2)+1; FOR i:=i1 TO i2 DO
 BEGIN nsecar[i]:=ssp[i,xgp,ygp]; locx:=AMAX1(locx,nsecar[i]);
 END;
lspx:=CompCurrMax(locx); IF(lspx<1)THEN lspx:=1;
WITH Form1.Image1.Canvas DO
 BEGIN FOR n:=n1 TO n2 DO
  BEGIN i:=(n-1)*2; z:=(nsecar[i]+nsecar[i+1])*0.5;
  CASE nscale OF
  2: z:=SQRT(ABS(z));
  3: z:=LN(ABS(z)+1);
  4: z:=AMIN1(z,lspx);
  ELSE END;
  li:=n; r:=z/lspx*40; r:=40-r; lj:=272+35+3+Round(r);
  Pen.Color:=clYellow;
  IF(n=n1)THEN
   BEGIN ix1:=n1; iy1:=350;
   END   ELSE
    BEGIN ix2:=li; iy2:=lj;
    MoveTo(ix1,iy1); LineTo(ix2,iy2); ix1:=ix2; iy1:=iy2;
    END;
  lj:=272+35+40+3; Pixels[li,lj+1]:=clRed;
  END;
 Brush.Color:=clRed; Font.Color:=clBlack; Font.Style:=[fsBold];
 ConvertStr(locx,10,0); s:=' N-Section;   Max= '+sedz+'    ( ';
 s:=s+IntToStr(Round(spx))+' )   '; TextOut(171,292,s);
 END;
WITH Form1 DO
 BEGIN Edit3.Text:=InttoStr(xgp); Edit4.Text:=InttoStr(ygp);
 Edit5.Text:=InttoStr((ygp-1)*32+xgp);
 END;
END;
PROCEDURE HideComponents;
BEGIN WITH Form1 DO
 BEGIN ProgressBar1.Visible:=false; Image1.Visible:=false;
 Image2.Visible:=false; Image3.Visible:=false;
 Edit1.Visible:=false; Edit2.Visible:=false; Edit3.Visible:=false;
 Edit4.Visible:=false; Edit5.Visible:=false;
 Button1.Visible:=false; Button2.Visible:=false;
 Button3.Visible:=false; Button4.Visible:=false;
 Button5.Visible:=false; Button6.Visible:=false;
 Button7.Visible:=false; Button8.Visible:=false;
 Button9.Visible:=false; Button10.Visible:=false;
 Label1.Visible:=false; Label2.Visible:=false;
 {Memo1.Visible:=false; Canvas.Brush.Color:=clbtnFace;}
 END;
Form2.Visible:=false;
END;
PROCEDURE TForm1.Button1Click(Sender: TObject);
BEGIN ModalRes:=0; click1:=true;   {OK}
END;
PROCEDURE TForm1.Button2Click(Sender: TObject);
VAR r:REAL; i:INTEGER;
BEGIN IF(grst=4)THEN IF(npk>0)THEN {Cancel}
  BEGIN Dec(npk); LabelOut('Number of points = '+IntToStr(npk),'');
  END;
END;
PROCEDURE TForm1.Button3Click(Sender: TObject);
VAR i,n1,n2:INTEGER; s:STRING; {Set Section}
BEGIN s:=Edit5.Text; FCompress(s);
IF(s='')THEN i:=j1 ELSE i:=StrToInt(s);
ygp:=(i-1)DIV 32+1; xgp:=i-(ygp-1)*32;
IF((infun(xgp,j1,j2)AND(infun(ygp,k1,k2))))THEN GraphNSection
                                           ELSE
 BEGIN ShowMess('Error, invalid section '+IntToStr(i)); Exit;
 END;
Edit3.Text:=InttoStr(xgp); Edit4.Text:=InttoStr(ygp);
END;
PROCEDURE TForm1.Button4Click(Sender: TObject);
BEGIN ExecuteChange(1); {Section up}
END;
PROCEDURE TForm1.Button5Click(Sender: TObject);
BEGIN ExecuteChange(2); {Section down}
END;
PROCEDURE TForm1.Button6Click(Sender: TObject);
VAR t1,t2,n1,n2:INTEGER; s:STRING; {Set N1,N2}
BEGIN s:=Edit1.Text; FCompress(s);
IF(s='')THEN t1:=i1 ELSE t1:=StrToInt(s);
s:=Edit2.Text; FCompress(s); IF(s='')THEN t2:=i2 ELSE t2:=StrToInt(s);
IF(NOT((infun(t1,i1,i2))AND(infun(t2,i1,i2)))OR(t2<t1))THEN
 BEGIN ShowMess('Error, invalid spectrum interval'); Exit;
 END;
i1:=t1; i2:=t2; GraphNSection;
END;
PROCEDURE TForm1.Button7Click(Sender: TObject);
VAR t1,t2,n1,n2:INTEGER; s:STRING; {Set x,y}
BEGIN s:=Edit3.Text; FCompress(s);
IF(s='')THEN t1:=j1 ELSE t1:=StrToInt(s);
s:=Edit4.Text; FCompress(s); IF(s='')THEN t2:=k1 ELSE t2:=StrToInt(s);
IF(NOT((infun(t1,j1,j2))AND(infun(t2,k1,k2))))THEN
 BEGIN ShowMess('Error, invalid spectrum interval'); Exit;
 END;
xgp:=t1; ygp:=t2; GraphNSection;
END;
PROCEDURE TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
VAR i,j,k,l,jj:INTEGER;
BEGIN
CASE grst OF
1: BEGIN i:=2*x; l:=y; jj:=l DIV 34; l:=l-jj*34; k:=8-jj; j:=33-l;
{ShowMess(IntToStr(x)+' '+IntToStr(y)+' '+IntToStr(j)+' '+IntToStr(k));}
   IF(NOT((infun(x,1,512)AND(infun(y,1,272)))))THEN Exit;
   IF(NOT((infun(j,1,32)AND(infun(k,1,8)))))THEN Exit;
   jj:=Round(sp[i,j,k]); WITH Image3.Canvas DO
    BEGIN Font.Size:=10; Font.Pitch:=fpFixed; Brush.Color:=clGreen;
    FillRect(Rect(0,0,100,130));
    TextOut(5,10,'N= '+IntToStr(i));
    TextOut(5,30,'X= '+IntToStr(j));
    TextOut(5,50,'Y= '+IntToStr(k));
    TextOut(5,70,'V= '+IntToStr(jj));
    END;
   END;
4: BEGIN xgp:=x; ygp:=y; click1:=true;
   END;
ELSE END;
END;
PROCEDURE ExecuteChange(mo:INTEGER);
VAR x1,y1,n1,n2:INTEGER; s:STRING;
BEGIN s:=Form1.Edit3.Text; FCompress(s);
IF(s='')THEN xgp:=j1 ELSE xgp:=StrToInt(s);
s:=Form1.Edit4.Text; FCompress(s);
IF(s='')THEN ygp:=k1 ELSE ygp:=StrToInt(s);
IF(NOT((infun(xgp,j1,j2)AND(infun(ygp,k1,k2)))))THEN
 BEGIN ShowMess('Error, invalid section '+
  IntToStr(xgp)+' '+IntToStr(ygp)); Exit;
 END;
CASE mo OF
1: IF(xgp<j2)THEN Inc(xgp) ELSE
    BEGIN xgp:=j1; IF(ygp<k2)THEN Inc(ygp) ELSE ygp:=k1;
    END;
2: IF(xgp>j1)THEN Dec(xgp) ELSE
    BEGIN xgp:=j2; IF(ygp>k1)THEN Dec(ygp) ELSE ygp:=k2;
    END;
ELSE END;
GraphNSection;
END;
{***}                                                    {File}
PROCEDURE TForm1.ReadTheSpectrum1Click(Sender: TObject);
BEGIN HideComponents;
OpenDialog1.Title:='   Select the file'; OpenDialog1.FileName:=sfn;
IF(OpenDialog1.Execute)THEN sfn:=OpenDialog1.FileName ELSE Exit;
IF(NOT FileExists(sfn))THEN ShowMess('No file '+sfn)
                       ELSE
 BEGIN Read3Binary; IF(spx=0)THEN
  BEGIN ShowMess('++++ Error, the spectrum is zero-valued'); Exit;
  END                        ELSE WITH Canvas DO
   BEGIN ShowMess('The spectrum '+sfn+' read in');
   Convolute; SetTheMaxima;
   npk:=0; noefsc:=true; norevers:=true; nosaved:=false;
   END;
 END;
END;
PROCEDURE TForm1.ReadtheEffectiveSpectrum1Click(Sender: TObject);
BEGIN OpenDialog1.Title:='   Select the effective file'; HideComponents;
OpenDialog1.FileName:=esfn;
IF(OpenDialog1.Execute)THEN esfn:=OpenDialog1.FileName ELSE Exit;
IF(NOT FileExists(esfn))THEN ShowMess('No file '+esfn)
                        ELSE
 BEGIN ReadEffSpectrum; noefs:=false;
 IF(espx=0)THEN
  BEGIN ShowMess('++++ Error, the spectrum is zero-valued'); Exit;
  END      ELSE
   BEGIN L0rec:=''; MakeFormV(250,20,330,430,0);
   s:=esfn+' spectrum read in ';
   OuttoLabel(Form2.Label5,10,30,clMaroon,clWhite,s);
   WITH CB1rec DO
    BEGIN nitems:=1;
    ar[1]:=' Remove peaks ';
    END;
   MakeCheckListBox(20,100,250,40);
   WITH Form2 DO
    BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
    IF(CheckListBox1.Checked[0])THEN RemovePeaks;
    END;
   END;
 END;
END;
PROCEDURE TForm1.SimulatetheSpectrum1Click(Sender: TObject);
VAR i,j,k:INTEGER; x,y,z,f,ex:REAL;
BEGIN ex:=0; FOR i:=i1 TO i2 DO FOR j:=j1 TO j2 DO FOR k:=k1 TO k2 DO
 BEGIN x:=i-200; y:=j-23; z:=k-5; z:=SQR(x/6)+SQR(y/3)+SQR(z/2);
 f:=100*exp(-z);
 x:=i-700; y:=j-15; z:=k-3; z:=SQR(x/6)+SQR(y/3)+SQR(z/2);
 f:=f+100*exp(-z);
 x:=i-500; y:=j- 5; z:=k-2; z:=SQR(x/7)+SQR(y/3)+SQR(z/2);
 f:=f+100*exp(-z);
 x:=i-750; y:=j-18; z:=k-5; z:=SQR(x/7)+SQR(y/3)+SQR(z/2);
 f:=f+100*exp(-z);
 ssp[i,j,k]:=f; sp[i,j,k]:=Round(f); IF(f>ex)THEN ex:=f;
 END;
snor:=ex; nscale:=1; sfn:='Simulated';
ConvoluteTheSpectrum(csnor,0);
ConvoluteTheSpectrum(cxnor,1);
ConvoluteTheSpectrum(cynor,2);
SetTheMaxima;
END;
PROCEDURE TForm1.InputtheInifile1Click(Sender: TObject);
BEGIN IDataIn;
END;
PROCEDURE TForm1.SavetheInputdata1Click(Sender: TObject);
BEGIN IDataOut;
END;
PROCEDURE TForm1.SavetheResults1Click(Sender: TObject);
BEGIN SaveRes;
END;
PROCEDURE TForm1.Exit1Click(Sender: TObject);
VAR i:INTEGER;
BEGIN s:='Results not saved. Quit?'; IF(nosaved)THEN
 BEGIN i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0); IF(i=mrNo)THEN Exit;
 END;
peaksr.Free; FOR i:=0 TO 4 DO pmod[i].Free; spec.Free;
CloseFile(fout); EraseEmptyF(outfn);
Application.Terminate;
END;
PROCEDURE TForm1.FormClose(Sender: TObject; VAR Action: TCloseAction);
BEGIN Exit1Click(Self);
END;
{***}                                                   {Settings}
PROCEDURE TForm1.Setthebounds1Click(Sender: TObject);
BEGIN Setthebounds;
END;
PROCEDURE TForm1.Setthescale1Click(Sender: TObject);
BEGIN Setthescale; IF(grst=1)THEN GraphtheSpectrum1Click(Self);
IF(grst=2)THEN GraphTheConvolutions1Click(Self);
END;
PROCEDURE TForm1.SettheTOFData1Click(Sender: TObject);
BEGIN SettheTOFData;
END;
PROCEDURE TForm1.FormandFontSizes1Click(Sender: TObject);
BEGIN ToggletheFormSize; r:=scrsize; {ResizeF1(r,r); ResizeF2(r,r);}
HideComponents; IF(grst=2)THEN GraphTheConvolutions1Click(Self);
END;
{***}                                                   {Graph}
PROCEDURE GraphConvoXY(x1,y1,n1,n2:INTEGER);
VAR i,n:INTEGER; z,r:REAL; li,lj:LONGINT;
BEGIN cspx:=CompCurrMax(csnor); WITH Bitmap.Canvas DO
 BEGIN FOR n:=n1 TO n2 DO
  BEGIN i:=1+(n-1)*2; z:=(csp[i]+csp[i+1])*0.5;
  CASE nscale OF
  2: z:=SQRT(ABS(z));
  3: z:=LN(ABS(z)+1);
  4: z:=AMIN1(z,cspx);
  ELSE END;
  li:=n; r:=z/cspx*40; r:=40-r; lj:=y1+272+35+3+Round(r);
   BEGIN Pixels[li,lj]:=clYellow; Pixels[li,lj-1]:=clYellow;
   Pixels[li,lj+1]:=clYellow; lj:=y1+272+35+40+3;
   Pixels[li,lj+1]:=clRed;
   END;
  END;
 Brush.Color:=clRed; Font.Color:=clBlack; Font.Style:=[fsBold];
 ConvertStr(cspx,18,0); Compress(sedz);
 TextOut(171,y1+292,' Convolution in X,Y;   Max= '+sedz);
 END;
END;
PROCEDURE MakeBitmaps;
BEGIN Form1.Image1.Visible:=true; Form1.Image2.Visible:=true;
Form1.Image3.Visible:=true;
Bitmap:=TBitmap.Create; WITH Bitmap DO {Top}
 BEGIN Width:=620; Height:=40;
 END;
BrushArea(0,0,620,40,clMaroon,bsSolid);
Form1.Image2.Canvas.Draw(0,0,Bitmap); Bitmap.Free;
Bitmap:=TBitmap.Create; WITH Bitmap DO {sidelong}
 BEGIN Width:=99; Height:=380;
 END;
BrushArea(0,0,99,380,clGreen,bsSolid);
Form1.Image3.Canvas.Draw(0,0,Bitmap); Bitmap.Free;
Bitmap:=TBitmap.Create; WITH Bitmap DO {Main}
 BEGIN Width:=520; Height:=380;
 END;
END;
PROCEDURE TForm1.GraphtheSpectrum1Click(Sender: TObject);
VAR i,j,k,n1,n2,ii,kn,c:INTEGER; r,z:REAL; li,lj,lk:LONGINT;
 PROCEDURE MakeEd(S:TEdit; i,j,k:INTEGER);
 BEGIN WITH S DO
  BEGIN Left:=exs(i); Top:=exs(j); Width:=exs(50); Height:=exs(18);
  Text:=InttoStr(k); Visible:=true;
  END;
 END;
BEGIN HideComponents; {Mark1.Enabled:=true;}
WITH Form1 DO
 BEGIN MakeEd(Edit1,370,0,i1); MakeEd(Edit2,370,20,i2);
 MakeEd(Edit3,455,0,j1); MakeEd(Edit4,455,20,k1);
 MakeEd(Edit5,570,5,j1);
 END;
n1:=((i1-1) DIV 2)+1; n2:=((i2-1) DIV 2)+1;
MakeBitmaps; WITH ProgressBar1 DO
 BEGIN Visible:=true; Left:=0; Top:=exs(51); Width:=exs(100);
 END;
WITH Bitmap.Canvas DO {Main}
 BEGIN BrushArea(0,0,520,380,clBlack,bsSolid);
 spx:=AMAX1(CompCurrMax(snor),1); FOR k:=k1 TO k2 DO{Graph the spectrum}
  BEGIN r:=k-1; r:=r*100/8; ProgressBar1.Position:=Round(r);
  FOR j:=j1 TO j2 DO FOR i:=n1 TO n2 DO
   BEGIN ii:=1+(i-1)*2; z:=(sp[ii,j,k]+sp[ii+1,j,k])*0.5;
   CASE nscale OF
   2: z:=SQRT(ABS(z));
   3: z:=LN(ABS(z)+1);
   4: z:=AMIN1(z,spx);
   ELSE END;
   c:=Round(z*256/spx);
   li:=i; lj:=(33-j); lk:=(8-k)*34;
   Bitmap.Canvas.Pixels[exs(li),exs(lj+lk)]:=RGB(0,c,c);
   END;
  END;
 WITH Bitmap.Canvas DO {Horizontal lines}
  BEGIN FOR i:=0 TO 8 DO
   BEGIN lj:=i*34-1; Brush.Color:=ClRed;
   FillRect(Rect(0,exs(lj),exs(520),exs(lj+1)));
   END;
  Brush.Color:=clBlack;
  END;
 kn:=1024 DIV 100+2; DotArea(0,0,360,kn);
 BrushArea(0,271,520,306,clMaroon,bsSolid);
 MakeAbscissae(0,274,kn); xgp:=j1; ygp:=k1;
 WITH Image2.Canvas DO
  BEGIN Font.Color:=clWhite; Brush.Color:=clMaroon; Font.Size:=10;
  s:=ExtractFileName(sfn); TextOut(exs(130),1,' '+s+' ');
  Font.Color:=clLime; TextOut(1,1,' SPECTRUM FILE: ');
  TextOut(1,20,' Max: '); ConvertStr(spx,19,0); Compress(sedz);
  TextOut(exs(50),20,sedz);
  TextOut(exs(341),exs(5),'N1= '); TextOut(exs(341),exs(25),'N2= ');
  TextOut(exs(435),exs(5),'X= '); TextOut(exs(435),exs(25),'Y= ');
  TextOut(exs(515),exs(5),'N sect=');
  END;
 {Put the marks of the found peaks}
 IF(npk<>0)THEN FOR ii:=1 TO npk DO
  BEGIN li:=(Round(pkar[ii].x)-i1) DIV 2;
  lj:=33-Round(pkar[ii].y)+5; lk:=(8-Round(pkar[ii].z))*34;
  WITH Bitmap.Canvas DO
   BEGIN Pen.style:=psSolid; Pen.Color:=clFuchsia; Brush.Color:=clBlack;
   Moveto(exs(li),exs(lj+lk)); lj:=lj-10; Lineto(exs(li),exs(lj+lk));
   lj:=lj+5; li:=li-5; Moveto(exs(li),exs(lj+lk));
   li:=li+10; Lineto(exs(li),exs(lj+lk));
   END;
  END;
 END;
Form1.Image1.Canvas.Draw(0,0,Bitmap); GraphNSection;
ProgressBar1.Visible:=false; ncl:=-1; Bitmap.Free; grst:=1;
ArrangeButtons(Self);
END;
PROCEDURE TForm1.GraphTheConvolutions1Click(Sender: TObject);
VAR i,j,k,n,n1,n2,ii,kn:INTEGER; x1,y1,c:INTEGER; r,z:REAL;
    l1,l2,li,lj,lc:LONGINT;
BEGIN HideComponents;
n1:=((i1-1) DIV 2)+1; n2:=((i2-1) DIV 2)+1;
x1:=1+(i1 DIV 2); y1:=39+j1;
MakeBitmaps; WITH ProgressBar1 DO
 BEGIN Visible:=true; Left:=0; Top:=exs(41); Width:=exs(100);
 END;
WITH Bitmap.Canvas DO
 BEGIN {Convolution in Y}
 BrushArea(0,0,520,380,0,bsSolid);
 cxnx:=AMAX1(CompCurrMax(cynor),1);
 FOR j:=j1 TO j2 DO FOR n:=n1 TO n2 DO
  BEGIN i:=1+(n-1)*2; z:=(snx[i][j]+snx[i+1][j])*0.5;
  CASE nscale OF
  2: z:=SQRT(ABS(z));
  3: z:=LN(ABS(z)+1);
  4: z:=AMIN1(z,cxnx);
  ELSE END;
  c:=Round(z*256/cxnx);
  r:=n; li:=Round(r); lj:=y1+(33-j)*4; lc:=RGB(0,c,c);
  Pixels[li,lj]:=lc; Pixels[li,lj+1]:=lc;
  Pixels[li,lj-1]:=lc;
  Pixels[li,lj-2]:=lc;
  END;
 ProgressBar1.Position:=50;
 {Convolution in X}
 cxny:=AMAX1(CompCurrMax(cxnor),1);
 FOR k:=k1 TO k2 DO FOR n:=n1 TO n2 DO
  BEGIN i:=1+(n-1)*2; z:=(sny[i][k]+sny[i+1][k])*0.5;
  CASE nscale OF
  2: z:=SQRT(ABS(z));
  3: z:=LN(ABS(z)+1);
  4: z:=AMIN1(z,cxny);
  ELSE END;
  c:=Round(z*256/cxny); lc:=RGB(0,c,c);
  r:=n; li:=Round(r); lj:=y1+170+(9-k)*8;
  FOR ii:=-3 TO 4 DO Pixels[li,lj+ii]:=lc;
  END;
 kn:=12; DotArea(x1,y1,y1+370,kn);
 BrushArea(0,20,520,39,clBlue,bsSolid);
 BrushArea(0,y1+130,520,y1+170,clBlue,bsSolid);
 BrushArea(0,y1+235,520,y1+286,clBlue,bsSolid);
 Brush.Color:=clRed; Font.Color:=clBlack; Font.Style:=[fsBold];
 ConvertStr(cxny,17,0); Compress(sedz);
 TextOut(171,23,' Convolution in Y    Max='+sedz);
 Brush.Color:=clRed; Font.Color:=clBlack; Font.Style:=[fsBold];
 ConvertStr(cxnx,17,0); Compress(sedz);
 TextOut(171,y1+153,' Convolution in X   Max='+sedz);
 MakeAbscissae(x1,y1+132,kn); MakeAbscissae(x1,y1+240,kn);
 GraphConvoXY(x1,y1-20,n1,n2);
 ProgressBar1.Position:=75;
 {Put the marks of the found peaks}
 IF(npk<>0)THEN FOR ii:=1 TO npk DO
  BEGIN li:=x1+(Round(pkar[ii].x)-i1) DIV 2;
  lj:=y1+(33-Round(pkar[ii].y)+j1)*4+5;
  Pen.style:=psSolid; Pen.Color:=clFuchsia; Brush.Color:=clBlack;
  Moveto(li,lj); lj:=lj-10; Lineto(li,lj);
  lj:=lj+5; li:=li-5; Moveto(li,lj); li:=li+10; Lineto(li,lj);
  END;
 END;
Form1.Image1.Canvas.Draw(0,0,Bitmap);
ProgressBar1.Visible:=false; ncl:=-1; Bitmap.Free; grst:=2;
END;
{***}                                                        {Mark}
PROCEDURE TForm1.SetofPoints1Click(Sender: TObject);
VAR i,j,k,l,ii,jj,kk,ix,jx,kx:INTEGER; butd:STRING;
    a,d,v0,dx,dy,dz,wx0,wy0,wz0,w1,w2,w3,r:REAL;
 PROCEDURE ShowN;
 BEGIN LabelOut('Number of points = '+IntToStr(npk),'');
 END;
LABEL Lend;
BEGIN IF(grst<>1)THEN
 BEGIN ShowMess('No spectrum graph on the screen'); Exit;
 END;
EnableM(false); ModalRes:=1; butd:=butar; butar:='1100000000';
ArrangeButtons(Form1); WITH Form1.Canvas DO
 BEGIN Font.Color:=clLime; Brush.Color:=clMaroon;
 Font.Style:=[fsBold]; Font.Size:=10; IF(npk>0)THEN
  BEGIN i:=MessageDlg('Reset the counter?',MtWarning,[mbYes,mbNo],0);
  IF(i=mrYes)THEN npk:=0;
  END;
 END;
LabelOut('Click on the peak (to quit - on OK)','');
grst:=4; WHILE(ModalRes<>0)DO WITH Form1.Image3.Canvas DO
 BEGIN Wait(click1); IF(ModalRes=0)THEN GOTO Lend;
 i:=2*xgp; l:=ygp; jj:=l DIV 34; l:=l-jj*34; k:=8-jj; j:=33-l;
 IF(NOT((infun(xgp,1,512)AND(infun(ygp,21,292)))))THEN CONTINUE;
 IF(NOT((infun(j,1,32)AND(infun(k,1,8)))))THEN CONTINUE;
 r:=0; ix:=i; jx:=j; kx:=k; v0:=sp[i,j,k];;
 Inc(npk); Font.Size:=10; Font.Pitch:=fpFixed;
 Brush.Color:=clGreen;
 FOR kk:=k-1 TO k+1 DO FOR jj:=j-2 TO j+2 DO FOR ii:=i-4 TO i+4 DO
  IF(sp[ii,jj,kk]>r)THEN
   BEGIN r:=sp[ii,jj,kk]; ix:=ii; jx:=jj; kx:=kk;
   END;
 {ShowMessage(IntToStr(ix)+'   '+IntToStr(jx)+'   '+IntToStr(kx));}
 pkar[npk].x:=ix; pkar[npk].y:=jx; pkar[npk].z:=kx;
 DetermineWidths(ix,jx,kx,wx0,wy0,wz0);
 pkar[npk].wx:=wx0; pkar[npk].wy:=wy0; pkar[npk].wz:=wz0;
 v0:=0; w1:=(wxxl+wxxu)*0.5; w2:=(wyyl+wyyu)*0.5; w3:=(wzzl+wzzu)*0.5;
 FOR kk:=k1 TO k2 DO FOR jj:=j1 TO j2 DO FOR ii:=i1 TO i2 DO
  BEGIN dx:=(ii-ix)/w1; dy:=(jj-j)/w2; dz:=(kk-k)/w3;
  r:=SQR(dx)+SQR(dy)+SQR(dz); IF(r < 3)THEN v0:=v0+sp[ii,jj,kk];
  END;
 pkar[npk].V:=v0; FillRect(Rect(0,0,100,130));
 TextOut(15,0,'Peak='+IntToStr(npk));
 r:=ix; ConvertStr(r,5,0); TextOut(5,14,'N='+sedz);
 r:=jx; ConvertStr(r,5,0); TextOut(5,28,'X='+sedz);
 r:=kx; ConvertStr(r,5,0); TextOut(5,42,'Y='+sedz);
 r:=v0;  ConvertStr(r,6,0); TextOut(5,56,'V='+sedz);
 r:=wx; ConvertStr(r,6,1); TextOut(5,70,'Wx='+sedz);
 r:=wy; ConvertStr(r,6,1); TextOut(5,84,'Wy='+sedz);
 r:=wz; ConvertStr(r,6,1); TextOut(5,98,'Wz='+sedz);
 WITH pkar[npk] DO ComputeD(x,y,z,a,r,d);
 ConvertStr(d,8,4); TextOut(5,112,'d='+sedz+'  ');

 s:=IntToStr((kx-1)*32+jx); Form1.Edit5.Text:=s; FCompress(s);
 IF(s='')THEN i:=j1 ELSE i:=StrToInt(s);
 ygp:=(i-1)DIV 32+1; xgp:=i-(ygp-1)*32;
 Form1.Edit3.Text:=InttoStr(xgp); Form1.Edit4.Text:=InttoStr(ygp);
 IF((infun(xgp,j1,j2)AND(infun(ygp,k1,k2))))THEN GraphNSection;
 ShowN;
 END;
Lend: grst:=1; EnableM(true); butar:=butd; ArrangeButtons(Form1);
LabelOut('',''); IF(npk<>0)THEN nosaved:=true;
END;
{***}                                                        {Operation}
PROCEDURE TForm1.NormalizebyEffSpectrum1Click(Sender: TObject);
VAR i,j,k:INTEGER; efn:REAL;
BEGIN IF(NOT noefsc)THEN
 BEGIN ShowMess(
  'The correction for the effective spectrum already done'); Exit;
 END;
IF(noefs)THEN
 BEGIN ShowMess('No effective spectrum available'); Exit;
 END;
FOR j:=j1 TO j2 DO FOR i:=i1 TO i2 DO FOR k:=k1 TO k2 DO
 BEGIN efn:=esp[i,j,k]; sp[i,j,k]:=Round(sp[i,j,k]*efn/espx);
 END;
fismax3(0); Convolute; SettheMaxima; noefsc:=false;
ShowMess('The correction for the effective spectrum is done');
END;
PROCEDURE TForm1.TransformtoReversedSpace1Click(Sender: TObject);
BEGIN TransformtoReversedSpace;
END;
PROCEDURE TForm1.SmooththeSpectrum1Click(Sender: TObject);
BEGIN SmooththeSpectrum;
END;
PROCEDURE TForm1.FindthePeaks1Click(Sender: TObject);
BEGIN FindthePeaks(ProgressBar1);
END;
PROCEDURE TForm1.AssigntheHKLs1Click(Sender: TObject);
BEGIN AssigntheHKLs;
END;
{***}                                                      {Info}
PROCEDURE TForm1.abouttheSpectrum1Click(Sender: TObject);
BEGIN abouttheSpectrum;
END;
PROCEDURE TForm1.aboutthePeaks1Click(Sender: TObject);
BEGIN aboutthePeaks;
END;
{***}                                                       {Help}
PROCEDURE TForm1.General1Click(Sender: TObject);
BEGIN SaveHelp(GeneralH1_n,GeneralH1); MakeHelp(0);
END;
PROCEDURE TForm1.GettingStarted1Click(Sender: TObject);
BEGIN SaveHelp(GetStart_n,GetStart); MakeHelp(0);
END;
PROCEDURE TForm1.GraphOperations1Click(Sender: TObject);
BEGIN SaveHelp(OperGrph_n,OperGrph); MakeHelp(0);
END;
PROCEDURE TForm1.MenuMeanings1Click(Sender: TObject);
BEGIN SaveHelp(MenuComm_n,MenuComm); MakeHelp(0);
END;
{***}
PROCEDURE EnableM(m:BOOLEAN);
BEGIN WITH Form1 DO
 BEGIN File1.Enabled:=m; Settings1.Enabled:=m; Graph1.Enabled:=m;
 Mark1.Enabled:=m; Calculate1.Enabled:=m; Output1.Enabled:=m;
 Help1.Enabled:=m;
 END;
END;
PROCEDURE ArrangeButtons(S: TForm1);
VAR i:INTEGER;
 PROCEDURE ABut(b:TButton);
 BEGIN WITH b DO
  BEGIN Left:=exs(525); Top:=exs(145+i*25); Visible:=true;
  Width:=exs(90); Height:=exs(24);
  IF(butar[i]='1')THEN Enabled:=true ELSE Enabled:=false; Inc(i);
  END;
 END;
BEGIN i:=1; ABut(S.Button1); ABut(S.Button2); ABut(S.Button3);
ABut(S.Button4); ABut(S.Button5); ABut(S.Button6); ABut(S.Button7);
ABut(S.Button8); ABut(S.Button9); ABut(S.Button10);
END;
PROCEDURE LabelOut(CONST s1,s2:STRING);
BEGIN WITH Form1 DO
 BEGIN IF(s1='')THEN Label1.Visible:=false
                ELSE OuttoLabel(Label1,5,20,clBlue,clYellow,s1);
 IF(s2='')THEN Label2.Visible:=false
          ELSE OuttoLabel(Label2,300,20,clBlue,clYellow,s2);
 END;
END;




END.

{PROCEDURE ResizeF1(sc1,sc2:REAL);
BEGIN WITH Form1 DO
 BEGIN scrsize:=sc2; Left:=0; Top:=0; Width:=exs(630); Height:=exs(470);
 Caption:='  VISUAL MRIA +++ 2004,    by Zlokazov V.B.';
 Color:=clBtnFace; scrsize:=sc1; Font.Size:=fntsize;
 WITH Image1 DO
  BEGIN Left:=0; Top:=0; Width:=exs(wgraph); Height:=exs(y1graph-1);
  Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
  END;
 WITH Image2 DO
  BEGIN Left:=0; Top:=exs(y1graph);
  Width:=exs(wgraph-104); Height:=exs(323);
  Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
  END;
 WITH Image3 DO
  BEGIN Left:=exs(516); Top:=exs(y1graph);
  Width:=exs(104); Height:=exs(323);
  Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
  END;
 END;
END;
PROCEDURE ResizeF2(sc1,sc2:REAL);
BEGIN WITH Form2 DO
 BEGIN scrsize:=sc2; Left:=0; Top:=0; Width:=exs(320);
 Height:=exs(516); scrsize:=sc1; Font.Size:=fntsize;
 WITH Image1 DO
  BEGIN Left:=0; Top:=1; Width:=exs(310); Height:=exs(290);
  Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
  END;
 WITH Image2 DO
  BEGIN Left:=0; Top:=exs(80); Width:=exs(516); Height:=exs(300);
  Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
  END;
 END;
END;}

