UNIT vedz1;

INTERFACE

USES
  Windows,  Messages, SysUtils, Classes,  Graphics, Controls, Forms,
  Dialogs,  Menus,    StdCtrls, ExtCtrls, Grids,    DBGrids,  DB,
  ShellAPI, Clipbrd,  ComCtrls, DdeMan,   DBTables, DBCtrls,  math,
  varfun,   vzlocom,  vedz0,    vedz2,    vedz4,    vspectr,  vdata,
  vpmodel,  vpeaksr,  vstdcons, vedz3,    vgfit01;


CONST  bufle:INTEGER = 4096*8;
TYPE   DOM_DATA = RECORD y,dy,x,dx:REAL; END;
TYPE
  TForm1 = CLASS(TForm)
    MainMenu1: TMainMenu;
    {File} File1: TMenuItem;
       Read1: TMenuItem;
       Write1: TMenuItem;
       ReWrite1: TMenuItem;
       BackCopyToA1: TMenuItem;
       Dir1: TMenuItem;
       Quit1: TMenuItem;
    {Traff} Traff1: TMenuItem;
       Recode1: TMenuItem;
       MakefileforLATEX1: TMenuItem;
       Finance1: TMenuItem;
       Execute1: TMenuItem;
       Connect1: TMenuItem;
       MakeEDZfonts1: TMenuItem;
       ExcelToNorm1: TMenuItem;
       Transform1: TMenuItem;
       Edit2: TMenuItem;
    {DataBase}DataBase1: TMenuItem;
       Open1: TMenuItem;
       Add1: TMenuItem;
       Delete1: TMenuItem;
       UpDate1: TMenuItem;
       Close1: TMenuItem;
    {Pati}pati1: TMenuItem;
    {Test}Test1: TMenuItem;
       TestThis2: TMenuItem;
       TestExp1: TMenuItem;
       testGFit1: TMenuItem;
       DomanovTest1: TMenuItem;
       TestFourier1: TMenuItem;
       TestDeconvol1: TMenuItem;
       TestAnisotropy1: TMenuItem;
       TestMor1: TMenuItem;
    {Help}Help1: TMenuItem;
       Showeres1: TMenuItem;
    {dev}
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Image1: TImage;
    DdeClientConv1: TDdeClientConv;
    DdeClientItem1: TDdeClientItem;
    Query1: TQuery;
    DBGrid1: TDBGrid;
    DataSource1: TDataSource;
    ComboBox1: TComboBox;
    PROCEDURE Edit1KeyDown(Sender:TObject; VAR Key:WORD;
              Shift: TShiftState);
    PROCEDURE Recode1Click(Sender: TObject);
    PROCEDURE Quit1Click(Sender: TObject);
    PROCEDURE Finance1Click(Sender: TObject);
    PROCEDURE Execute1Click(Sender: TObject);
    PROCEDURE Connect1Click(Sender: TObject);
    PROCEDURE MakeEDZfonts1Click(Sender: TObject);
    PROCEDURE ReWrite1Click(Sender: TObject);
    PROCEDURE Open1Click(Sender: TObject);
    PROCEDURE Close1Click(Sender: TObject);
    PROCEDURE Add1Click(Sender: TObject);
    PROCEDURE Delete1Click(Sender: TObject);
    PROCEDURE Read1Click(Sender: TObject);
    PROCEDURE ExcelToNorm1Click(Sender: TObject);
    PROCEDURE Transform1Click(Sender: TObject);
    PROCEDURE BackCopyToA1Click(Sender: TObject);
    PROCEDURE Dir1Click(Sender: TObject);
    PROCEDURE Showeres1Click(Sender: TObject);
    PROCEDURE MakefileforLATEX1Click(Sender: TObject);
    PROCEDURE pati1Click(Sender: TObject);
    PROCEDURE DomanovTest1Click(Sender: TObject);
    PROCEDURE TestThis2Click(Sender: TObject);
    PROCEDURE TestFourier1Click(Sender: TObject);
    PROCEDURE testGFit1Click(Sender: TObject);
    PROCEDURE Edit2Click(Sender: TObject);
    PROCEDURE TestExp1Click(Sender: TObject);
    PROCEDURE TestDeconvol1Click(Sender: TObject);
    PROCEDURE TestAnisotropy1Click(Sender: TObject);
    PROCEDURE TestMor1Click(Sender: TObject);
  PRIVATE
    { Private declarations }
  PUBLIC
    { Public declarations }
  END;

PROCEDURE HideComponents;
PROCEDURE ExecuteSQLCommand(CONST Q:TQuery; CONST s:STRING);
PROCEDURE OpenAT(VAR fn1,fn2:STRING);

VAR Form1: TForm1;
    a,b,c,al,be,ga,v,li,la,li34,la34,pb:REAL;
    alias,dbname,s:STRING;
    comp,opname:STRING;
    optime:REAL;
    orch,perf:STRING;
    inb:ARRAY[0..101] OF BOUNDA; N,nc:INTEGER;
    iar:ARRAY[1..3] OF MARKREC;
    apk,w0,w1,w,back,z,x,r,ur,err,am,amx,amn:REAL;
    npmax,k1,k2:INTEGER; {initial and final number of found peaks}
    c0,wi0:REAL;
    varr:ARRAY[1..500] OF REAL;
VAR i,j:INTEGER;
    sp:TSpectrum;

IMPLEMENTATION
{$R *.DFM}
{***}
PROCEDURE Compare3Deriv;
VAR i:INTEGER; t,f1,f2,f3,d1,d2,h,h2,di3,di2,di1,de3,de2,de1,x:REAL;
 FUNCTION F(x:REAL):REAL;
 BEGIN F:=1+x*(1+x*(1+x*(1+x)));
 {powerRI(x,4)+powerRI(x,3)+powerRI(x,2)+x+1;}
 END;
BEGIN
h:=0.001; h2:=h*2; FOR i:=1 TO 100 DO
 BEGIN x:=i; de3:=24*x+6;
 f1:=F(x+h)-F(x-h);
 f2:=F(x+h2)-F(x-h2);
 f3:=F(x+h*3)-F(x-h*3);
 di3:=(f3-(f1+f2))/(6*powerRI(h,3)){6/h/h/h};
 Writeln(fout,i,de3:12:5,di3:12:5
 {,de2:13:5,di2:13:5,de1:14:5,di1:14:5});
 END;
END;
PROCEDURE ArithMod(VAR y,w,f:REAL; i,typ:INTEGER);
{The arithmetic procedure for least squares minimization;
    f  =  Am((x-P)/W) + Sm"((x-P)/W)
 is fitted by a Lorentzian (m(x)) Parameters: A,P,W,S
 computes function value + 1-st derivatives, Feb 3 2006}
VAR vv,vz,ff,fz,fzz,fzzz,wi,z,z21,z22,si,am,exc:REAL;
    ia,ip,iw,j,k:INTEGER;
BEGIN y:=varr[i]; {x:=i; y:=1000*EXP(-SQR((x-138)/40));}
w:=0; IF(y<>0)THEN w:=1/(ABS(y)+0.0001);
WITH testgfit DO
 BEGIN x:=i;wi:=par[3].p;z:=(x-par[2].p)/wi; am:=par[1].p; si:=par[4].p;
 {ff:=EXP(-z*z/2); fzz:=(z*z-1)*ff/SQR(wi); f:=am*ff+si*fzz;
 drv[1]:=ff; drv[2]:=-am*ff*z/wi+si*z*(3-SQR(z))/SQR(wi)*ff;
 drv[3]:=((1-SQR(z))/(wi*wi*wi)+(3*z-z*z*z)/SQR(SQR(wi)))*ff;
 drv[4]:=fzz; ff:=1/z21;  cc:=1; c0:=par[2].p;
 IF(ABS(z)<=cc)THEN exc:=1 ELSE exc:=EXP(-SQR((x-c0)/wi0)+cc*cc); }
 {exc:=EXP(-SQR(SQR((x-c0)/wi0)));exc:=1/(1+SQR((x-c0)/wi0));exc:=1;}
 {fz:=(-2*am*z+si*(24*SQR(z)+8*z)/SQR(1+SQR(z)))*exc;}
 {cc:=am*fz+si*fzzz;}
 {fz:=6*z*(2*SQR(z21)-z22)/powerRI(z21,5);}
 {fzzz:=24*z*(1-SQR(z))/powerRI(z21,4);}
 z21:=1+SQR(z); z22:=6*SQR(z)-2; fzz:=z22/powerRI(z21,3);
 fz:=-2*z/SQR(z21);
 ff:=1/z21; vv:=ff-0.5*fzz; f:=am*vv;
 vz:=-am*(2*z/powerRI(z21,2)-12*(z-z*z*z)/powerRI(z21,4));
 par[1].drv:=vv;
 par[2].drv:=-vz/wi;
 par[3].drv:=-vz*z/wi;
 par[4].drv:=0;
 {Writeln(fout,i:6,1000*ff:9:2,1000*fzz/SQR(wi):19:5);}
 END;
END;
PROCEDURE MakeDirInvExp;
VAR   i:INTEGER; w:REAL;
LABEL Loop;
BEGIN w:=0.05;
Loop: FOR i:=1 TO 100 DO
 BEGIN r:=i; onl[i]:=100*EXP(-SQR((r-50)/20)); Writeln(fout,i:5,r:12:4);
 END;
FOR i:=1 TO 100 DO
 BEGIN r:=1/Float(i); onl[i+100]:=100*EXP(-SQR((r-0.02)/w));
 Writeln(fout,i:5,r:12:5);
 END;
 MakeFormV(250,20,330,430,0);
 L1rec:='w= '; ConvertStr(w,12,8); E1rec:=sedz;
 MakeEdits(10,220,320,80,1);
 WITH LB1rec DO
  BEGIN nitems:=1;
  ar[1]:='dir+inv exp';
  END;
 GraphSpecAndModel(Form2.Image1,100,2,0); Form2.ShowModal;
 IF(ModalRes=0)THEN Exit; Zval(Form2.Edit1.Text,w); GOTO Loop;
END;
PROCEDURE TestModelFitting;
{Purpose: to test various width parameters fitting Version: Dec 24 2004}
VAR   n,mp,lnois:INTEGER; r,x,cmax,b,ass,chi:REAL; i,j:INTEGER;
LABEL Lend;
 PROCEDURE mparam(i,l:INTEGER; v,vl,vu:REAL);
 BEGIN WITH testgfit.par[i] DO
  BEGIN p:=v; pl:=vl; pu:=vu;  IF(l=0)THEN
   BEGIN pl:=v; pu:=v;
   END;
  END;
 END;
 PROCEDURE MakeData;
 VAR i:INTEGER; y,w,ff:REAL;
 BEGIN WITH testgfit DO
  BEGIN
  END;
 END;
{---------------------}
BEGIN
{mat3[1,1]:=1; mat3[1,2]:=2; mat3[1,3]:=1;
mat3[2,1]:=1; mat3[2,2]:=2; mat3[2,3]:=2;
mat3[3,1]:=1; mat3[3,2]:=1; mat3[3,3]:=1;
InvertMatrix3(ok,false,r);
FOR i:=1 TO 3 DO
 BEGIN FOR j:=1 TO 3 DO Write(fout,mat3[i,j]:7:2); Writeln(fout);
 END;
 Writeln(fout,'det=',r:9:3);
mat3[1,1]:=1; mat3[1,2]:=2; mat3[1,3]:=1;
mat3[2,1]:=2; mat3[2,2]:=2; mat3[2,3]:=2;
mat3[3,1]:=1; mat3[3,2]:=2; mat3[3,3]:=3;
InvertMatrix3(ok,true,r);
FOR i:=1 TO 3 DO
 BEGIN FOR j:=1 TO 3 DO Write(fout,mat3[i,j]:7:2); Writeln(fout);
 END;
 Writeln(fout,'det=',r:9:3);
InvertMatrix3(ok,false,r);
FOR i:=1 TO 3 DO
 BEGIN FOR j:=1 TO 3 DO Write(fout,mat3[i,j]:7:2); Writeln(fout);
 END;}
{MakeDirInvExp; Compare3Deriv; Exit;}
WITH testgfit DO
 BEGIN n:=3; mp:=276;  {Number of points}
 lnois:=0; {noise}
 {Writeln(fout,n:6,mp:6);} mpoint:=276; n:=npar;
 {***} L0rec:='Fit of Voigtian'; MakeFormV(250,20,330,430,0);
 strgrW[0]:=90; strgrW[1]:=70; strgrW[2]:=70; strgrW[3]:=70;
 strgrT[1]:='A';
 strgrNn[1,1]:=100; strgrNn[1,2]:=1000; strgrNn[1,3]:=100000;
 strgrT[2]:='P';
 strgrNn[2,1]:=100; strgrNn[2,2]:=138; strgrNn[2,3]:=160;
 strgrT[3]:='W';
 strgrNn[3,1]:=20; strgrNn[3,2]:=40; strgrNn[3,3]:=100;
 strgrT[4]:='S';
 strgrNn[4,1]:=-100000; strgrNn[4,2]:=0; strgrNn[4,3]:=100000;
 strgrT[5]:='Niter';
 strgrNn[5,1]:=cb.gnit;
 strgrT[6]:='step';
 strgrNn[6,1]:=cb.step;
 strgrT[7]:='damp';
 strgrNn[7,1]:=cb.damp;
 strgrT[8]:='sqr(2) or abs(1)';
 strgrNn[8,1]:=cb.liqu;
 PuttoTable(5,20,8,8,3,8);
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  FOR i:=1 TO 7 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
  WITH cb DO
   BEGIN gnit:=Round(har[5]); step:=har[6]; damp:=har[7];
   {liqu:=Round(har[8]);} ipr:=1;
   END;
  FOR i:=1 TO 4 DO par[i].pl:=har[i];
  FOR i:=1 TO 7 DO Zval(Form2.StringGrid1.Cells[1,i-1],har[i]);
  FOR i:=1 TO 4 DO par[i].p:=har[i];
  FOR i:=1 TO 7 DO Zval(Form2.StringGrid1.Cells[2,i-1],har[i]);
  FOR i:=1 TO 4 DO par[i].pu:=har[i];
  END;
 c0:=par[2].p; wi0:=par[3].p;
 {FOR i:=1 TO mp DO ArithMod(cmax,b,ass,i,j); GOTO Lend;}
 PrintParArray;
 FOR i:=1 TO npar DO pold[i]:=par[i].p;
 FOR i:=1 TO 276 DO
  BEGIN rannor(r,r); x:=voigta[i]; varr[i]:=AMAX1(0,x+SQRT(x)*r);
  END;
 LeastSquaresFit(ArithMod,TestRegul);
 prifch; {Fitting characteristics}
 chi:=0; FOR i:=1 TO n DO
  chi:=chi+ABS(pold[i]-par[i].p)/AMAX1(0.001,pold[i]);
 chi:=chi/n; Writeln(fout,'Par-diff=',chi:8:2);
 cmax:=0; {lsmprn(ArithMod,cmax);} {graph; if cmax=0, set automat.}
 primat; {Correlation coefficients}
 MakeFormV(250,20,330,430,0);
 cmax:=0; FOR i:=1 TO mp DO
  BEGIN ArithMod(b,b,ass,i,1);
  onl[i]:=varr[i]; onl[i+mp]:=ass;
  cmax:=AMAX1(cmax,ABS(onl[i]-onl[i+mp]){/AMAX1(ass,0.0001)});
  END;
 WITH LB1rec DO
  BEGIN nitems:=2;
  ConvertStr(rb.chi2{/Float(mp-4)},7,2);
  ar[1]:='True - magenta,    chi2/df= '+sedz;
  ConvertStr(cmax,7,2);
  ar[2]:='Fit.- aqua,  ABS dev(relat.) = '+sedz;
  END;
 GraphSpecAndModel(Form2.Image1,mp,2,0); Form2.ShowModal;
 END;
{results in FOUT}
Lend:;
END;

PROCEDURE TestAnisotropy;
VAR   i,ipro,n,mp:INTEGER;
LABEL Lbeg,Lend;
BEGIN ipro:=1; n:=4; mp:=276; testgfit:=TParameter.Create(n,n,mp);
WITH testgfit DO
 BEGIN FormCB; FormParameters;
  WITH cb DO
   BEGIN gnit:=30; eps:=0.01; ipr:=10; step:=0.75; damp:=0.033;
   {dbg.drv:=true;} {dbg.corr:=true;} liqu:=2; {iconv:=2;}
   END;
 END;
Lbeg: L0rec:=''; MakeFormV(250,20,330,430,0);
WITH CB1rec DO
 BEGIN nitems:=3; indx:=ipro;
 ar[1]:='Test anisotropic broadening';
 ar[2]:='Test using peak model with 2-deriv.';
 ar[3]:='Exit';
 END;
MakeRadioGroup(1,0,20,50,270,90);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN GOTO Lend;
 i:=RadioGroup1.ItemIndex; ipro:=i+1;
 END;
CASE i OF
0: TestAnisoBroad;
1: TestModelFitting;
2: GOTO Lend;
ELSE END;
GOTO Lbeg;
Lend: testgfit.Free;
END;
{***}
PROCEDURE TestDeconvolution;
VAR n1,n2,m,m2,i,j,n:INTEGER; q,sr,si,x,sg,sl,r,r1,r2:REAL;
    convar,tar,densar:ARRAY[1..101] OF REAL;
    ffr,ffi,ftr,fti,fspr,fspi,frfr,frfi:ARRAY[1..200] OF REAL;
BEGIN {***} L0rec:=''; MakeFormV(250,20,330,430,0);
m:=7; n:=3; m2:=m DIV 2;

sg:=1; FOR i:=1 TO 2*n+1 DO {resol.fun}
 BEGIN x:=i; r:=SQR((x-n-1)/sg)*0.5; densar[i]:=10*EXP(-r);
 arr[i]:=densar[i]; ari[i]:=0;
 END;
n1:=1; n2:=7;
sfft(2*n+1,1,n1,n2); {m:=n1*n2;} Writeln(fout,n1:5,n2:4);
FOR i:=1 TO m DO
 BEGIN frfr[i]:=orr[i]; frfi[i]:=ori[i];
 END;
{FOR i:=1 TO m DO
 BEGIN arr[i]:=orr[i]; ari[i]:=ori[i];
 END;
sfft(2*n+1,-1,n1,n2);}
FOR i:=1 TO 2*n+1 DO
 Writeln(fout,'Dar,Fr,Fi ',i:4,densar[i]:15:4,orr[i]:15:4,ori[i]:15:2);
{Exit;}

sl:=2; FOR i:=1 TO 8 DO  {true peak}
 BEGIN x:=i; r:=SQR((x-Float(m2))/sl)*0.5; tar[i]:=10*EXP(-r);
 arr[i]:=tar[i]; ari[i]:=0;
 END;
n1:=1; n2:=7;
sfft(m,1,n1,n2); {m:=n1*n2;}     Writeln(fout,n1:5,n2:4);
FOR i:=1 TO m DO
 BEGIN fspr[i]:=orr[i]; fspi[i]:=ori[i];
 END;
FOR i:=1 TO m DO
 Writeln(fout,'Tar,Fr,Fi   ',i:4,tar[i]:15:4,orr[i]:15:4,ori[i]:15:2);
{Exit;}

{Convolute}
FOR i:=1 TO m DO sa[i]:=tar[i];
FOR i:=1 TO 2*n+1 DO sb[i]:=densar[i];
ConvoluteFunc(m,2*n+1); FOR i:=1 TO m DO convar[i]:=sd[i];
FOR i:=1 TO m DO
 BEGIN arr[i]:=convar[i]; ari[i]:=0;
 END;
n1:=0; n2:=0;
sfft(m,1,n1,n2);  Writeln(fout,n1:5,n2:4);
FOR i:=1 TO m DO
 BEGIN ftr[i]:=orr[i]; fti[i]:=ori[i];
 END;
FOR i:=1 TO m DO
 Writeln(fout,'conv ',i:4,convar[i]:12:2,orr[i]:15:4,ori[i]:15:2);
FOR i:=1 TO m DO
 BEGIN onl[i]:=tar[i]; onl[i+m]:=convar[i];
 END;
WITH LB1rec DO
 BEGIN nitems:=2;
 ConvertStr(sg,7,2); ar[1]:='True - magenta,wi= '+sedz;
 ConvertStr(sl,7,2); ar[2]:='Conv.- aqua, wi = '+sedz;
 END;
GraphSpecAndModel(Form2.Image1,m,2,0); Form2.ShowModal;
{Exit;}
{Divide Fconv/Fresf}
FOR i:=1 TO m DO
 BEGIN q:=2*pi/m*Float(n+1);
 {ComplexMult(frfr[i],frfi[i],COS(q),SIN(q),frfr[i],frfi[i]);}
 {ComplexMult(ftr[i],fti[i],COS(q),SIN(q),ftr[i],fti[i]);}
 arr[i]:=r1; ari[i]:=r2;
 END;
FOR i:=1 TO m DO
 BEGIN ComplexMult(frfr[i],frfi[i],fspr[i],fspi[i],ffr[i],ffi[i]);
 Writeln(fout,frfr[i]:9:2,frfi[i]:9:2,fspr[i]:9:2,fspi[i]:9:2,
  ffr[i]:9:2,ffi[i]:9:2,ftr[i]:9:2,fti[i]:9:2);
 END;
Exit;


{Calculate the absenses}
sr:=0; si:=0;
FOR i:=1 TO n DO
 BEGIN q:=-2*pi/m;
 FOR j:=1 TO i DO sr:=sr+tar[j]*densar[j+n-1]*COS(q*(j-1+j-n));
 FOR j:=1 TO i DO si:=si+tar[j]*densar[j+n-1]*SIN(q*(j-1+j-n));
 k:=n; FOR j:=m-i TO m-1 DO
  BEGIN Inc(k); sr:=sr+tar[j]*densar[k]*COS(q*(j+k));
  END;
 k:=n; FOR j:=m-i TO m-1 DO
  BEGIN Inc(k); sr:=sr+tar[j]*densar[k]*COS(q*(j+k));
  END;
 END;
{FOR i:=1 TO m DO
 ComplexMult(frfr[i],frfi[i],ftr[i],fti[i],ftr[i],fti[i]);}
FOR i:=1 TO m DO
 BEGIN fspr[i]:=orr[i]; fspi[i]:=ori[i];
 {Writeln(fout,'cv Restcv abs ',i:4,
  fspr[i]:9:2,fspi[i]:9:2,frfr[i]:9:2,frfi[i]:9:2);}
 Writeln(fout,'Fcv   Fr*Ft ',i:4,
  fspr[i]:9:2,fspi[i]:9:2,ftr[i]:9:2,fti[i]:9:2);
 END;

sfftsh(m,50,-1,n1,n2);
FOR i:=1 TO m DO onl[i]:=SQRT(SQR(orr[i])+SQR(ori[i]));
FOR i:=1 TO m DO Writeln(fout,'sol tr ',i:4,onl[i]:8:2,tar[i-51]:12:2);
FOR i:=1 TO m DO onl[i+100]:=tar[i-51];
WITH LB1rec DO
 BEGIN nitems:=1;
 ar[1]:='Restored by Fourier transform.';
 END;
GraphSpecAndModel(Form2.Image1,m,2,0); Form2.ShowModal;
 {Writeln(fout,'true resf conv ',
 j:4,tar[j]:8:2,densar[j]:8:2,convar[j]:8:2); }
{arr[i]:=orr[i]; ari[i]:=ori[i];
FOR i:=1 TO m DO
 BEGIN arr[i]:=convar[i-51]*10; ari[i]:=0;
 END;
sfftsh(m,50,1,n1,n2); m:=n1*n2;
FOR i:=1 TO m DO
 BEGIN fspr[i]:=orr[i]; fspi[i]:=ori[i];
 x:=SQRT(SQR(orr[i])+SQR(ori[i]));
 Writeln(fout,'cv Fcv abs ',i:4,convar[i-51]:9:2,orr[i]:9:2,ori[i]:9:2,
  x:15:2);
 arr[i]:=orr[i]; ari[i]:=ori[i];
 END;
sfftsh(m,-1,-1,n1,n2);
FOR i:=1 TO m DO
 BEGIN x:=SQRT(SQR(orr[i])+SQR(ori[i]));
 END;
FOR i:=1 TO m DO
 BEGIN arr[i]:=densar[i-51]; ari[i]:=0;
 END;
sfftsh(m,50,1,n1,n2); m:=n1*n2;}
{FOR i:=-50 TO 50 DO onl[i+51]:=convar[i];
GraphSpecAndModel(Form2.Image1,m,1,0); Form2.ShowModal;}
END;
{*}                                                            {AUXI}
PROCEDURE HideComponents;
BEGIN Form2.Close; WITH Form1 DO
 BEGIN Label1.Visible:=false; Label2.Visible:=false;
 Edit1.Visible:=false;
 DBGrid1.Visible:=false;
 ComboBox1.Visible:=false;
 {DBNavigator1.Visible:=false; }
 END;
END;
PROCEDURE TForm1.Edit1KeyDown(Sender: TObject; VAR Key:WORD;
          Shift: TShiftState);
VAR i:INTEGER;
BEGIN s:=''; s:=InttoStr(Key);
IF(ssAlt IN Shift)THEN s:=s+' Alt ';
IF(ssShift IN Shift)THEN s:=s+' Shift ';
IF(ssCtrl IN Shift)THEN s:=s+' Ctrl ';
{ShowMess(s);} Label2.Caption:=s;
END;
PROCEDURE FittheRadCalibr;
{ Purpose: To fit data with unordered arguments: calibration case
  Version: Dec 15 1997}
{Purpose: To minimize    [a*X_j+b - E_j]^2  over [a,b];
          where X_j := ARG MIN | E_j - a*X_k - b | over [X_k];
 Version: Sep 10 1997;}
CONST energar:ARRAY[1..10] OF REAL = (121.782, 244.691, 344.267,
      443.940, 778.914, 867.383, 964.070, 1085.835, 1112.065, 1407.974);
CONST chanar:ARRAY[1..17] OF REAL = ( 279.103,  548.540,  555.467,
      767.232,  818.911,  913.763, 985.708, 1719.957, 1912.933,
      2125.412, 2214.553, 2394.927, 2449.159, 2583.336, 2804.774,
      2931.833, 3097.047);
VAR oxar:ARRAY[1..50] OF REAL; ixar:ARRAY[1..50] OF INTEGER;
    i,j,k,iter,nit,me,mc,jm:INTEGER; r,z,c0,c1,c2,dev:REAL;
    vc2,pa0,pax:ARRAY[1..2] OF REAL; m11,m12,m21,m22:REAL;
 FUNCTION Ener(x:REAL):REAL;
 BEGIN z:=x/(c2-c1); Ener:=pa[1]*z+pa[2];
 END;
 PROCEDURE SortXs;
 VAR j,k:INTEGER;
 BEGIN FOR j:=1 TO me DO ixar[i]:=0; FOR j:=1 TO me DO
  BEGIN amx:=1.E16; jm:=1; FOR k:=1 TO mc DO
    {IF((iter>0)AND(ixar[k]=0))THEN}
   BEGIN dev:=ABS(Ener(chanar[k])-energar[j]);
   IF(dev<amx)THEN
    BEGIN amx:=dev; jm:=k;
    END;
   END;
  oxar[j]:=chanar[jm]; ixar[jm]:=1; {Mark the selected item;}
  {Writeln(fout,energar[j]:9:3,oxar[j]:9:3,Ener(oxar[j]):15:3);}
  END;  {In oxar selected channels}
 arran(oxar,me,1);
 END;
 PROCEDURE ComputeChi;
 VAR i:INTEGER;
 BEGIN chi:=0; FOR i:=1 TO me DO
  chi:=chi+sigi*SQR(energar[i]-Ener(oxar[i]));
 chi:=chi/AMAX1(1,c2-c1-2); Writeln(fout,'Chi2= ',chi:15:3);
 END;

BEGIN nit:=50; me:=10; mc:=17; sigi:=1; {me:=2; mc:=2;}
c1:=chanar[1]; c2:=chanar[mc];
pa0[1]:=energar[me]-energar[1]; pa0[2]:=energar[1]-pa0[1]*c1/(c2-c1);
Writeln(fout,'par0=',pa0[1]:9:3,pa0[2]:9:3);
chio:=1E10;

FOR iter:=1 TO nit DO
 BEGIN FOR i:=1 TO me DO ixar[i]:=0;
 pa[1]:=pa0[1]+RNDM(-1)*10; pa[2]:=pa0[2]+RNDM(-1)*1000;
 Writeln(fout,'* par=',pa[1]:9:3,pa[2]:9:3);
 {assign channels} SortXs; ComputeChi;
 m11:=0; m12:=0; m21:=0; m22:=0; FOR i:=1 TO 2 DO vc2[i]:=0;
 {Refine parameters} FOR j:=1 TO me DO
  BEGIN fex:=energar[j]; r:=Ener(oxar[j]); ffr[1]:=z; ffr[2]:=1;
  FOR i:=1 TO 2 DO vc2[i]:=vc2[i]+sigi*fex*ffr[i];
  m11:=m11+sigi*ffr[1]*ffr[1]; m12:=m12+sigi*ffr[1]*ffr[2];
  m21:=m21+sigi*ffr[2]*ffr[1]; m22:=m22+sigi*ffr[2]*ffr[2];
  {Writeln(fout,'z ',z:9:3,ffr[1]:9:3,ffr[2]:9:3);}
  END;
 {Writeln(fout,'m11-m22 ',m11:9:3,m12:9:3,m21:9:3,m22:9:3);}
 det:=AMAX1(0.00001,m11*m22-m12*m21); {Invert matrix}
 {Writeln(fout,'det ',det:9:3);}
 r:=m11/det; m11:=m22/det; m22:=r; m12:=-m21/det; m21:=m12;
 {Writeln(fout,m11:9:3,m12:9:3,m21:9:3,m22:9:3);
 Writeln(fout,'vec2 ',vc2[1]:9:3,vc2[2]:9:3);}
 pa[1]:=m11*vc2[1]+m12*vc2[2];
 pa[2]:=m21*vc2[1]+m22*vc2[2];
 Writeln(fout,'New par=',pa[1]:9:3,pa[2]:9:3);
 {FOR i:=1 TO me DO
  Writeln(fout,energar[i]:9:3,oxar[i]:9:3,Ener(oxar[i]):15:3);}
 ComputeChi;
 IF(chi<chio)THEN
  BEGIN chio:=chi; FOR i:=1 TO 2 DO pax[i]:=pa[i];
  END;
 IF(chi<0.1)THEN BREAK;
 END; {Loop end}
FOR i:=1 TO 2 DO pa[i]:=pax[i]; SortXs;
{mocan:=1; ncen:=me; encm:=true; FOR i:=1 TO ncen DO WITH enc[i] DO
 BEGIN x:=oxar[i]; y:=energar[i]; e:=0.1;
 END;}

MakeFormV(170,20,400,430,0); WITH LB1rec DO
 BEGIN ar[1]:=' The fitted parameters, iter:'+IntToStr(iter);
 s:=''; FOR i:=1 TO 2 DO
  BEGIN ConvertStr(pa[i],10,3); Compress(sedz); s:=s+sedz+' ';
  END;
 ar[2]:=s;
 s:=''; ar[3]:=s;
 ConvertStr(chio,10,2); ar[4]:='Chi^2='+sedz;
 FOR i:=1 TO me DO
  BEGIN s:=''; ConvertStr(energar[i],10,3); s:=s+sedz;
  ConvertStr(oxar[i],10,3); s:=s+sedz;
  ConvertStr(Ener(oxar[i]),15,3); s:=s+sedz; ar[5+i]:=s;
  END;
 nitems:=5+me;
 FOR i:=1 TO nitems DO Writeln(fout,ar[i]);
 END;
MakeListBox(3,40,380,300); Form2.ShowModal;
END;


{*}                                                            {FILE}
PROCEDURE TForm1.Read1Click(Sender: TObject);
VAR   i,j,n:INTEGER; stra:ARRAY[1..5000] OF STRING; ft:TEXTFILE;
LABEL L1;
BEGIN L0rec:='Specify the file name'; GetFilename(fn1,0);
AssignFile(ft,fn1); {$I-} Reset(ft); {$I+};
n:=0; WHILE(NOT EoF(ft))DO
 BEGIN Inc(n); Readln(ft,stra[n]);
 END;
L1: MakeFormV(250,20,330,430,0);
WITH Form2.Label1 DO
 BEGIN Left:=5; Top:=30; Caption:='Enter the word'; Visible:=true;
 END;
WITH Form2.Edit1 DO
 BEGIN Left:=30; Top:=50; Width:=260; Text:=' '; Visible:=true;
 END;
Form2.ShowModal; IF(ModalRes=0)THEN Exit; fn:=Form2.Edit1.Text;
FOR i:=1 TO n DO
 BEGIN j:=Pos(fn,stra[i]); IF(j<>0)THEN Writeln(fout,stra[i]);
 END;
GOTO L1;
END;
PROCEDURE TForm1.ReWrite1Click(Sender: TObject);
VAR i,j,k,kkk:INTEGER; stra:ARRAY[1..150] OF STRING; s:STRING;
BEGIN L0rec:='Convert EXCEL-file to ASCII one';
GetDir(0,fn); GetFilename(fn,0); IF(ModalRes=0)THEN Exit;
AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
AssignFile(fo,'tmp.sav'); Rewrite(fo);
j:=0; WHILE(NOT EoF(ft))DO
 BEGIN Readln(ft,s); IF(s[1]='*')THEN CONTINUE;
 FOR i:=1 TO Length(s) DO IF(s[i]=',')THEN s[i]:='.';
 FOR i:=1 TO Length(s) DO IF(s[i]='	')THEN s[i]:=' ';
 Inc(j); IF(j>150)THEN
  BEGIN ShowMess('Number of lines > 150; input stopped'); BREAK;
  END;
 stra[j]:=s;
 fffins(kkk,s);
 FOR i:=1 TO kkk DO Write(fo,onl[i]:8:2); Writeln(fo);
 END;
CloseFile(ft);
ReSet(fo);
FOR i:=1 TO j DO
 BEGIN Readln(fo,s); LB1rec.ar[i]:=s;
 END;
CloseFile(fo);
MakeFormV(50,20,510,430,0);
s:=IntToStr(j)+' lines, each containing '+IntToStr(kkk)+' items';
OuttoLabel(Form2.Label1,5,0,clMaroon,clWhite,s);
LB1rec.nitems:=j;
MakeListBox(10,20,480,340);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 END;
WITH CB1rec DO
 BEGIN nitems:=kkk; FOR i:=1 TO kkk DO ar[i]:='    Column '+IntToStr(i);
 END;
L1rec:=' Specify the output file name'; GetFilename(fn,1);
MakeFormV(50,20,410,430,0); MakeCheckListBox(50,80,200,20*kkk);
s:=' Select columns to be output ';
OuttoLabel(Form2.Label1,50,20,clMaroon,clWhite,s);
s:=' Save the data to file '+fn+' ';
OuttoLabel(Form2.Label2,50,280,clMaroon,clWhite,s);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 AssignFile(ft,fn); Rewrite(ft);
 FOR i:=1 TO j DO WITH LB1rec DO
  BEGIN s:=ar[i]; fffins(kkk,s);
  FOR k:=1 TO kkk DO
   IF(CheckListBox1.Checked[k-1])THEN Write(ft,onl[k]:10:4);
  Writeln(ft);
  END;
 END;
CloseFile(ft);
END;
PROCEDURE TForm1.BackCopyToA1Click(Sender: TObject);
VAR indxm,ic1,ic2,i,j:INTEGER; da1,da2,dir1,dir2,sh:STRING;
    fload:TDATETIME; ho,mi,se,mse,y,m,d:WORD; dt:REAL;
CONST extar:ARRAY[1..11] OF STRING[6] = (
      '*.for','*.pas','*.eng','*.rus','*.doc','*.tex','*.txr','any',
      'delphi','texts','f->c'
      );
LABEL L1,Lend,Lbeg;
BEGIN fload:=Now+1; da2:=DateToStr(fload); t2:=fload; dt:=30;
{DecodeDate(fload,y,m,d); DecodeTime(fload,ho,mi,se,mse);
IF(m=1)THEN BEGIN m:=12; Dec(y); END   ELSE Dec(m);}
ic1:=2; ic2:=5; indxm:=9;
IF(fldisk<>'F')THEN ShowMess('Flash disk = '+fldisk);

Lbeg: L0rec:='BackCopy files'; MakeFormV(150,20,430,430,0);
s:='Select type of files to be backcopied';
OuttoLabel(Form2.Label4,5,5,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=11; indx:=indxm; FOR i:=1 TO 11 DO ar[i]:=extar[i];
 END;
MakeRadioGroup(1,3,20,20,270,170);

OuttoLabel(Form2.Label5,10,250,clMaroon,clWhite,'FROM'); WITH CB1rec DO
 BEGIN nitems:=6; indx:=ic1;
 ar[1]:='A'; ar[2]:='C'; ar[3]:='D'; ar[4]:='E'; ar[5]:='F'; ar[6]:='G';
 END;
MakeComboBox(Form2.ComboBox1,55,250,150);

OuttoLabel(Form2.Label6,225,250,clMaroon,clWhite,'TO');
WITH CB1rec DO
 BEGIN nitems:=6; indx:=ic2;
 ar[1]:='A'; ar[2]:='C'; ar[3]:='D'; ar[4]:='E'; ar[5]:='F'; ar[6]:='G';
 END;
MakeComboBox(Form2.ComboBox2,250,250,150);

L1rec:=' Days ago'; E1rec:=FloatToStr(dt);
MakeEdits(20,120,320,200,1);

nfs:=0; nft:=0; klist:=0; WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex+1; sh:=extar[i];
 ic1:=ComboBox1.ItemIndex+1; ic2:=ComboBox2.ItemIndex+1;
 Zval(Edit1.Text,dt); t1:=t2-Round(dt)-1;
 da1:=DateToStr(t1){+EncodeTime(ho,mi,se,mse)};
 CASE i OF
 1: s:='\fort\';
 2,9,11: s:='\pasc\';
 3..7,10: s:='\thes\';
 8: GOTO Lend;
 ELSE END;
 IF(i=11)THEN
  BEGIN ic1:=4; IF(fldisk='F')THEN ic1:=6; ic2:=2; indxm:=9; i:=9;
  END;
 IF(indxm=9)THEN indxm:=10 ELSE indxm:=9;
 CASE ic1 OF
 1: dir1:='a:\';
 2: dir1:='c:\zlok'+s;
 3: dir1:='d:'+s;
 4: dir1:='e:'+s;
 5: dir1:=fldisk+':'+s;
 6: dir1:='g:\zlok'+s;
 ELSE END;
 CASE ic2 OF
 1: dir2:='a:\';
 2: dir2:='c:\zlok'+s;
 3: dir2:='d:'+s;
 4: dir2:='e:'+s;
 5: dir2:=fldisk+':'+s;
 6: dir2:='g:\zlok'+s;
 ELSE END;
 END;
sh:=extar[i]; IF(i IN [1..8])THEN GOTO Lend;
IF(i=9)THEN WITH LB1rec DO
 BEGIN nfs:=0; nft:=0;
 IF((ic2=1)AND(NOT FileExists('a:\delphi.fld')))THEN
  BEGIN ShowMess('Floppy no delphi'); Exit;
  END;
 sh:='v*.pas'; SearchFiles(sh,dir1,dir2);
 sh:='v*.dfm'; SearchFiles(sh,dir1,dir2);
 sh:='v*.dpr'; SearchFiles(sh,dir1,dir2);
 GOTO L1;
 END;
IF(i=10)THEN WITH LB1rec DO
 BEGIN IF((ic2=1)AND(NOT FileExists('a:\upd.fld')))THEN
  BEGIN ShowMess('Floppy no upd'); Exit;
  END;
 sh:='*.eng'; SearchFiles(sh,dir1,dir2);
 sh:='*.rus'; SearchFiles(sh,dir1,dir2);
 sh:='*.doc'; SearchFiles(sh,dir1,dir2);
 sh:='*.tex'; SearchFiles(sh,dir1,dir2);
 sh:='*.txr'; SearchFiles(sh,dir1,dir2);
 dir1:=Copy(dir1,1,2)+'\'; IF(ic1 IN [2,6])THEN dir1:=dir1+'zlok\';
 dir2:=Copy(dir2,1,2)+'\'; IF(ic2 IN [2,6])THEN dir2:=dir2+'zlok\';
 sh:='edz.mac'; SearchFiles(sh,dir1,dir2);
 sh:='edz.txt'; SearchFiles(sh,dir1,dir2);
 sh:='edz.fas'; SearchFiles(sh,dir1,dir2);
 sh:='traff.fin'; SearchFiles(sh,dir1,dir2);
 GOTO L1;
 END;
Lend: SearchFiles(sh,dir1,dir2);

L1: MakeFormV(150,20,430,430,0); WITH LB1rec DO
 BEGIN ar[2]:='     from '+da1+' to '+da2; nitems:=klist+2;
 ar[1]:=bblank+IntToStr(klist)+' file(s) processed';
 END;
MakeListBox(10,0,400,320); Form2.ShowModal;
IF(ModalRes=0)THEN Exit;
GOTO Lbeg;
END;
PROCEDURE TForm1.Dir1Click(Sender: TObject);
VAR i:INTEGER; s,stt,sh:STRING; sdr:FTY;
BEGIN REPEAT L0rec:=''; MakeFormV(250,20,330,430,0); nfs:=0;
WITH CB1rec DO
 BEGIN nitems:=8; indx:=8;
 ar[1]:=' Specify the mask';
 ar[2]:='vm*.pas';
 ar[3]:='v*.pas';
 ar[4]:='*.eng';
 ar[5]:='*.tex';
 ar[6]:='*.txr';
 ar[7]:='*.rus';
 ar[8]:='*.sav';
 END;
MakeRadioGroup(1,0,30,20,240,280); lsave1:=0; lsave2:=0;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex+1; sh:=CB1rec.ar[i]; GetDir(0,s);
 CASE i OF
 2..3: sh:='\zlok\pasc\'+sh;
 4..7: sh:='\zlok\thes\'+sh;
 8:    sh:='\zlok\'+sh;
 ELSE END;
 END;
IF(i=1)THEN
 BEGIN MakeFormV(10,20,330,430,0);
 L1rec:=' Mask='; E1rec:=fn0; MakeEdits(10,120,170,100,1);
 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit; fn0:=Edit1.Text;
  sh:=fn0; IF(length(sh)<2)THEN
   BEGIN ShowMess('Wrong device '+sh); Exit;
   END;
  i:=Pos(':',sh); IF(length(sh)=i)THEN sh:=sh+'*.*';
  i:=PosB('\',sh); IF(length(sh)=i)THEN sh:=sh+'*.*';
  END;
 END;
IF(FindFirst(sh,faArchive,SR)=0)THEN
 REPEAT Inc(nfs); fns[nfs].name:=SR.Name;
 fns[nfs].time:=SR.Time; fns[nfs].size:=SR.Size;
 UNTIL FindNext(SR)<>0;
FindClose(SR);

FOR i:=1 TO nfs DO FOR j:=1 TO nfs DO
 BEGIN IF(fns[i].time > fns[j].time)THEN
  BEGIN sdr:=fns[i]; fns[i]:=fns[j]; fns[j]:=sdr;
  END;
 END;

FOR i:=1 TO nfs DO WITH fns[i] DO
 BEGIN stt:=name+Copy(tblank,1,21-Length(name));
 s:=IntToStr(size); s:=Copy(tblank,1,7-Length(s))+s; stt:=stt+s;
 s:=Copy(DateTimeToStr(FileDateToDateTime(time)),1,14);
 stt:=stt+' '+s; UpCaseStr(stt);
 LB1rec.ar[i]:=stt;
 END;
LB1rec.nitems:=nfs;

REPEAT MakeFormV(10,20,630,430,0); MakeListBox(0,20,370,340);
Form2.ListBox1.ItemIndex:=MAX0(0,LBindx);
OuttoLabel(Form2.Label1,5,0,clMaroon,clWhite,
 ' Mask= '+sh+'  '+IntToStr(nfs)+' files '); DosWin:=true;

Form2.ShowModal; IF(ModalRes=0)THEN BREAK;
WITH Form2.ListBox1 DO IF(ItemIndex<>-1)THEN
 BEGIN i:=ItemIndex+1; ListTextFile(ExtractFileDir(sh)+'\'+fns[i].name);
 LBindx:=i-1;
 END;
UNTIL false;
      UNTIL false;
END;

PROCEDURE TForm1.Quit1Click(Sender: TObject);
BEGIN CloseFile(fout); pmod[1].Free;
Application.Terminate;
END;
{*}                                                            {TRAFF}
PROCEDURE TForm1.Recode1Click(Sender: TObject);
VAR io,ic:INTEGER;
BEGIN fn1:='\zlok\a.sav';
{L1rec:=' Enter the input file name '; GetFilename(fn1,0);
IF(ModalRes=0)THEN Exit;}
fn2:='\zlok\t.sav';
{L1rec:=' Enter the output file name '; GetFilename(fn2,1);
IF(ModalRes=0)THEN Exit;}
L0rec:='VEDZ: a.sav -> t.sav'; MakeForm(25);
OuttoLabel(Form2.Label3,10,30,clGreen,clWhite,selops);
WITH CB1rec DO
 BEGIN nitems:=10; indx:=1;
 ar[1]:=' KOI8-r    -> DOS_Cyr';
 ar[2]:=' Rus_ES    -> ENGLISH';
 ar[3]:=' Win_1251  -> DOS_Cyr';
 ar[4]:=' RU        -> DOS_Cyr';
 ar[5]:=' RU_VOV    -> DOS_Cyr';
 ar[6]:=' UTF8      -> DOS_Cyr';
 ar[7]:=' ALL       -> DOS_Cyr';
 ar[8]:='    DOS_Cyr   -> WIN_Cyr';
 ar[9]:='    WIN_Cyr   -> DOS_Cyr';
 ar[10]:=' Vova''s -> =char';
 END;
MakeRadioGroup(1,0,50,70,210,260);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; io:=RadioGroup1.ItemIndex;
 IF(fn1=fn2)THEN
  BEGIN ShowMessage('Error, equal names for input and output'); Exit;
  END;
 END;
Recode(fn1,fn2,io,ic);
MakeFormV(5,20,500,430,0); WITH LB1rec DO
 BEGIN nitems:=1; ar[1]:=' '+IntToStr(ic)+' items converted';
 END;
MakeListBox(5,40,475,120); Form2.ShowModal;
Dir1Click(Self);
END;
PROCEDURE TForm1.MakefileforLATEX1Click(Sender: TObject);
BEGIN Recode('a.sav','t.sav',7,i); Quit1Click(Self);
END;
PROCEDURE TForm1.Finance1Click(Sender: TObject);
BEGIN L0rec:='VEDZ'; MakeForm(25);
fn:='\zlok\traff.fin';
AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
ok:=(IOresult=0); IF NOT ok THEN
 BEGIN L1rec:=' Enter the input file name '; GetFilename(fn,0);
 IF(ModalRes=0)THEN Exit;
 AssignFile(ft,fn); {$I-} Reset(ft); {$I+};
 END;
financial;
{$I-} Reset(ft); {$I+}; LB1rec.nitems:=0;
MakeFormV(5,20,570,430,0); WITH LB1rec DO WHILE(NOT EoF(ft))DO
 BEGIN Inc(nitems); Readln(ft,s); ar[nitems]:=s;
 END;
MakeListBox(5,40,550,320); Form2.ShowModal;
CloseFile(ft);
END;
PROCEDURE TForm1.Execute1Click(Sender: TObject);
VAR i:INTEGER; ss:PCHAR; dir,s:STRING; PName:ARRAY[0..79] OF CHAR;
BEGIN L0rec:=' Execute a program'; MakeFormV(250,20,330,430,0);
L1rec:=''; E1rec:=''; MakeEdits(10,10,270,170,1);
s:=' Specify the program path and name ';
OuttoLabel(Form2.Label1,5,50,clMaroon,clWhite,s);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; s:=Edit1.Text;
 END;
GetDir(0,dir);
i:=ShellExecute(Handle,nil,StrPCopy(PName,s),nil,nil,SW_RESTORE);
IF(i<32)THEN
 BEGIN ShowMess(s+' call failure; Check the correctness');
 END;
END;
PROCEDURE TForm1.Connect1Click(Sender: TObject);
VAR Info:Pchar; {clipb:TClipboard; i,j:INTEGER;
    PName:ARRAY[0..79] OF CHAR; ok:BOOLEAN;}
BEGIN L0rec:=' Connect to program'; MakeFormV(50,20,530,430,0);
{L1rec:=''; E1rec:=''; MakeEdits(10,10,270,70,1);
Form2.Edit1.text:='aaaa';
Form2.ShowModal;
Form2.Edit1.PasteFromClipboard;}
MakeMemo(5,500); Form2.Memo1.PasteFromClipboard;
{IF(NOT DdeClientConv1.SetLink('vmria.exe','Topic1')
   OR NOT DdeClientConv1.OpenLink)THEN
   ShowMessage('No contact with vmria.exe')
                                  ELSE}
 {BEGIN Info:=DdeClientConv1.RequestData('Items1');
 Memo1.SetTextBuf(Info);
 DdeClientConv1.CloseLink;
 END;}
{clipb.Create; i:=GetTextBuf(PName,50); clipb.Free;}
WITH Form2 DO
 BEGIN ShowModal;
 END;
END;
PROCEDURE TForm1.MakeEDZfonts1Click(Sender: TObject);
VAR ok:BOOLEAN; fb:FILE; nstr,i,j,k,l,count,res:INTEGER; b:BYTE;
    cod16:ARRAY[1..64,1..16] OF BYTE;
{-----------------------------------------------}
BEGIN nstr:=16;
FOR i:=1 TO 48 DO FOR j:=1 TO 16 DO cod16[i,j]:=$00;
FOR j:=1 TO 48 DO FOR l:=1 TO 14 DO FOR k:=1 TO 8 DO
 IF(MIKZ_FNT1[(j-1)*15+l+1,k]='1')THEN
 cod16[j,l]:=cod16[j,l] OR (128 SHR (k-1));
AssignFile(fb,'edz1.fnt'); {$I-} Rewrite(fb) {$I+}; ok:=(IOresult=0);
count:=6; BlockWrite(fb,cod16,count,res); CloseFile(fb);
FOR i:=1 TO 16 DO FOR j:=1 TO 16 DO cod16[i,j]:=$00;
FOR j:=1 TO 16 DO FOR l:=1 TO 14 DO FOR k:=1 TO 8 DO
 IF(MIKZ_FNT2[(j-1)*15+l+1,k]='1')THEN
 cod16[j,l]:=cod16[j,l] OR (128 SHR (k-1));
AssignFile(fb,'edz2.fnt'); {$I-} Rewrite(fb) {$I+}; ok:=(IOresult=0);
count:=2; BlockWrite(fb,cod16,count,res); CloseFile(fb);
ShowMess(' Fonts built, run: binobj edzi.fnt edzi.obj edzi ');
END;
PROCEDURE TForm1.ExcelToNorm1Click(Sender: TObject);
BEGIN ExcelToNFile;
END;
PROCEDURE TForm1.Transform1Click(Sender: TObject);
VAR   i,j,k,ip,ic1,ic2,ii:INTEGER; s:STRING; textF:BOOLEAN;
      buf:ARRAY[1..512] OF BYTE;
LABEL L1,Lgo;
BEGIN L0rec:=''; MakeFormV(250,20,330,430,0); textF:=true; RE:=true;
WITH CB1rec DO
 BEGIN nitems:=9; indx:=1;
 ar[1]:='Text lines -> words';
 ar[2]:='Count word occurences';
 ar[3]:='Text file -> 72-line file';
 ar[4]:='Partition the file ';
 ar[5]:='Translate (rus to eng, or v.v.)';
 ar[6]:='Insert(overwrite) string)';
 ar[7]:='Purge non-ASCII (or German)';
 ar[8]:='Ajust to standard Fortran';
 ar[9]:='DOS-UNIX exchange';
 END;
MakeRadioGroup(1,0,10,20,300,240);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 ip:=RadioGroup1.ItemIndex;
 END;
IF(ip IN [0,2,6,7])THEN GOTO Lgo;
IF(ip=1)THEN
 BEGIN MakeFormV(250,20,330,430,0);
 L1rec:='Word to be counted= '; E1rec:=''; MakeEdits(10,200,200,100,1);
 END;
IF(ip=4)THEN
 BEGIN MakeFormV(250,20,330,430,0);
 WITH CB1rec DO
  BEGIN nitems:=2; indx:=1;
  ar[1]:='ENG to RUS';
  ar[2]:='RUS to ENG';
  END;
 MakeRadioGroup(1,0,10,20,300,200);
 END;
IF(ip=8)THEN
 BEGIN MakeFormV(250,20,330,430,0);
 WITH CB1rec DO
  BEGIN nitems:=2; indx:=1;
  ar[1]:='DOS  -> UNIX';
  ar[2]:='UNIX -> DOS';
  END;
 MakeRadioGroup(1,0,10,20,300,200);
 END;
IF(ip IN [1,4,8])THEN WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 i:=RadioGroup1.ItemIndex;
 RE:=false; IF(i=1)THEN RE:=true;
 sword:=Edit1.Text;
 GOTO Lgo;
 END;

IF(ip=3)THEN
 BEGIN MakeFormV(250,20,330,430,0);
 WITH CB1rec DO
  BEGIN nitems:=1; ar[1]:='File is a binary one';
  END;
 MakeCheckListBox(5,220,235,25);
 Form2.CheckListBox1.Checked[0]:=NOT textF;
 s:=' This information is only for partitioning files ';
 OuttoLabel(Form2.Label5,5,265,clBlue,clYellow,s);
 strgrW[0]:=170; strgrW[1]:=60;
 strgrT[1]:='Beginning line (512byte block)'; strgrNn[1,1]:=1;
 strgrT[2]:='End line (block)'; strgrNn[2,1]:=1;
 strgrT[3]:='1st column (if text file)'; strgrNn[3,1]:=1;
 strgrT[4]:='Last column (if text file)'; strgrNn[4,1]:=72;
 PuttoTable(5,280,4,4,1,8);

 WITH Form2 DO
  BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
  textF:=NOT CheckListBox1.Checked[0];
  FOR i:=1 TO 4 DO Zval(StringGrid1.Cells[0,i-1],har[i]); {c,r}
  i:=Round(har[1]); j:=Round(har[2]);
  ic1:=Round(har[3]); ic2:=Round(har[4]);
  END;
 END;
Lgo:
OpenAT(fn1,fn2); IF(ModalRes=0)THEN Exit;
IF(ip=8)THEN
 BEGIN AssignFile(fbyt,fn1); {$I-} Reset(fbyt); {$I+};
 AssignFile(fo,fn2); Rewrite(fo);
 END    ELSE IF((ip=3)AND(NOT textF))THEN
 BEGIN count:=512; hands:=FileOpen(fn1,$0000); handt:=FileCreate(fn2);
 END                                 ELSE
  BEGIN AssignFile(ft,fn1); {$I-} Reset(ft); {$I+};
  AssignFile(fo,fn2); Rewrite(fo);
  END;
CASE ip OF
0: BEGIN k:=0; WHILE NOT EoF(ft) DO {Split into words}
    BEGIN Readln(ft,fn); IF((fn='')OR(fn=' '))THEN GOTO L1;
    REPEAT FCompress(fn); i:=0; IF(fn='')THEN GOTO L1;
     REPEAT Inc(i);
     UNTIL((fn[i]=' ')OR(i>=Length(fn)));
    s:=Copy(fn,1,i); IF(Length(Copy(fn,1,i))<>0)THEN
     BEGIN Writeln(fo,Copy(fn,1,i)); Inc(k); Delete(fn,1,i);
     END;
    UNTIL Length(fn)=0;
    L1:;
    END;
   s:=IntToStr(k)+' word sequence is formed';
   END;
1: BEGIN k:=0; IF(sword='')THEN
    BEGIN ShowMess('Empty word'); Exit;
    END;
   WHILE NOT EoF(ft) DO
    BEGIN Readln(ft,fn); i:=1;
    REPEAT fn:=Copy(fn,i,255); j:=Pos(sword,fn);
    IF(j<>0)THEN
     BEGIN Inc(k); i:=j+Length(sword);
     END    ELSE fn:='';
    UNTIL (fn='');
    END;
   s:=IntToStr(k)+' '+sword+' occurence(s)'; Writeln(fo,s);
   END;
2: BEGIN k:=0; s:=''; WHILE NOT EoF(ft) DO
    BEGIN Readln(ft,fn); s:=s+' '+fn; IF(Length(s)<72)THEN CONTINUE;
    j:=72; FOR i:=62 TO 72 DO
     IF(s[i] IN [' ',',',':',';','.','?','!',')',']','}','='])THEN j:=i;
    Writeln(fo,Copy(s,1,j)); Delete(s,1,j); Inc(k);
    END;
   IF(s<>'')THEN
    BEGIN HCompress(s); Writeln(fo,s); Inc(k);
    END;
   s:=IntToStr(k)+' 72-lines saved to file';
   END;
3: BEGIN k:=0; IF(textF)THEN
    BEGIN IF(i<>1)THEN REPEAT Readln(ft,fn); Inc(k);
                       UNTIL ((EoF(ft)OR(k=(i-1)))) ELSE; k:=0;
    REPEAT Readln(ft,fn); Writeln(fo,Copy(fn,ic1,ic2-ic1+1));Inc(k);
    UNTIL ((EoF(ft)OR(k=(j-i+1))));
    END                 ELSE
    BEGIN IF(i<>1)THEN REPEAT resread:=FileRead(hands,buf,count);
    Inc(k);            UNTIL ((resread=0)OR(k=(i-1)));
    REPEAT resread:=FileRead(hands,buf,count); IF(resread=0)THEN BREAK;
    reswrit:=FileWrite(handt,buf,resread); Inc(k);
    IF(resread<>reswrit)THEN
     BEGIN ii:=MessageDlg('Wrong reading',MtWarning,[mbYes,mbAbort],0);
     s:='File '+fn1+' not partitioned'; IF(ii=mrAbort)THEN BREAK;
     END;
    UNTIL ((resread=0)OR(k=j));
    END;
   s:=IntToStr(k-i+1)+' ';
   IF(textF)THEN s:=s+'lines' ELSE s:=s+'blocks';
   END;
4: BEGIN TranslateEngRus(i);s:='Text translated, '+IntToStr(i)+' lines';
   END;
5: BEGIN InsertString(k); s:=IntToStr(k)+' strings processed';
   END;
6: BEGIN PurgeNonAscii(k); s:=IntToStr(k)+' chars processed';
   END;
7: BEGIN AjustFortran; s:='Finished';
   END;
8: BEGIN UnixDosZ; s:='Finished';
   END;
ELSE END;
IF(ip=8)THEN
 BEGIN CloseFile(fbyt); CloseFile(fo);
 END    ELSE IF((ip=3)AND(NOT textF))THEN
 BEGIN FileClose(hands); FileClose(handt);
 END                                 ELSE
  BEGIN CloseFile(ft); CloseFile(fo);
  END;
ShowMess(s);
END;
PROCEDURE TForm1.Edit2Click(Sender: TObject);
BEGIN EditTextFile;
END;
{*}                                                           {DATABASE}
PROCEDURE TForm1.Open1Click(Sender: TObject);
VAR i:INTEGER;
BEGIN {TestVGFit; Exit;}
{WITH DBNavigator1 DO
 BEGIN VisibleButtons:=[nbFirst,nbLast,nbPrior,nbNext,nbDelete];
 Visible:=true; Left:=5; Top:=0; Width:=230; Height:=20;
 END;}
WITH DBGrid1 DO
 BEGIN Visible:=true;
 Left:=5; Top:=25; Width:=620; Height:=350;
 Font.Pitch:=fpFixed; Options:=Options+[dgEditing];
 END;
{alias:='parts_db'; dbname:='parts.db';
alias:='DBDEMOS'; dbname:='biolife.db';}
alias:='musi'; dbname:='mus.db';
WITH Query1 DO
 BEGIN DataBaseName:=alias; s:='Select * from '+dbname;
 ExecuteSQLCommand(Form1.Query1,s);
 END;
AssignFile(ft,'\zlok\a.mus'); {$I-} Reset(ft); {$I+};
{s:='Select opus from mus.db where componist LIKE ''W%''';
s:='Select componist from mus.db where opus LIKE ''F%''';}
END;
PROCEDURE TForm1.Add1Click(Sender: TObject);
BEGIN IF(NOT Query1.Active)THEN Exit;
{ReadMusRecord;}
s:='Insert into '+dbname+' (componist,opus) VALUES ('''+comp
+''','' '')';
ShowMess(s);
{Query1.CachedUpdates:=true;}
WITH Query1 DO
 BEGIN Open; SQL.Clear; SQL.Add(s); Close; ExecSQL; Close;
 END;
{Query1.FieldByName('Componist').AsString:=comp;}
END;
PROCEDURE TForm1.Delete1Click(Sender: TObject);
BEGIN IF(NOT Query1.Active)THEN Exit;
s:='Delete from '+dbname+' where NUM > 8';
WITH Query1 DO
 BEGIN Open; SQL.Clear; SQL.Add(s); Close; ExecSQL; Close;
 END;
END;
PROCEDURE TForm1.Close1Click(Sender: TObject);
BEGIN
DBGrid1.Visible:=false;
Query1.GetFieldNames(ComboBox1.Items);
WITH ComboBox1 DO
 BEGIN Visible:=true; Left:=5; Top:=25; Width:=320; Height:=30;
 ItemIndex:=0;
 END;
Query1.Close;
CloseFile(ft);
END;
PROCEDURE TForm1.pati1Click(Sender: TObject);            {PATI}
VAR i:INTEGER;
LABEL L1;
BEGIN L1:ShowSession(i); Patience(i,AcMenu);
IF(acmenu)THEN GOTO L1;
END;
                                                         {TEST}
PROCEDURE TForm1.TestThis2Click(Sender: TObject);
VAR i,j,k:INTEGER;
BEGIN FittheRadCalibr; Exit;
AssignFile(ft,'m2.gph'); AssignFile(fo,'mm.gph');
{$I-} Reset(ft); {$I+}; Rewrite(fo); k:=7;
WHILE(NOT EoF(ft))DO
 BEGIN fffin(ft,1,k,j,onl); IF(ABS(onl[4])>100)THEN onl[4]:=100;
 Write(fo,onl[1]:6:0,onl[2]:8:0,onl[3]:7:1,onl[4]:7:1,onl[5]:8:4);
 Writeln(fo,onl[6]:4:0,onl[7]:8:0);
 END;
CloseFile(ft); CloseFile(fo);
END;
PROCEDURE TForm1.TestExp1Click(Sender: TObject);
BEGIN TestExpon;
END;
PROCEDURE TForm1.testGFit1Click(Sender: TObject);
BEGIN TestWidthFitting;
END;
PROCEDURE TForm1.TestFourier1Click(Sender: TObject);
VAR n1,n2,m,m2,i:INTEGER; x,s,d,r:REAL; p:ARRAY[1..3] OF REAL;
 PROCEDURE SuppressF(i,ibr,ibi,m:INTEGER);
 BEGIN orr[i]:=ibr; ori[i]:=ibi;
 orr[m-i+2]:=ibr; ori[m-i+2]:=-ibi;
 END;
BEGIN {***} L0rec:=''; MakeFormV(250,20,330,430,0);
p[1]:=Round(rndm(-1)*70);
p[2]:=Round(rndm(-1)*70+66);
p[3]:=Round(rndm(-1)*70+132);
Writeln(fout,p[1]:8:0,p[2]:8:0,p[3]:8:0);
m:=200; FOR i:=1 TO m DO
 BEGIN x:=i; sa[i]:=(rndm(-1)-0.5)*100+500+250*EXP(-x/50)
 +4000*EXP(-SQR((x-p[1])/3))
 +4000*EXP(-SQR((x-p[2])/3))
 +4000*EXP(-SQR((x-p[3])/3))
 +50*SIN(Float(i)*2*pi/9.75)
 +75*SIN(Float(i)*2*pi/9.875)
 +100*SIN(Float(i)*2*pi/10)
 +75*SIN(Float(i)*2*pi/10.16)
 +50*SIN(Float(i)*2*pi/10.33)
 +200*SIN(Float(i)*2*pi/20);
 {+200*SIN(Float(i)*2*pi/25) }

 arr[i]:=sa[i]; ari[i]:=0; onl[i+m]:=sa[i]; onl[i]:=sa[i];
 END;
WITH LB1rec DO
 BEGIN nitems:=2;
 ar[1]:='Periods=9.75..10.33,  20';
 ar[2]:='Peaks at 66,130,142';
 END;
GraphSpecAndModel(Form2.Image1,m,2,1); Form2.ShowModal;
n1:=0; n2:=0;
sfft(m,1,n1,n2); m:=n1*n2; m2:=m DIV 2; FOR i:=1 TO m DO
 BEGIN r:=AMAX1(ABS(orr[i]),ABS(ori[i]));
 IF(r<>0)THEN d:=SQRT(SQR(orr[i]/r)+SQR(ori[i]/r));
 {sd[i]:=d*r;} onl[i]:=d*r;
 Writeln(fout,i:4,orr[i]:8:2,ori[i]:8:2,(d*r):8:2);
 END;
WITH LB1rec DO
 BEGIN nitems:=1;
 ar[1]:='Fourier transform.  Periodicity peaks at 11,  21';
 END;
GraphSpecAndModel(Form2.Image1,m,1,1); Form2.ShowModal;
s:=0; FOR i:=4 TO m DO s:=s+orr[i]; s:=s/m/2; s:=0;
FOR i:=11-1 TO 11+1 DO SuppressF(i,Round(s),0,m); {20}
FOR i:=21-2 TO 21+2 DO SuppressF(i,Round(s),0,m); {10}
{orr[11]:=0; ori[11]:=0;
orr[91]:=0; ori[91]:=0;
orr[6]:=0; ori[6]:=0;
orr[96]:=0; ori[96]:=0;}
FOR i:=1 TO m DO
 BEGIN arr[i]:=orr[i]; ari[i]:=ori[i];
 END;
sfft(m,-1,n1,n2);
 {FOR i:=1 TO m DO Writeln(fout,i:5,spec[1].y[i]:10:0,orr[i]:10:0);}
FOR i:=1 TO m DO
 BEGIN r:=AMAX1(ABS(orr[i]),ABS(ori[i]));
 IF(r<>0)THEN d:=SQRT(SQR(orr[i]/r)+SQR(ori[i]/r));
 onl[i+m]:=d*r; onl[i]:=sa[i];
 arr[i]:=orr[i]; ari[i]:=ori[i];
 END;
GraphSpecAndModel(Form2.Image1,m,2,0); Form2.ShowModal;
sfft(m,1,n1,n2); FOR i:=1 TO m DO
 BEGIN r:=AMAX1(ABS(orr[i]),ABS(ori[i]));
 IF(r<>0)THEN d:=SQRT(SQR(orr[i]/r)+SQR(ori[i]/r));
 {sd[i]:=d*r;} onl[i]:=d*r;
 {Writeln(fout,i:6,orr[i]:8:2,ori[i]:8:2);}
 END;
GraphSpecAndModel(Form2.Image1,m,1,0); Form2.ShowModal;
END;
PROCEDURE TForm1.DomanovTest1Click(Sender: TObject);
VAR i,k,n,ni:INTEGER; arr:ARRAY[1..100] OF DOM_DATA;
    am,ai:ARRAY[1..2,1..2] OF REAL; farc:ARRAY[1..2] OF REAL;
    chp,wm,det,v,w,x,ch,x0:REAL;
BEGIN L0rec:='Enter data: y, dy, x, dx'; MakeFormV(250,20,330,430,0);
MakeMemo(5,290); ni:=0;
WITH Form2.Memo1 DO
 BEGIN Clear;
 Lines.Add(' 50   5  56.93   2.5 ');
 Lines.Add(' 55   4  56.5    2.5 ');
 Lines.Add('140   7 313.3   21   ');
 Lines.Add('175   6 450     30   ');
 Lines.Add('200  10 490     35   ');
 Lines.Add('187   7 506     42   ');
 Lines.Add('251  12 652     63   ');
 END;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 WITH Memo1.Lines DO
  BEGIN n:=Count; FOR i:=1 TO n DO
   BEGIN s:=Strings[i-1]; fffins(k,s); WITH arr[i] DO
    BEGIN y:=onl[1]; dy:=onl[2]; x:=onl[3]; dx:=onl[4];
    END;
   END;
  END;
 END;
REPEAT Inc(ni);
FOR i:=1 TO 2 DO  {Least square fit}
 BEGIN farc[i]:=0; FOR j:=1 TO 2 DO am[i,j]:=0;
 END;
{wm:=0; FOR i:=1 TO n DO wm:=wm+arr[i].dx; wm:=AMAX1(wm/n,0.01);}
wm:=0.0001;
x0:=0; FOR i:=1 TO n DO x0:=x0+arr[i].x; x0:=x0/n; x0:=0;
FOR i:=1 TO n DO WITH arr[i] DO
 BEGIN v:=y; w:=SQR(1/AMAX1(dy,wm)); z:=x-x0;
 farc[1]:=farc[1]+w*v; farc[2]:=farc[2]+w*v*z;
 am[1,1]:=am[1,1]+w; am[1,2]:=am[1,2]+w*z; am[2,2]:=am[2,2]+w*z*z;
 END;
am[2,1]:=am[1,2]; det:=AMAX1(0.000001,am[1,1]*am[2,2]-SQR(am[1,2]));
ai[1,1]:=am[2,2]/det; ai[2,2]:=am[1,1]/det;
ai[1,2]:=-am[1,2]/det; ai[2,1]:=-am[2,1]/det;
b:=(ai[1,1]*farc[1]+ai[1,2]*farc[2]);
a:=(ai[1,2]*farc[1]+ai[2,2]*farc[2]);
ch:=0; chp:=0; FOR i:=1 TO n DO WITH arr[i] DO
 BEGIN r:=y-a*(x-x0)-b; ch:=ch+SQR(r/dy);
 IF(r>=0)THEN chp:=chp+SQR(r/dy);
 END;
chp:=chp/AMAX1(ch,0.0001);; ch:=ch/(n-2);
{ConvertStr(am[1,1]*ai[1,1]+(am[1,2]*ai[1,2]),8,1); s:=sedz+' ';
ConvertStr(am[1,1]*ai[1,2]+(am[1,2]*ai[2,2]),8,1); s:=s+sedz+' ';
ConvertStr(am[1,2]*ai[1,1]+(am[2,2]*ai[1,2]),8,1); s:=s+sedz+' ';
ConvertStr(am[1,2]*ai[1,2]+(am[2,2]*ai[2,2]),8,1); s:=s+sedz+' ';
ShowMess(s);}
MakeFormV(250,20,330,430,0); WITH LB1rec DO {Output}
 BEGIN nitems:=7+n;
 ConvertStr(ch,8,3); ar[1]:=' chi^2= '+sedz;
 ConvertStr(chp,8,3); ar[1]:=ar[1]+'   chi2+= '+sedz;
 ConvertStr(a,10,5); s:=sedz; ConvertStr(SQRT(ai[2,2]),10,5);
 ar[2]:=' a= '+s+' +- '+sedz;
 ConvertStr(b,10,5); s:=sedz; ConvertStr(SQRT(ai[1,1]),10,5);
 ar[3]:=' b= '+s+' +- '+sedz;
 ConvertStr(ai[1,2]/SQRT(ai[1,1]*ai[2,2]),10,5); ar[4]:=' corr= '+sedz;
 ar[5]:=' ';
 ar[6]:='    X       Y       F     dif   chi^2  err ';
 ar[7]:=' ';
 FOR i:=1 TO n DO WITH arr[i] DO
  BEGIN s:=''; ConvertStr(x,6,0); s:=s+sedz;
  ConvertStr(y,8,2); s:=s+sedz; z:=x-x0;
  ConvertStr(a*z+b,8,2); s:=s+sedz;
  ConvertStr(y-a*z-b,8,2); s:=s+sedz;
  ConvertStr(SQR((y-a*z-b)/dy),7,2); s:=s+sedz;
  ConvertStr(dy,5,0); s:=s+sedz;
  ar[i+7]:=s;
  END;
 END;
MakeListBox(5,40,315,320); Form2.ShowModal;
FOR i:=1 TO n DO WITH arr[i] DO dy:=SQRT(dy*dy+SQR(a*dx));
UNTIL ni=2;
END;
{PROCEDURE TForm1.Test2Click(Sender: TObject);
VAR i,N,m,mo,ilo:INTEGER;
    u,tv,bb,p0,es,e,tp,r1,r2,T,B,p,v,r,l,pim,pal,psf,ptot:REAL;
CONST star:ARRAY[1..3] OF STRING = (
           'Uniform - uniform',
           'Uniform - exponential',
           'Exponential - exponential');
BEGIN TestMutations; TestRatio; TestMRAL;TestAuPar;
Case1Event;
END;}
PROCEDURE arexp(VAR yy,ww,v:REAL; jp,typ:INTEGER);
VAR i:INTEGER; x,A,B,W,T:REAL;
 FUNCTION ex(xx:REAL):REAL;
 BEGIN ex:=EXP(-xx/T);
 END;
 FUNCTION ef(xx:REAL):REAL;
 BEGIN ef:=erf(xx/W);
 END;
BEGIN x:=jp/10; A:=pold[1]; T:=pold[2]; W:=pold[3]; B:=pold[4];
{ef:=erf(x/W); ex:=EXP(-x/T);
v:=A/T*W*ex*ef+B;
yy:=A/T*ex*(ef-EXP(-SQR(x/W)/2)*x/W/SQRT(2*pi)/2);
ww:=(A/T*(W+0.00001)*ex*ef+B-v)/0.00001;
v:=A/T*W*ex(x)*ef(x)+B;
yy:=A/T*W*ex(x)*(-ef(x)/T+EXP(-SQR(x/W)/2)*x/W/SQRT(2*pi));
ww:=(A/T*(W+0.00001)*ex*ef+B-v)/0.00001;}
v:=erf(x); ww:=(erf(x+0.00001)-erf(x))/0.0001;
yy:=EXP(-SQR(x)/2)/{SQRT(2*pi)/}10;
END;

PROCEDURE TForm1.TestMor1Click(Sender: TObject);
VAR   i,j,km:INTEGER; f,R,A,B,si,t_0,T12,ds,t,s,yy,w,v:REAL;
LABEL Lagain;
BEGIN
{***} L0rec:=''; MakeFormV(250,20,330,430,0);
{pold[1]:=1000;
pold[2]:=20;
pold[3]:=10;
pold[4]:=100;
s:=0;
FOR i:=0 TO 100 DO
 BEGIN arexp(yy,w,v,i,4); Writeln(fout,i:5,v:10:3,w:10:3,yy:10:3);
 END;
Writeln(fout,s:8:3,SQRT(2*pi):8:3);}
{j:=201; FOR i:=-100 TO 100 DO
 BEGIN t:=i/20; myerf(t,s,ds); onl[i+101]:=s; onl[i+302]:=ds;
 END;}
A:=1000; B:=10; T12:=100; si:=15; t_0:=51;
Lagain: R:=si*si/T12; j:=500;
km:=Round(t_0); v:=0; FOR i:=1 TO 500 DO
 BEGIN t:=i/T12; myerf((Float(i)-R-t_0)/si,s,ds);
 f:=0; IF(i>=Round(t_0))THEN f:=A*EXP(-t); onl[i]:=f*s+B;
 onl[i+j]:=i/Float(3);
 IF(onl[i]>v)THEN
  BEGIN v:=onl[i]; km:=i;
  END;
 Writeln(fout,i:5,onl[i]:9:1);
 END;
strgrW[0]:=80; strgrW[1]:=90;
strgrT[1]:='T1/2='; strgrNn[1,1]:=T12;
strgrT[2]:='si=  '; strgrNn[2,1]:=si;
strgrT[3]:='t_0= '; strgrNn[3,1]:=t_0;
strgrT[4]:='A=   '; strgrNn[4,1]:=A;
GraphSpecAndModel(Form2.Image1,j,1,0);
PuttoTable(80,289,4,4,1,8);
OuttoLabel(Form2.Label2,5,380,clGreen,clWhite,'Ch= '+IntToStr(km));
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
FOR i:=1 TO 4 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]); {c,r}
T12:=har[1]; si:=har[2]; t_0:=har[3]; A:=har[4];
GOTO Lagain;
END;
PROCEDURE TForm1.TestDeconvol1Click(Sender: TObject);
BEGIN TestDeconvolution;
END;
PROCEDURE TForm1.TestAnisotropy1Click(Sender: TObject);
BEGIN TestAnisotropy;
END;

PROCEDURE TForm1.Showeres1Click(Sender: TObject);        {HELP}
BEGIN ViewResFile;
END;

                        {***}
PROCEDURE OpenAT(VAR fn1,fn2:STRING);
BEGIN fn1:='\zlok\a.sav';
L1rec:=' Enter the input file name '; GetFilename(fn1,0);
IF(ModalRes=0)THEN Exit;
fn2:='\zlok\t.sav';
L1rec:=' Enter the output file name '; GetFilename(fn2,1);
IF(ModalRes=0)THEN Exit;
END;

PROCEDURE ExecuteSQLCommand(CONST Q:TQuery; CONST s:STRING);
BEGIN WITH Q DO TRY
 Close; SQL.Clear; SQL.Add(s); Open;
 EXCEPT
 ON EDataBaseError DO ExecSQL;
 END;
END;



END.
