UNIT vmria2;

INTERFACE

USES Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
     Dialogs, StdCtrls, ExtCtrls, Grids,   vzlocom,  vmriahlp,
     vgfit,   CheckLst, vstdcons, vmria3,  Gauges,   vmria00;

TYPE
  TForm2 = CLASS(TForm)
    {OK}Button1: TButton;
    {Cancel}Button2: TButton;
    {Help}Button3: TButton;
    {Direct lat.par}Button4: TButton;
    {Stop fit}Button5: TButton;
    {Save}Button6: TButton;
    {Calculate}Button7: TButton;
    {For Four.synth.}Button8: TButton;
    {Browse}Button9: TButton;
    {Show Space Group}Button10: TButton;
    {Find Space Group}Button11: TButton;
    {Save Fourier}Button12: TButton;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    CheckListBox1: TCheckListBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Memo1: TMemo;
    RadioGroup2: TRadioGroup;
    ComboBox1: TComboBox;
    ListBox1: TListBox;
    RadioGroup1: TRadioGroup;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Timer1: TTimer;
    PROCEDURE Button1Click(Sender: TObject);
    PROCEDURE Button2Click(Sender: TObject);
    PROCEDURE Button3Click(Sender: TObject);
    PROCEDURE Button4Click(Sender: TObject);
    PROCEDURE Button5Click(Sender: TObject);
    PROCEDURE Button6Click(Sender: TObject);
    PROCEDURE Button7Click(Sender: TObject);
    PROCEDURE Button8Click(Sender: TObject);
    PROCEDURE Button9Click(Sender: TObject);
    PROCEDURE Button10Click(Sender: TObject);
    PROCEDURE Timer1Timer(Sender: TObject);
    PROCEDURE Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    PROCEDURE FormCreate(Sender: TObject);
    PROCEDURE FormKeyPress(Sender: TObject; VAR Key: Char);
    PROCEDURE Button11Click(Sender: TObject);
    PROCEDURE Button12Click(Sender: TObject);
  PRIVATE
    { Private declarations }
  PUBLIC
    { Public declarations }
  END;


PROCEDURE ActivateForm2(ix,iw,ih:LONGINT);
PROCEDURE MakeListBox(ix,it,iw,ih:LONGINT);
PROCEDURE MakeHeader(cl:LONGINT);
PROCEDURE MakeRadioGroup(ng,m,x,y,w,h:LONGINT);
PROCEDURE MakeCheckListBox(ix,it,iw,ih:LONGINT);
PROCEDURE MaketheButtons(x,y,w:INTEGER);
PROCEDURE MakeEdits(x1,x2,y,w,n:INTEGER);
PROCEDURE MakeCombo(x,y,w:LONGINT);
PROCEDURE GetFilename(VAR fn:STRING; mo:INTEGER);
PROCEDURE ClearParArea;
PROCEDURE MakeForm(bla:INTEGER);
PROCEDURE MakeFormV(x,y,w,h,bm:INTEGER);
PROCEDURE MakeBevel(x,y,w,h,i:INTEGER);
PROCEDURE MakeMemo(x,w:INTEGER);
PROCEDURE MakeHelp(m:INTEGER);
PROCEDURE StringOut(CONST s:STRING; mo:INTEGER);
PROCEDURE MakeCurrInfo;
PROCEDURE PuttoTable(x,t,nf,n,mm,ndig:LONGINT);
PROCEDURE MakeTxtFile(VAR ifn:STRING);
PROCEDURE ShowInfo(CONST s:STRING);

VAR Form2: TForm2;
    N_calc:INTEGER; {number for calculation button}
IMPLEMENTATION
USES vmria1;
{$R *.DFM}

PROCEDURE TForm2.FormCreate(Sender: TObject);
BEGIN KeyPreview:=true;
END;
PROCEDURE TForm2.FormKeyPress(Sender: TObject; VAR Key: Char);
BEGIN IF(Key=#27)THEN Button2Click(Self);
END;
PROCEDURE TForm2.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
VAR xx,yy,v:REAL; xc,yc:INTEGER;
BEGIN WITH frec DO
CASE nreac2 OF
1: BEGIN xc:=Round(Float(x)/scrsize); yc:=Round(Float(y)/scrsize);
   IF((NOT infun(xc,125,279))AND(NOT infun(yc,25,180)))THEN Exit;
   xx:=Float((xc-130))/5; yy:=Float((175-yc))/5;
   xc:=MIN1(31,AMAX1(1,xx)); yc:=MIN1(31,AMAX1(1,yy));
   xx:=xc*dx+x0; yy:=yc*dy+y0;
   ConvertStr(xx,6,2); s:=sedz; ConvertStr(yy,6,2); s:=s+sedz;
   Image1.Canvas.TextOut(exs(5),exs(70),'X,Y= '+s);
   v:=amap[xc,yc,zc];
   Image1.Canvas.TextOut(exs(5),exs(90),'Ampl= '+FltoSt(v,2));
   END; {x,y on Fourier synthesis map}
ELSE END;
END;
PROCEDURE MakeHeader(cl:LONGINT);
BEGIN WITH Form2.Font DO
 BEGIN Color:=cl; Style:=[fsBold]; Pitch:=fpFixed; Size:=fntsize;
 Form2.Caption:=' '+L0rec;
 END;
END;
PROCEDURE TForm2.Timer1Timer(Sender: TObject);
BEGIN Timer1.Interval:=0; click1:=true;
END;
PROCEDURE TForm2.Button1Click(Sender: TObject);
BEGIN Close; ModalRes:=1;
END;
PROCEDURE TForm2.Button2Click(Sender: TObject);
BEGIN Close; ModalRes:=0;
END;
PROCEDURE TForm2.Button3Click(Sender: TObject);
BEGIN Button1.Enabled:=false; Button2.Enabled:=false;
Button3.Enabled:=false; MakeHelp(0);
END;
PROCEDURE TForm2.Button4Click(Sender: TObject); {Show Direct Lattice}
VAR i,iph,i0:INTEGER; s:STRING;
BEGIN Button1.Enabled:=false; Button2.Enabled:=false;
Button3.Enabled:=false; ActivateForm3(0,300,450,true);
WITH Form3.Memo1 DO
 BEGIN Font.Color:=clAqua; Font.Style:=[fsBold]; Font.Size:=fntsize;
 Clear; Font.Pitch:=fpFixed; Left:=0; Top:=0; Width:=exs(280);
 FOR iph:=1 TO nph DO
  BEGIN Lines.Add(' UNIT CELL,  PHASE '+IntToStr(iph));
  GetDirCellPars(iph); IF(ModalRes=0)THEN CONTINUE;
  s:=''; FOR i:=1 TO 3 DO WITH lpa[i] DO
   BEGIN ConvertStr(a,9,4); s:=s+sedz;
   END;
  Lines.Add(s); s:=''; FOR i:=1 TO 3 DO WITH lpa[i] DO
   BEGIN ConvertStr(b,9,4); s:=s+sedz;
   END;
  Lines.Add(s); s:=''; FOR i:=1 TO 3 DO WITH lpa[i] DO
   BEGIN ConvertStr(c,9,4); s:=s+sedz;
   END;
  Lines.Add(s); s:=''; FOR i:=1 TO 3 DO WITH lpa[i] DO
   BEGIN ConvertStr(alpha,9,2); s:=s+sedz;
   END;
  Lines.Add(s); s:=''; FOR i:=1 TO 3 DO WITH lpa[i] DO
   BEGIN ConvertStr(beta,9,2); s:=s+sedz;
   END;
  Lines.Add(s); s:=''; FOR i:=1 TO 3 DO WITH lpa[i] DO
   BEGIN ConvertStr(gamma,9,2); s:=s+sedz;
   END;
  Lines.Add(s); Lines.Add(' ');
  END;
 FOR iph:=1 TO nph DO IF((magfl)AND(keyma[iph]=1))THEN
  BEGIN Lines.Add(' MAGNETIC ANGLES, PHASE '+IntToStr(iph));
  GetMagMomAngles(iph,1);
  FOR i:=1 TO 3 DO
   BEGIN ConvertStr(har[i],18,2);
   Lines.Add(sedz);
   END;
  Lines.Add(' ');
  END;
 Form3.Button1.Default:=true;
 s:='For changing use the key Rietveld_Fit';
 OuttoLabel(Form3.Label1,5,370,clMaroon,clWhite,s);
 Form3.ShowModal;
 END;
WITH Form2 DO
 BEGIN Button1.Enabled:=true; Button2.Enabled:=true;
 Button3.Enabled:=true;
 END;
END;
PROCEDURE TForm2.Button5Click(Sender: TObject); {Stop}
BEGIN gfit.v_stop:=true;
END;
PROCEDURE TForm2.Button6Click(Sender: TObject); {Save}
VAR i:INTEGER;
BEGIN IF(ListBsav)THEN Exit; s:=Form2.Caption; Writeln(fout,s);
WITH Form2.ListBox1 DO FOR i:=0 TO Items.Count-1 DO
 Writeln(fout,Items[i]); ListBsav:=true;
END;
PROCEDURE TForm2.Button7Click(Sender: TObject); {Show N of tries}
VAR i,itr,n:INTEGER;
BEGIN s:=' Total N of tries= '; WITH Form2 DO
 BEGIN FOR i:=1 TO 7 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 IF(NOT ok)THEN Exit; n:=Round(har[7]);
 itr:=1; FOR i:=1 TO 6 DO itr:=itr*MAX0(1,Round(ABS(har[i])));
 OuttoLabel(Label6,108,241,clMaroon,clWhite,s+IntToStr(itr*n)+' ');
 END;
END;
PROCEDURE TForm2.Button8Click(Sender: TObject);
BEGIN Close;
CASE nreac2 OF
1: frec.zc:=frec.zc-2; {Four.synth.map viewing back}
ELSE END;
END;
PROCEDURE TForm2.Button9Click(Sender: TObject);  {Browse while output}
BEGIN SaveDm:=true; Close;
END;
PROCEDURE TForm2.Button10Click(Sender: TObject); {Show Space Group}
VAR i,j:INTEGER; s:STRING;
BEGIN WITH Form2.StringGrid1 DO WITH lat[iph_gl] DO
 BEGIN Zval(Cells[0,0],har[1]); Zval(Cells[0,1],har[2]);
 nsg:=Round(har[1]); sett:=Round(har[2]);
 END;
SetSpaceGroupInfo(iph_gl); IF(ModalRes=0)THEN Exit;
WITH lat[iph_gl] DO WITH LB1rec DO WITH Form3 DO
 BEGIN Caption:='Space group '+IntToStr(nsg)+' information';
 ActivateForm3(5,450,450,true); WITH Memo1.Lines DO
  BEGIN s:='Centrosymmetric'; IF(csym=0)THEN s:='non '+s;
  s:=nlatar[nlatt+1]+'-lattice,  '+s; Add(s);
  s:=schoe+'  '+stand; Add(s);
  s:='   Translation vectors,  '+IntToStr(ntlv)+' item[s]'; Add(s);
  FOR i:=1 TO ntlv DO
   BEGIN s:=''; FOR j:=1 TO 3 DO
    BEGIN ConvertStr(tlv[j,i],5,2); s:=s+sedz;
    END;
   Add(s);
   END;
  s:='   Transformations ('+IntToStr(nut)+' item[s])'; Add(s);
  FOR i:=1 TO nut DO
   BEGIN ftrstr(i,iph_gl,s); Add(s);
   END;
  ShowModal;
  END;
 END;
END;
PROCEDURE TForm2.Button11Click(Sender: TObject);  {Find space group}
VAR i,j:INTEGER; s:STRING;
BEGIN s:=Form2.StringGrid1.Cells[0,0]; Compress(s);
FindSpaceGroup(s,i); IF(ModalRes=0)THEN Exit;
ConvertStr(Float(i),5,0); Form2.StringGrid1.Cells[0,0]:=sedz;
ShowMess('Group '+s+crc+'Space group= '+IntToStr(i)+
 ', setting= 1 or 2');
END;
PROCEDURE TForm2.Button12Click(Sender: TObject);
VAR i,j:INTEGER;
BEGIN Writeln(fout,Form2.Caption);
WITH frec DO Writeln(fout,'Z= ',z0+(zc-1)*dz:8:2);
Writeln(fout,'Fourier XY-plane (30 x 30)');
FOR j:=1 TO 30 DO
 BEGIN FOR i:=1 TO 30 DO Write(fout,amap[i,j,frec.zc]:7:1);
 Writeln(fout);
 END;
Writeln(fout);
END;
{PROCEDURE TForm2.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
BEGIN IF(Key=VK_RETURN)THEN Form2.Button1Click(Self);
END;}
PROCEDURE StringOut(CONST s:STRING; mo:INTEGER);
BEGIN IF(mo=2)THEN Form2.Memo1.Lines.Add(s)
              ELSE Writeln(fout,s);
END;
PROCEDURE MakeCurrInfo;
BEGIN ActivateForm2(300,250,150); Form2.Top:=exs(100);
IF(dispbut)THEN MaketheButton(Form2.Button5,90,90,70,20,'STOP');
END;
{PROCEDURE TForm2.FormActivate(Sender: TObject);
BEGIN IF(Edit1.Visible)THEN Edit1.SetFocus;
END;}
PROCEDURE MakeHelp(m:INTEGER);
VAR i:INTEGER;
BEGIN ActivateForm3(0,590,450,true); WITH Form3 DO
 BEGIN FOR i:=1 TO MIN0(lhelp,100) DO Memo1.Lines.Add(helpa[i]);
 Button1.Default:=true; Label1.Visible:=false;
 IF(m=1)THEN
  OuttoLabel(Form3.Label1,330,393,clMaroon,clWhite,' To be continued ');
 ShowModal;
 END;
ok:=true; WITH Form2 DO
 BEGIN Button1.Enabled:=ok; Button2.Enabled:=ok; Button3.Enabled:=ok;
 END;
END;
PROCEDURE ClearParArea;
BEGIN WITH Form2.Image1.Canvas DO
 BEGIN Brush.Color:=0; Font.Color:=clTeal; Font.Size:=fntsize;
 Font.Style:=[fsBold]; FillRect(Rect(0,0,exs(310),exs(290)));
 END;
Form2.Image1.Visible:=true;
END;
PROCEDURE GetFilename(VAR fn:STRING; mo:INTEGER);
{mo=0 - file name for reading
    1 - file name for writing
    2 - get a string }
VAR   s:STRING; i:INTEGER;
LABEL L1;
BEGIN s:=fn; IF(mo>=1)THEN GOTO L1;     {Read}
fn:=ExtractFileName(s); i:=Pos(s,fn); IF(i<>0)THEN Delete(s,i,100);
ModalRes:=1; WITH Form2.OpenDialog1 DO
 BEGIN Title:=L0rec; FileName:=fn; InitialDir:=s;
 Options:=Options-[ofAllowMultiSelect];
 IF(Execute)THEN s:=FileName
            ELSE
  BEGIN ModalRes:=0; Exit;
  END;
 Compress(s);
 IF(NOT FileExists(s))THEN
  BEGIN ShowMess('No file '+s); ModalRes:=0;
  END                 ELSE fn:=s;
 END;
Exit;
L1: MakeForm(0); {Write}
IF((L1rec='')OR(L1rec=' '))THEN L1rec:='Enter filename';
OuttoLabel(Form2.Label1,5,30,clMaroon,clWhite,L1rec);
MakeEdit(Form2.Edit1,30,50,260,fn);
Form2.ShowModal; IF(ModalRes=0)THEN Exit; fn:=Form2.Edit1.Text;
IF(mo=2)THEN Exit;               {String}
Compress(fn); ExtractFN(fn,sedz); IF(Length(sedz)=0)THEN
 BEGIN ShowMess('Wrong filename'); ModalRes:=0;
 END;
IF(NOT OWriteFile(fn))THEN ModalRes:=0;
END;
PROCEDURE ActivateForm2(ix,iw,ih:LONGINT);
BEGIN WITH Form2 DO
 BEGIN Close; Left:=exs(Form1.Top+ix); Top:=exs(Form1.Top+20);
 Width:=exs(iw); Height:=exs(ih); Caption:=''; Color:=clGreen;
 Label1.Visible:=false; Label2.Visible:=false; Label3.Visible:=false;
 Label4.Visible:=false; Label5.Visible:=false; Label6.Visible:=false;
 Label7.Visible:=false; Label8.Visible:=false; Label9.Visible:=false;
 Label10.Visible:=false;
 Button1.Visible:=false; Button2.Visible:=false; Button3.Visible:=false;
 Button4.Visible:=false; Button5.Visible:=false; Button6.Visible:=false;
 Button7.Visible:=false; Button8.Visible:=false; Button9.Visible:=false;
 Button10.Visible:=false; Button11.Visible:=false;
 Button12.Visible:=false;
 Edit1.Visible:=false; Edit2.Visible:=false; Edit3.Visible:=false;
 Edit4.Visible:=false;
 RadioGroup1.Visible:=false; RadioGroup2.Visible:=false;
 ListBox1.Visible:=false; ComboBox1.Visible:=false;
 CheckListBox1.Visible:=false; Memo1.Visible:=false;
 Image1.Visible:=false; Image2.Visible:=false; Image3.Visible:=false;
 StringGrid1.Visible:=false; StringGrid2.Visible:=false;
 {BorderIcons:=[];}
 Bevel1.Visible:=false; Bevel2.Visible:=false; Bevel3.Visible:=false;
 ModalRes:=1;
 END;
END;
PROCEDURE MakeBevel(x,y,w,h,i:INTEGER);
BEGIN WITH Form2 DO
CASE i OF
1: Make_Bevel(Bevel1,x,y,w,h);
2: Make_Bevel(Bevel2,x,y,w,h);
3: Make_Bevel(Bevel3,x,y,w,h);
ELSE END;
END;
PROCEDURE MakeFormV(x,y,w,h,bm:INTEGER);
VAR i:INTEGER;
BEGIN IF(bm=1)THEN ListBsav:=false; ActivateForm2(x,w,h);
MakeHeader(0); Form2.Color:=clGreen;
i:=(w DIV 2)-90; IF(bm=1)THEN i:=i-30; MaketheButtons(i,375,60);
IF(bm=1)THEN MaketheButton(Form2.Button6,i+185,375,60,20,'Save');
END;
PROCEDURE MakeForm(bla:INTEGER);
BEGIN MakeFormV(170,20,345,430,0);
IF(bla=0)THEN SaveHelp(blankH_n,blankH);
END;
PROCEDURE MakeMemo(x,w:INTEGER);
BEGIN Make_Memo(Form2.Memo1,x,w);
END;
PROCEDURE PuttoTable(x,t,nf,n,mm,ndig:LONGINT);
BEGIN
MakeStringGrid(Form2.StringGrid1,Form2.StringGrid2,x,t,nf,n,mm,ndig);
END;
PROCEDURE MakeRadioGroup(ng,m,x,y,w,h:LONGINT);
BEGIN IF(ng=1)THEN BuildRG(Form2.RadioGroup1,m,x,y,w,h)
              ELSE BuildRG(Form2.RadioGroup2,m,x,y,w,h);
END;
PROCEDURE MakeEdits(x1,x2,y,w,n:INTEGER);
BEGIN WITH Form2 DO
 BEGIN OuttoLabel(Label1,x1,y,clMaroon,clWhite,L1rec);
 MakeEdit(Edit1,x2,y-2,w,E1rec); IF(n<2)THEN Exit;
 OuttoLabel(Label2,x1,y+23,clMaroon,clWhite,L2rec);
 MakeEdit(Edit2,x2,y+21,w,E2rec); IF(n<3)THEN Exit;
 OuttoLabel(Label3,x1,y+46,clMaroon,clWhite,L3rec);
 MakeEdit(Edit3,x2,y+44,w,E3rec); IF(n<4)THEN Exit;
 OuttoLabel(Label4,x1,y+69,clMaroon,clWhite,L4rec);
 MakeEdit(Edit4,x2,y+67,w,E4rec);
 END;
END;
PROCEDURE MaketheButtons(x,y,w:INTEGER);
BEGIN WITH Form2 DO
 BEGIN MaketheButton(Button1,x,y,w,20,'OK');
 MaketheButton(Button2,x+w+2,y,w,20,'Cancel');
 MaketheButton(Button3,x+2*w+4,y,w,20,'Help');
 Button1.Default:=true;
 END;
END;
PROCEDURE MakeListBox(ix,it,iw,ih:LONGINT);
BEGIN Make_ListBox(Form2.ListBox1,ix,it,iw,ih);
END;
PROCEDURE MakeCheckListBox(ix,it,iw,ih:LONGINT);
BEGIN Make_CheckListBox(Form2.CheckListBox1,ix,it,iw,ih);
END;
PROCEDURE MakeCombo(x,y,w:LONGINT);
BEGIN MakeComboBox(Form2.ComboBox1,x,y,w);
END;
PROCEDURE MakeTxtFile(VAR ifn:STRING);
VAR i:INTEGER;
BEGIN L0rec:='Edit the file '+ifn+' if needed';
MakeFormV(10,20,620,430,0); SaveHelp(InfIniF_n,InfIniF);
MakeMemo(0,610); WITH Form2.Memo1 DO
 BEGIN Lines.LoadFromFile(ifn);
 Form2.ShowModal; IF(ModalRes=0)THEN Exit;
 i:=MessageDlg('Save the file?',MtWarning,[mbYes,mbNo],0);
 IF(i=mrYes)THEN Lines.SaveToFile(ifn) ELSE Exit;
 END;
END;
PROCEDURE ShowInfo(CONST s:STRING);
BEGIN ActivateForm3(250,350,450,false);
WITH Form3 DO
 BEGIN Memo1.Visible:=false;
 OuttoLabel(Label1,5,70,clMaroon,clWhite,s); ShowModal;
 END;
END;

{---}

END.
