UNIT vdomfl;
INTERFACE
USES      vzlocom,  vdomus0, comctrls, Dialogs, SysUtils, Controls,
          Graphics, vdomus2, vdomhlp,  vstdcons;
PROCEDURE fismax3(m:INTEGER);
PROCEDURE Convolute;
PROCEDURE Read3Binary;
PROCEDURE ReadEffSpectrum;
PROCEDURE IDataIn;
PROCEDURE IDataOut;
PROCEDURE SaveRes;
PROCEDURE Setthebounds;
PROCEDURE Setthescale;
PROCEDURE SettheTOFData;
PROCEDURE abouttheSpectrum;
PROCEDURE aboutthePeaks;
PROCEDURE ToggletheFormSize;
IMPLEMENTATION
PROCEDURE ToggletheFormSize;
VAR i:INTEGER;
BEGIN L0rec:=''; MakeFormV(100,20,320,430,0);
s:='   Set the screen scale ';
OuttoLabel(Form2.Label1,50,32,clMaroon,clWhite,s);
WITH CB1rec DO
 BEGIN nitems:=3; indx:=2; ar[1]:='1'; ar[2]:='1.25'; ar[3]:='1.5';
 END;
{MakeRadioGroup(1,0,50,50,200,80);}
s:='   Set the font size ';
OuttoLabel(Form2.Label2,50,152,clMaroon,clWhite,s);
 WITH CB1rec DO
 BEGIN nitems:=3; indx:=3;
 ar[1]:=' Small (8)'; ar[2]:=' Regular (10)'; ar[3]:=' Large (12)';
 END;
{MakeRadioGroup(2,0,50,170,200,80);}
WITH CB1rec DO
 BEGIN nitems:=1;
 ar[1]:=' Use Russian Helps';
 END;
MakeCheckListBox(50,280,200,20);
Form2.CheckListBox1.Checked[0]:=RusHelp;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit; i:=RadioGroup1.ItemIndex;
 RusHelp:=CheckListBox1.Checked[0];
 {CASE i OF
 0: scrsize:=1;
 1: scrsize:=1.25;
 2: scrsize:=1.5;
 ELSE END;
 i:=RadioGroup2.ItemIndex;
 CASE i OF
 0: fntsize:=8;
 1: fntsize:=10;
 2: fntsize:=12;
 ELSE END;}
 END;
END;
PROCEDURE IDataIn;
VAR   i:INTEGER; comm:STRING[11]; r:REAL;
LABEL Lend;
BEGIN GetFilename(inifn,0); IF(ModalRes=0)THEN Exit;
AssignFile(ft,inifn); Reset(ft);
WHILE(NOT EoF(ft))DO
 BEGIN EnterStr(ft); s:=sedz;
 comm:=''; FOR i:=1 TO Length(s) DO
  IF(s[i] IN ['A'..'Z'])THEN comm:=comm+s[i];
 IF(comm='STOP')THEN GOTO Lend;
 EnterStr(ft); FCompress(sedz); s:=sedz; r:=0;
 IF((comm<>'SSN')AND(comm<>'SESN'))THEN ZVal(s,r);
 IF(comm='SSN')THEN sfn:=sedz;
 IF(comm='SESN')THEN esfn:=sedz;
 IF(comm='BN')THEN i1:=Round(r);
 IF(comm='BN')THEN i1:=Round(r);
 IF(comm='EN')THEN i2:=Round(r);
 IF(comm='BX')THEN j1:=Round(r);
 IF(comm='EX')THEN j2:=Round(r);
 IF(comm='BY')THEN k1:=Round(r);
 IF(comm='EY')THEN k2:=Round(r);
 IF(comm='FP')THEN Fp:=r;
 IF(comm='DELAY')THEN delay:=r;
 IF(comm='CW')THEN chw:=r;
 IF(comm='TH')THEN Bra:=r*2; {2 theta}
 IF(comm='DX')THEN dthx:=r;
 IF(comm='DY')THEN dthy:=r;
 IF(comm='LC')THEN lm:=r;
 IF(comm='LS')THEN rl:=r;
 IF(comm='SENS')THEN sens:=r;
 IF(comm='RES')THEN res:=r;
 IF(comm='WNX')THEN wxxu:=r;
 IF(comm='WXX')THEN wyyu:=r;
 IF(comm='WYX')THEN wzzu:=r;
 IF(comm='WNN')THEN wxxl:=r;
 IF(comm='WXN')THEN wyyl:=r;
 IF(comm='WYN')THEN wzzl:=r;
 IF(comm='HVM')THEN hvmin:=r;
 END;
Lend:;
CloseFile(ft);
AssignFile(ft,vddir+'\vdomus.fn'); Rewrite(ft); Writeln(ft,inifn);
CloseFile(ft);
END;
PROCEDURE aboutthePeaks;
VAR i,k:INTEGER; a,th,d:REAL; s:STRING;
BEGIN IF(npk=0)THEN
  BEGIN ShowMessage('No peaks '); Exit;
  END;
L0rec:='Peak information'; MakeFormV(0,20,610,430,1);
ListBsav:=false; WITH LB1rec DO
 BEGIN ar[1]:=
  '     N       X     Y       V      Wx    Wy    Wz  L curr. theta   d';
 ar[2]:='';
 FOR i:=1 TO npk DO WITH pkar[i] DO
  BEGIN s:=''; ConvertStr(x,8,2); s:=s+sedz; ConvertStr(y,8,2);
  s:=s+sedz; ConvertStr(z,6,2); s:=s+sedz; ConvertStr(V,8,0); s:=s+sedz;
  ConvertStr(wx,8,2); s:=s+sedz; ConvertStr(wy,6,2); s:=s+sedz;
  ConvertStr(wz,6,2); s:=s+sedz;
  computeD(x,y,z,a,th,d); ConvertStr(a,6,2); s:=s+sedz;
  ConvertStr(th*radian,7,2); s:=s+sedz; ConvertStr(d,8,4);
  ar[i+2]:=s+sedz;
  END;
 ar[npk+3]:='';
 ar[npk+4]:='     Total = '+IntToStr(npk)+' peaks';
 nitems:=npk+4;
 END;
MakeListBox(5,5,590,320); Form2.ListBox1.MultiSelect:=true;
WITH CB1rec DO
 BEGIN nitems:=1; ar[1]:=' Delete the marked peaks';
 END;
MakeCheckListBox(155,340,300,20); Form2.CheckListBox1.Checked[0]:=false;
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 IF(CheckListBox1.Checked[0])THEN FOR i:=2 TO npk+1 DO
   IF(ListBox1.Selected[i])THEN pkar[i-1].x:=-1;
 k:=0; FOR i:=1 TO npk DO IF(pkar[i].x<>-1)THEN
  BEGIN Inc(k); pkar[k]:=pkar[i];
  END;
 npk:=k;
 END;
IF(ListBsav)THEN nosaved:=false;
END;
PROCEDURE abouttheSpectrum;
VAR i:INTEGER; s:STRING;
BEGIN L0rec:='Spectrum information'; MakeFormV(200,20,330,430,1);
WITH LB1rec DO
 BEGIN s:=ExtractFileName(sfn); ar[1]:=' Spectrum= '+s;
 i:=Pos(s,sfn); s:=sfn; IF(i<>0)THEN Delete(s,i,255);
 ar[2]:=' Path = '+s; s:=ExtractFileName(esfn);
 ar[3]:=' Eff. spectrum= '+s; i:=Pos(s,esfn); s:=esfn;
 IF(i<>0)THEN Delete(s,i,255); ar[4]:=' Path = '+s;
 ConvertStr(spx,10,0); ar[5]:=' Max in spectrum= '+sedz;
 ConvertStr(espx,10,0); ar[6]:=' Max in eff. spectrum= '+sedz;
 ar[7]:='';
 s:='corrected for effective spectrum'; IF(noefsc)THEN s:='not '+s;
 ar[8]:=s;
 s:='reversed to reciprocal space'; IF(norevers)THEN s:='not '+s;
 ar[9]:=s; ar[10]:='';
 ar[11]:='N-bounds '+IntToStr(i1)+' - '+IntToStr(i2);
 ar[12]:='X-bounds '+IntToStr(j1)+' - '+IntToStr(j2);
 ar[13]:='Y-bounds '+IntToStr(k1)+' - '+IntToStr(k2); i:=13;
 IF(NOT norevers)THEN
  BEGIN Inc(i); ar[i]:='';
  Inc(i); ar[i]:='      Reversed bounds';
  Inc(i); ar[i]:='N-bounds '+IntToStr(mN1)+' - '+IntToStr(mN2);
  Inc(i); ar[i]:='X-bounds '+IntToStr(mx1)+' - '+IntToStr(mx2);
  Inc(i); ar[i]:='Y-bounds '+IntToStr(my1)+' - '+IntToStr(my2);
  END;
 nitems:=i;
 END;
MakeListBox(5,10,310,320); Form2.ShowModal;
END;
PROCEDURE fismax3(m:INTEGER);
{***  Purpose: To find the maximum of the spectrum Version: Jan 6 2000}
VAR i,j,k:INTEGER; sn,r:REAL;
BEGIN sn:=-1E10;
FOR k:=k1 TO k2 DO FOR j:=j1 TO j2 DO FOR i:=i1 TO i2 DO
 BEGIN CASE m OF
 0: r:=sp[i,j,k];
 1: r:=esp[i,j,k];
 2: r:=ssp[i,j,k];
 ELSE END;
 IF(r > sn)THEN sn:=r;
 END;
CASE m OF
0: snor:=sn;
1: espx:=sn;
2: aspx:=sn;
ELSE END;
spx:=CompCurrMax(snor);
END;
PROCEDURE Convolute;
BEGIN ConvoluteTheSpectrum(csnor,0); ConvoluteTheSpectrum(cynor,1);
ConvoluteTheSpectrum(cxnor,2);
END;
PROCEDURE Read3Binary;
{Purpose: To read in binary 3-dim files, Dec 3 1999}
VAR  res,i,j,k,ir,ii:INTEGER; fb:FILE OF INTEGER;
     kk,il:LONGINT;
BEGIN AssignFile(fb,sfn); Reset(fb);
FOR ir:=1 TO 1024 DO
 BEGIN FOR j:=1 TO 256 DO buf2[j]:=0; BlockRead(fb,buf2,128,res);
 kk:=(ir-1)*256; FOR ii:=1 TO 256 DO
  BEGIN il:=kk+ii; ComputeXYZ(il,i,j,k); sp[i,j,k]:=buf2[ii];
  END;
 END;
CloseFile(fb);
fismax3(0);
Writeln(fout,'Spectrum '+sfn+' has been input');
END;
PROCEDURE ReadEffSpectrum;
VAR  res,i,j,k,ir,ii:INTEGER; fb:FILE OF INTEGER; kk,il:LONGINT;
BEGIN AssignFile(fb,esfn); Reset(fb);
FOR ir:=1 TO 1024 DO
 BEGIN FOR j:=1 TO 256 DO buf2[j]:=0; BlockRead(fb,buf2,128,res);
 kk:=(ir-1)*256; FOR ii:=1 TO 256 DO
  BEGIN il:=kk+ii; ComputeXYZ(il,i,j,k); esp[i,j,k]:=buf2[ii];
  END;
 END;
CloseFile(fb);
fismax3(1);
Writeln(fout,'Effective spectrum '+esfn+' has been input');
END;
PROCEDURE IDataOut;
VAR i:INTEGER; ft:TEXTFILE;
BEGIN AssignFile(ft,'vdomus.ini'); Rewrite(ft);
onl[1]:=i1; onl[2]:=i2; onl[3]:=j1; onl[4]:=j2; onl[5]:=k1; onl[6]:=k2;
onl[7]:=Fp; onl[8]:=delay; onl[9]:=chw; onl[10]:=Bra;
onl[11]:=dthx; onl[12]:=dthy; onl[13]:=lm;
onl[14]:=rl; onl[15]:=sens; onl[16]:=res;
onl[17]:=wxxu; onl[18]:=wxxl;
onl[19]:=wyyu; onl[20]:=wyyl;
onl[21]:=wzzu; onl[22]:=wzzl;
onl[23]:=hvmin;
onl[24]:=0; onl[25]:=0;
Writeln(ft,'*        VDOMUS ini-file');
Writeln(ft,'...Spectrum File Name');
Writeln(ft,sfn);
Writeln(ft,'...Effective Spectrum File Name');
Writeln(ft,esfn);
FOR i:=1 TO 25 DO
 BEGIN Writeln(ft,inicomm[i]); ConvertStr(onl[i],12,4);
 Writeln(ft,sedz);
 END;
Writeln(ft,'...STOP');
CloseFile(ft);
END;
PROCEDURE SaveRes;
VAR  i:INTEGER; a,th,d:REAL;
BEGIN IF(npk=0)THEN
 BEGIN ShowMess('No peaks analyzed'); Exit;
 END;
Writeln(fout,
'*   Results of VDOMUS analysis,  ',npk:4,' peaks processed');
Writeln(fout,'*');
Writeln(fout,
 '* i   N     x    y    Volume   Wx    Wy    Wz  theta    d');
FOR i:=1 TO npk DO WITH pkar[i] DO
 BEGIN computeD(x,y,z,a,th,d);
 Writeln(fout,i:3,x:5:0,y:5:0,z:5:0,V:9:0,wx:6:2,wy:6:2,wz:6:2,
  th*radian:7:2,d:8:4);
 END;
nosaved:=false; ShowMess('Results have been saved');
END;
PROCEDURE Setthebounds;
VAR   i:INTEGER;
LABEL Lerr;
BEGIN L0rec:='Set the bounds'; MakeFormV(200,20,330,430,0);
SaveHelp(SetSpB_n,SetSpB); s:=' Set the bounds for spectrum dimensions';
OuttoLabel(Form2.Label5,5,30,clGreen,clWhite,s);
strgrW[0]:=100; strgrW[1]:=80; strgrW[2]:=80;
strgrT[1]:=' t1 - t2'; strgrNn[1,1]:=i1; strgrNn[1,2]:=i2;
strgrT[2]:=' x1 - x2'; strgrNn[2,1]:=j1; strgrNn[2,2]:=j2;
strgrT[3]:=' y1 - y2'; strgrNn[3,1]:=k1; strgrNn[3,2]:=k2;
PuttoTable(40,50,4,3,2,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 FOR i:=1 TO 3 DO Zval(Form2.StringGrid1.Cells[1,i-1],har[i+3]);
 END;
IF(NOT(rinfun(har[1],1,1024)))THEN GOTO Lerr;
IF(NOT(rinfun(har[4],1,1024)))THEN GOTO Lerr;
IF(har[1]>har[4])THEN GOTO Lerr;
i1:=Round(har[1]); i2:=Round(har[4]);
IF(NOT(rinfun(har[2],1,32)))THEN GOTO Lerr;
IF(NOT(rinfun(har[5],1,32)))THEN GOTO Lerr;
IF(har[2]>har[5])THEN GOTO Lerr;
j1:=Round(har[2]); j2:=Round(har[5]);
IF(NOT(rinfun(har[3],1,8)))THEN GOTO Lerr;
IF(NOT(rinfun(har[6],1,8)))THEN GOTO Lerr;
IF(har[3]>har[6])THEN GOTO Lerr;
k1:=Round(har[3]); k2:=Round(har[6]); Exit;
Lerr: ShowMess('Error in spectrum bounds');
END;
PROCEDURE Setthescale;
BEGIN L0rec:='Select the scale mode'; MakeFormV(200,20,330,430,0);
SaveHelp(SScaleM_n,SScaleM); WITH CB1rec DO
 BEGIN ar[1]:='Normal'; ar[2]:='SQRT'; ar[3]:='LN'; ar[4]:='Trimmed';
 nitems:=4; indx:=nscale;
 END;
MakeRadioGroup(1,0,70,30,160,120);
L1rec:='Trimming coefficient = '; ConvertStr(trimm,7,3); E1rec:=sedz;
MakeEdits(20,210,220,70,1);
Form2.ShowModal; IF(ModalRes=0)THEN Exit;
nscale:=Form2.RadioGroup1.ItemIndex+1; IF(nscale=4)THEN
 BEGIN Zval(Form2.Edit1.Text,r); IF(ModalRes=0)THEN
  BEGIN ShowMess('Wrong trimming'); Exit;
  END;
 trimm:=r;
 END;
END;
PROCEDURE SettheTOFData;
VAR   i:INTEGER;
LABEL Lerr;
BEGIN L0rec:='Set the TOF - Data'; MakeFormV(250,20,330,430,1);
SaveHelp(SetToF_n,SetToF);
strgrW[0]:=140; strgrW[1]:=100;
strgrT[1]:='FlightPath (m)'; strgrNn[1,1]:=Fp;
strgrT[2]:='Delay(chan)';    strgrNn[2,1]:=delay;
strgrT[3]:='Chan.Width(mks)'; strgrNn[3,1]:=chw;
strgrT[4]:='Theta0 (deg)';   strgrNn[4,1]:=Bra/2;
strgrT[5]:='dTheta X (deg)'; strgrNn[5,1]:=dthx;
strgrT[6]:='dTheta Y (deg)'; strgrNn[6,1]:=dthy;
strgrT[7]:='L basic  (m)';   strgrNn[7,1]:=lm;
PuttoTable(40,50,7,7,1,8);
WITH Form2 DO
 BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
 FOR i:=1 TO 7 DO Zval(Form2.StringGrid1.Cells[0,i-1],har[i]);
 END;
IF(har[1]<=0)THEN GOTO Lerr; Fp:=har[1]; delay:=har[2];
IF(har[3]<=0)THEN GOTO Lerr; chw:=har[3];
IF(har[4]<=0)THEN GOTO Lerr; Bra:=har[4]*2; dthx:=har[5]; dthy:=har[6];
IF(har[7]<=0)THEN GOTO Lerr; lm:=har[7];
noToF:=false; Exit;
Lerr: ShowMess('Error in TOF - data');
END;
{-----------------------------------------------}
BEGIN;
END.
