PROGRAM vdomus;

USES  Forms, Graphics, Dialogs, Controls, SysUtils, vdomus0, vzlocom,
      vstdcons, vspectr, vpeaksr, vpmodel,
  vdomus1 in 'vdomus1.pas' {Form1},
  vdomus2 in 'vdomus2.pas' {Form2},
  vdomhlp in 'vdomhlp.pas' {Form3};

{$R *.RES}
PROCEDURE CheckOutFN(VAR outfn:STRING; mo:INTEGER; st:STRING);
VAR i:INTEGER; s:STRING;
BEGIN L0rec:=''; L1rec:='Enter new res-file name';
IF(FileExists(outfn))THEN
 BEGIN MakeFormV(0,20,630,430,0); SaveHelp(blankH_n,blankH);
 OuttoLabel(Form2.Label1,15,70,clGreen,clWhite,'Output file: ');
 OuttoLabel(Form2.Label2,105,70,clMaroon,clWhite,outfn);
 OuttoLabel(Form2.Label3,15,87,clGreen,clWhite,st);
 WITH CB1rec DO
  BEGIN nitems:=3; indx:=3; IF(mo=1)THEN
   BEGIN nitems:=2; indx:=1;
   END;
  ar[1]:='Change the file name';
  ar[2]:='Abort';
  ar[3]:='Still go on';
  END;
 MakeRadioGroup(1,0,200,140,260,120);
 s:='Remark: the analysis results are saved in an output file';
 OuttoLabel(Form2.Label4,15,300,clGreen,clWhite,s);
 s:='Its default name= d.res';
 OuttoLabel(Form2.Label5,25,317,clGreen,clWhite,s);
 WITH Form2 DO
  BEGIN ShowModal; i:=RadioGroup1.ItemIndex;
  CASE i OF
  0: GetFilename(outfn,1);
  1: Application.Terminate;
  ELSE END;
  END;
 END;
END;

PROCEDURE Initialize;
VAR   i:INTEGER; s,ss:STRING;
LABEL L1;
BEGIN WITH Form1 DO
 BEGIN Left:=0; Top:=0; Width:=630; Height:=470;
 Caption:='  VISUAL DOMUS +++ 2006,      by Zlokazov V.B.';
 WITH Image1 DO
  BEGIN Left:=0; Top:=40; Width:=520; Height:=380;
  END;
 WITH Image1.Canvas DO
  BEGIN Font.Color:=clWhite; Font.Style:=[fsBold]; Font.Size:=8;
  END;
 WITH Image2 DO
  BEGIN Left:=0; Top:=0; Width:=620; Height:=40;
  END;
 WITH Image2.Canvas DO
  BEGIN Font.Color:=clWhite; Font.Style:=[fsBold]; Font.Size:=8;
  END;
 WITH Image3 DO
  BEGIN Left:=521; Top:=40; Width:=99; Height:=380;
  END;
 WITH Image3.Canvas DO
  BEGIN Font.Color:=clWhite; Font.Style:=[fsBold]; Font.Size:=8;
  END;
 END;

ModalRes:=1; GetDir(0,vddir); i:=Length(vddir); ss:=vddir;
IF(ss[i]<>'\')THEN ss:=ss+'\';
s:=FormatDateTime('dd',Date)+FormatDateTime('hhnn',Time);
outfn:=ss+'d'+s+'.res';
Form2.OpenDialog1.Title:='   Select the file';
s:=' already exists and will be destroyed by new output';
CheckOutFN(outfn,0,s);
AssignFile(fout,outfn); {$I-} ReWrite(fout); {$I+};
ok:=(IOresult=0); IF NOT ok THEN
 BEGIN s:='Opening failure: possibly occupied by another program';
 CheckOutFN(outfn,1,s);
 END;
s:=ss+'vdomus.fn'; inifn:=ss+'vdomus.ini'; IF(FileExists(s))THEN
  BEGIN AssignFile(ft,s); {$I-} Reset(ft); {$I+};
  EnterStr(ft); inifn:=sedz; CloseFile(ft);
  END;
spec:=TSpectrum.Create(vddir); spec.smosp:=1;
FOR i:=0 TO 4 DO pmod[i]:=TPeakModel.Create;
peaksr:=TPeakSearch.Create;
WITH spec DO
 BEGIN a1:=1; a2:=4096; wv:=0; dwv:=0; w0:=4; w1:=6; dw0:=3.5;
 cw1:=(w1-w0)/(a2-a1); cw0:=w0-cw1*a1; smosp:=1;
 a11:=2; a22:=4095; dback:=-3; sfn:='';
 END;
{Form1.FormandFontSizes1.Enabled:=false;}
END;
{----------------------}
BEGIN Application.Initialize;
Application.CreateForm(TForm1, Form1);
Application.CreateForm(TForm2, Form2);
Application.CreateForm(TForm3, Form3);
Initialize;
HideComponents;
Application.Run;
END.
