UNIT vmria4;
INTERFACE
USES
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, vmria0,   vzlocom, vspectr,  vpeaksr,  varfun,
  vmria00;
TYPE
  TForm4 = CLASS(TForm)
    ListBox1: TListBox;
  PRIVATE { Private declarations }
  PUBLIC  { Public declarations }
  END;
CONST iniframe:ARRAY[1..50] OF STRING = (
'.......Set Number of Phases',
'1',
'.......Input the Spectrum',
'* filename',
'',
'* NofSp; SpTyp;   a1,    a2,   a11,  a22,',
'    1              1',
'* Fpath(m), delay(chan), chwidth(mks), Bragg(th),',
'',
'*   W0,   dW0,  W1,  dW1, dback    abs1    abs2    shape(0=cyl.)',
'                                    0       0.1',
'.......Input the Variance',
'* filename',
'',
'* NofSp; SpTyp;',
'',
'.......Input the Effective Spectrum',
'* filename',
'',
'*  SpTyp;    a1,   a2,   Ncons,',
'                           1',
'* Fpath(m), delay(chan), chwidth(mks), Bragg(th),',
'',
'.......Normalize the Spectrum and Correct for Absorption',
'* isp',
'',
'.......Input the Double-signed Real Model',
'*   i1   i2   Lbck  nmod   rsm      Nsp',
'                                     1',
'.......Input Zero Weights',
'*   isp   i1   i2',
'     1',
'.......Input Lattice Par',
'*    a         b       c     alpha beta gamma',
'',
'* nsg sett nat  keycos coW',
'                        1',
'.......Input the Atomic Parameters',
'* Element name;     atom 1,  phase 1',
'',
'* Occ   x        y       z     t11   t12  t13 t22 t23 t33',
'                                      0   0    0   0   0',
'*.......Input about the Parameters',
'* parameter filename',
'',
'.......Form HKLs',
'.......Input the Main Fit Controls',
'*  N_iter    step       damp',
'      6  0.990000   0.0100000000',
'.......STOP');

CONST iniexamp1:ARRAY[1..47] OF STRING = (
'.......Set the Mode',
'* 0=Rietveld  1=Powder Indexing  2=PowderMatch  3=Peak Analysis',
'0',
'.......Set Number of Spectra',
'1',
'.......Set Number of Phases',
'1',
'.......Input the Spectrum',
'*   z.spc is a DN2-diffractometer measured 2-byte binary spectrum',
'*   of the IUCr ZrO2 sample (2% Hf).',
'* filename',
'\zlok\z.spc',
'* NofSp; SpTyp; a1,   a2,   a11,   a22',
'   1      1     1   1024    305    740',
'* Fpath(m), delay(chan), chwidth(mks), Bragg(th),',
'   25.00000   -1.19        64.0         75.000',
'* W0,   dW0,  W1,    dW1,  dback   abs1    abs2    shape(0=cyl.)',
'  5.00  4.00  0.000 10.000   5    0.00147 0.00893    0',
'*',
'* Input of variance not needed (Poisson)',
'* Input of eff.spectrum not needed (in DN2 case default is used)',
'*',
'*.......Input the Variance',
'* filename',
'*C:\ZLOK\zf.var',
'* NofSp; SpTyp;',
'*   1   2',
'*',
'*.......Input the Effective Spectrum',
'* filename',
'*van1142s.d',
'* SpTyp; a1, a2, Nc, Fpath(m), delay(chan),  chwidth(mks), Bragg(th)',
'*   1    1  1024  1    25.00      -1.19         64.0         75.000',
'*',
'.......Normalize the Spectrum and Correct for Absorption',
'* ispect',
'   1',
'*          The peak model is non-gaussian.',
'*          Peak from channels 580-627 is peak model',
'.......Input the Real Model',
'*   i1   i2   Lbck nmod      rsm     N_sp',
'   580   627     9  1        1.0      1',
'.......Input the Lattice Parameters',
'*     A         B        C      alpha  beta   gamma  of phase 1',
'   5.15603   5.22228   5.32083  90.00  99.22  90.00',
'* nsg  sett  n_atoms  keycos  cpw',
'  14    2    4          0      0'
);

CONST iniexamp2:ARRAY[1..78] OF STRING = (
'.......Input the Parameters',
'* Npar  BoundL     Parameter    BoundU    ai    bi    Comment',
'   1   0.25000+2  0.25000+2   0.25000+2 1.000  0.000 FlightPath',
'   2   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 dTheta0',
'   3  -0.21900+1 -0.11960+1  -0.19000+0 1.000  0.000 Shift',
'   4 -0.10000+13  0.75441+4  0.10000+13 1.000  0.000 Bckg-const',
'   5 -0.10000+12  0.10831+4  0.10000+13 1.000  0.000 Bckg-lin',
'   6 -0.10000+12 -0.51711+3  0.10000+13 1.000  0.000 Bckg-quadr',
'   7 -0.10000+12  0.14529+3  0.10000+13 1.000  0.000 Bckg-cubic',
'   8 -0.10000+12 -0.11446+3  0.10000+13 1.000  0.000 Bckg-4th p',
'   9 -0.10000+12 -0.21292+3  0.10000+13 1.000  0.000 Bckg-5th p',
'  10  -0.10000+1 -0.73677+0   0.10000+1 1.000  0.000 Spectr.Cor',
'*              PHASE No 1',
'  11   0.15740+0  0.27748+2  0.10000+13 1.000  0.000 Coef.phase',
'  12   0.36710-1  0.38675-1   0.40570-1 1.000  0.000 (a*) ** 2',
'  13   0.34870-1  0.36718-1   0.38540-1 1.000  0.000 (b*) ** 2',
'  14   0.34460-1  0.36313-1   0.38090-1 1.000  0.000 (c*) ** 2',
'  15   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 b*c*cos(a*',
'  16   0.11370-1  0.12001-1   0.12570-1 1.000  0.000 a*c*cos(b*',
'  17   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 a*b*cos(g*',
'  18   0.10000+1  0.68093+1   0.90000+1 1.000  0.000 Width 0',
'  19  -0.10000+2  0.16068+1   0.10000+2 1.000  0.000 Width 1',
'  20   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 Extinction',
'*           Atom No 1  Zr',
'  21   0.98000+0  0.98000+0   0.98000+0 1.000  0.000 Occup.',
'  22   0.24820+0  0.27749+0   0.30340+0 1.000  0.000 X',
'  23   0.36400-1  0.40000-1   0.44400-1 1.000  0.000 Y',
'  24   0.18800+0  0.20817+0   0.22980+0 1.000  0.000 Z',
'  25   0.15000+0  0.15000+0   0.15000+0 1.000  0.000 T11',
'  26   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T12',
'  27   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T13',
'  28   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T22',
'  29   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T23',
'  30   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T33',
'*           Atom No 2  O',
'  31   0.10000+1  0.10000+1   0.10000+1 1.000  0.000 Occup.',
'  32   0.62100-1  0.70775-1   0.75900-1 1.000  0.000 X',
'  33   0.30780+0  0.33007+0   0.37620+0 1.000  0.000 Y',
'  34   0.31050+0  0.34020+0   0.37950+0 1.000  0.000 Z',
'  35   0.40000+0  0.40000+0   0.40000+0 1.000  0.000 T11',
'  36   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T12',
'  37   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T13',
'  38   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T22',
'  39   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T23',
'  40   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T33',
'*           Atom No 3   O',
'  41   0.10000+1  0.10000+1   0.10000+1 1.000  0.000 Occup.',
'  42   0.40590+0  0.44376+0   0.49610+0 1.000  0.000 X',
'  43   0.68220+0  0.75828+0   0.83380+0 1.000  0.000 Y',
'  44   0.43110+0  0.48199+0   0.52690+0 1.000  0.000 Z',
'  45   0.20000+0  0.20000+0   0.20000+0 1.000  0.000 T11',
'  46   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T12',
'  47   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T13',
'  48   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T22',
'  49   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T23',
'  50   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T33',
'*           Atom No 4  Hf',
'  51   0.20000-1  0.20000-1   0.20000-1 1.000  0.000 Occup.',
'  22   0.24820+0  0.27749+0   0.30340+0 1.000  0.000 X',
'  23   0.36400-1  0.40000-1   0.44400-1 1.000  0.000 Y',
'  24   0.18800+0  0.20817+0   0.22980+0 1.000  0.000 Z',
'  55   0.15000+0  0.15000+0   0.15000+0 1.000  0.000 T11',
'  56   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T12',
'  57   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T13',
'  58   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T22',
'  59   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T23',
'  60   0.00000+0  0.00000+0   0.00000+0 1.000  0.000 T33',
'.......Get Atomic Information from Parameter Array and assign names',
'* list of atom names for phases 1,2,..',
'Zr',
'O1',
'O2',
'Hf',
'.......Form HKLs',
'.......Input the Main Fit Controls',
'*  N_iter    step       damp',
'      6  0.9900   0.01000000000',
'.......STOP'
);
VAR Form4: TForm4;
PROCEDURE DisplayPoint(ch:REAL);
PROCEDURE MakeForm4(t:INTEGER);

IMPLEMENTATION
{$R *.DFM}
USES vmria1;
PROCEDURE MakeForm4(t:INTEGER);
BEGIN WITH Form4 DO
 BEGIN Left:=Form1.Left+exs(420); Top:=Form1.Top+exs(t);
 Width:=exs(200); Height:=exs(90); ListBox1.Visible:=false;
 END;
END;
PROCEDURE DisplayPoint(ch:REAL);
VAR b,wi,d,r,amn:REAL; i,h,k,l,m,iph,iph0,i0:INTEGER; ok:BOOLEAN;
BEGIN MakeForm4(44); WITH Form4.ListBox1 DO WITH spec[numsp] DO
 BEGIN Left:=exs(5); Top:=exs(5); Width:=exs(190); Height:=exs(80);
 Font.Color:=clAqua; Font.Style:=[fsBold]; Font.Size:=fntsize;
 Brush.Color:=clBlack; Font.Pitch:=fpFixed; Visible:=true; Clear;
 ConvertStr(ch,6,0); Compress(sedz); s:=sedz;
  IF(tofang=1)THEN
   BEGIN ConvertStr(x[Round(ch)],10,2); Compress(sedz);
   sedz:=s+'-'+sedz;
   END;
 Items.Add(' Channel =  '+sedz);
 i:=Round(ch); ConvertStr(y[i],18,1); Compress(sedz);
 Items.Add(' Counts  =  '+sedz);
 IF(tofang<>2)THEN
  BEGIN d:=chtod(ch); ConvertStr(d,10,4); Compress(sedz);
  Items.Add(' d       =  '+sedz);
  ok:=false; IF(numsp<>0)THEN
   BEGIN amn:=1E15; FOR iph:=1 TO nph DO
    FOR i:=1 TO lat[iph].nhkl DO
     BEGIN r:=ABS(d-hkla[i][iph].dk); IF(r<amn)THEN
      BEGIN amn:=r; iph0:=iph; i0:=i; ok:=true;
      END;
     END;
   END;
  IF(ok)THEN
   BEGIN h:=hkla[i0][iph0].h; k:=hkla[i0][iph0].k; l:=hkla[i0][iph0].l;
   sedz:=IntToStr(h)+' '+IntToStr(k)+' '+IntToStr(l);
   IF(nph>1)THEN sedz:=sedz+' ('+IntToStr(iph0)+')';
   Items.Add(' hkls    =  '+sedz);
   END;
  END        ELSE
   BEGIN d:=x[Round(ch)]; ConvertStr(d,10,4); Compress(sedz);
   Items.Add(' X      =  '+sedz);
   END;
 m:=spec[numsp].a2; GetPeakWidthB(spec[numsp].y,m,ch,wi,r,b,ok);
 ConvertStr(wi,10,1); Compress(sedz);
 IF(ok)THEN sedz:=' Width   =  '+sedz ELSE sedz:=' No width';
 Items.Add(sedz);
 END;
Form4.Show;
END;


END.
