UNIT vsync1;

INTERFACE

USES  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, StdCtrls, OoMisc,   AdPort,  vzlocom,  vstdcons, varfun,
      ExtCtrls, Menus;

TYPE
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
     File1: TMenuItem;
     Settings1: TMenuItem;
     Exit1: TMenuItem;
    ApdComPort1: TApdComPort;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Memo1: TMemo;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Timer1: TTimer;
    RadioGroup1: TRadioGroup;
    {PROCEDURE OnTrigger(CP: TObject; Msg, TriggerHandle, Data: Word);}
    PROCEDURE Button1Click(Sender: TObject);{Get the Phase}
    PROCEDURE Button2Click(Sender: TObject);{Decrease}
    PROCEDURE Button3Click(Sender: TObject);{Exit}
    PROCEDURE Button5Click(Sender: TObject);{Start}
    PROCEDURE Button6Click(Sender: TObject);{Increase}
    PROCEDURE Button8Click(Sender: TObject);{STOP}
    PROCEDURE Button9Click(Sender: TObject);{Test}
    PROCEDURE Button10Click(Sender: TObject);{Get timer interval}
    PROCEDURE Timer1Timer(Sender: TObject);
    PROCEDURE Settings1Click(Sender: TObject);
    PROCEDURE Exit1Click(Sender: TObject);
    PROCEDURE ApdComPort1TriggerAvail(CP: TObject; Count: Word);
  PRIVATE
    { Private declarations }
  PUBLIC
    { Public declarations }
  END;

VAR  Form1: TForm1;
     StartS:BOOLEAN = true;
     IFirst:BOOLEAN = true; {first interrupt}
     sbuf:STRING;           {buffer for characters}
     mc:INTEGER;            {Number of really got character groups}
     comm:CHAR;             {Command issued}
     nchar:INTEGER;         {Number of chars to be obtained}
     ph,ph0:INTEGER;        {phase current and given}
     ph1,ph2:REAL;          {current phases for stabilizing}
     pha:ARRAY[1..20] OF INTEGER;
     phak:INTEGER=0;        {array of phases,N of items }
     tin:INTEGER = 3000;    {timer interval}
     tina:ARRAY[1..20] OF INTEGER;
     tink:INTEGER=0;        {array of timer intervals,N of items }
     TestV:BOOLEAN = false;
     sb1:STRING;            {buffer for phase text}
     mode50:BOOLEAN = true; {mode: get 50 phases}
     modstep:INTEGER = 0;   {mode step; 0 =first 50 phases}
     count0:INTEGER = 0;    {counter for starting}
     pharr:ARRAY[1..12000] OF REAL; {Array of got phases}
PROCEDURE InitializeMemo;
PROCEDURE HideComponents;
PROCEDURE GetPhase(VAR p:INTEGER);
PROCEDURE MakePhaseCombo;
PROCEDURE MakeTimerCombo;
PROCEDURE SetIniInfo;
PROCEDURE ShowMem(s:STRING);

IMPLEMENTATION
{$R *.DFM}
PROCEDURE HideComponents;
BEGIN WITH Form1 DO
 BEGIN Left:=0; Top:=0; Width:=exs(630); Height:=exs(470);
 Caption:='  VISUAL SYNC +++ 2004,    by Zlokazov V.B.';
 Color:=clGreen{BtnFace}; Font.Size:=10;
 Label1.Visible:=false; Label2.Visible:=false; Label3.Visible:=false;
 Label4.Visible:=false;
 Button1.Visible:=false; Button2.Visible:=false; Button3.Visible:=false;
 Button4.Visible:=false; Button5.Visible:=false; Button6.Visible:=false;
 Button7.Visible:=false; Button8.Visible:=false; Button8.Visible:=false;
 Button10.Visible:=false;
 ComboBox1.Visible:=false;
 ComboBox2.Visible:=false;
 RadioGroup1.Visible:=false;
 END;
END;
PROCEDURE InitializeMemo;
BEGIN Make_Memo(Form1.Memo1,250,370); Form1.Memo1.Height:=exs(250);
Form1.Memo1.Clear;
OuttoLabel(Form1.Label2,20,5,clMaroon,clWhite,' Test buttons ');
MaketheButton(Form1.Button6,2,20,120,25,' Increase ');
MaketheButton(Form1.Button2,2,45,120,25,' Decrease ');
MaketheButton(Form1.Button3,2,70,120,25,' Output the phase ');
MaketheButton(Form1.Button9,2,95,120,25,' Test mode toggle ');

OuttoLabel(Form1.Label3,140,125,clMaroon,clWhite,' Main buttons ');
MaketheButton(Form1.Button7,120,145,120,25,' Help ');
MaketheButton(Form1.Button1,120,170,120,25,' Enter the phase ');
MaketheButton(Form1.Button10,120,195,120,25,' Set timer interval ');
MaketheButton(Form1.Button5,120,220,120,25,' Start ');
MaketheButton(Form1.Button8,120,245,120,25,' STOP ');
{MaketheButton(Form1.Button4,120,270,120,25,'  ');}
WITH CB1rec DO
 BEGIN nitems:=3; indx:=2;
 ar[1]:='Small';
 ar[2]:='Normal';
 ar[3]:='Large';
 END;
BuildRG(Form1.RadioGroup1,0,230,350,100,70);
WITH Form1.RadioGroup1 DO
 BEGIN Caption:='Screen size';
 END;
s:=' Maximum phase (C000 = 49152) ';
OuttoLabel(Form1.Label1,2,350,clMaroon,clWhite,s);
s:=' Timer interval ';
OuttoLabel(Form1.Label4,2,386,clMaroon,clWhite,s);
Form1.ApdComPort1.ComNumber:=1;
MakePhaseCombo;
MakeTimerCombo;
modstep:=0; count0:=0; Form1.Timer1.Interval:=100; comm:='Z';
END;
PROCEDURE MakePhaseCombo;
VAR i:INTEGER;
BEGIN WITH CB1rec DO
 BEGIN nitems:=phak; indx:=1;
 FOR i:=1 TO phak DO ar[i]:=IntToStr(pha[i]);
 END;
MakeComboBox(Form1.ComboBox1,20,365,100);
END;
PROCEDURE MakeTimerCombo;
VAR i:INTEGER;
BEGIN WITH CB1rec DO
 BEGIN nitems:=tink; indx:=1;
 FOR i:=1 TO tink DO ar[i]:=IntToStr(tina[i]);
 END;
MakeComboBox(Form1.ComboBox2,20,400,100);
END;
PROCEDURE TForm1.Button5Click(Sender: TObject);  {Start}
VAR i:INTEGER;
BEGIN StartS:=true; Timer1.Enabled:=true;
Memo1.Lines.Add('Start-command issued '+IntToStr(ph));
END;
PROCEDURE PutCharDP(c:CHAR);
BEGIN ph:=Round(rndm(-1)*40000);
END;
PROCEDURE TForm1.Timer1Timer(Sender: TObject);  {Timer}
VAR i:INTEGER;
BEGIN comm:='T'; {WITH ApdComPort1 DO
 BEGIN IF(OutBuffFree>=1)THEN
  BEGIN Memo1.Lines.Add('C command sent from timer'); PutChar('C');
  END                   ELSE Memo1.Lines.Add('C-command not accepted');}
WITH ApdComPort1 DO
 CASE modstep OF
0: BEGIN Inc(count0); pharr[count0]:=ph; IF(count0>50)THEN
    BEGIN count0:=-1; modstep:=1; r:=0; FOR i:=2 TO 50 DO r:=r+pharr[i];
    r:=r/49; ShowMem('ph50_0= '+FloatToStr(r)); ph1:=r;
    END;
   {IF(OutBuffFree>=1)THEN PutChar('C');} PutCharDP('C');
   END;
1: BEGIN Inc(count0); pharr[count0]:=ph;
   IF(count0=0)THEN Button2Click(Self); {Decrease velo}
   IF(count0>50)THEN
    BEGIN count0:=-1;
    r:=0; FOR i:=1 TO 50 DO r:=r+pharr[i]; r:=r/50; ph2:=r;
    ShowMem('ph50_0= '+FloatToStr(r));
    IF(ABS(ph1-ph2)<1000)THEN modstep:=2
                         ELSE
     BEGIN ph1:=ph2; count0:=-1;
     END;
    END;
   {IF(OutBuffFree>=1)THEN PutChar('C');} PutCharDP('C');
   END;
2: BEGIN Form1.Timer1.Interval:=5000; ShowMem('Stable');
   END;
ELSE END;
END;
PROCEDURE ShowMem(s:STRING);
BEGIN Form1.Memo1.Lines.Add(s);
END;
PROCEDURE SetIniInfo;
BEGIN s:='vsync.ini'; IF(FileExists(s))THEN ;
END;
PROCEDURE TForm1.ApdComPort1TriggerAvail(CP: TObject; Count: Word);
VAR ch:CHAR; i,m,jm:INTEGER; r,r1:REAL;
BEGIN IF(IFirst)THEN sbuf:=''; m:=Count;
FOR i:=1 TO m DO WITH ApdComPort1 DO
 BEGIN IF(CharReady)THEN
  BEGIN ch:=ApdComPort1.GetChar; IF((ch=#13)OR(ch=#10))THEN ch:='.';
  sbuf:=sbuf+ch;
  END               ELSE Memo1.Lines.Add('Character not ready');
 END;
IF(IFirst)THEN
 BEGIN IFirst:=false; mc:=m;
 END      ELSE mc:=mc+m;
IF((comm='A')OR(comm='B')OR(comm='Z'))THEN Exit;
IF((sbuf[mc-1]=#58)AND(sbuf[mc]=#32))THEN
  {end of 8byte group series = :blank}
 BEGIN IFirst:=true; IF((comm='C')OR(comm='T'))THEN
  BEGIN GetPhase(ph);
  Memo1.Lines.Add(sbuf+' My phase='+IntToStr(ph)+':'+sb1);
  r:=ABS(ph-ph0); r1:=0.1*AMAX0(1,ph0);
  {IF(r<=r1)THEN
           ELSE WITH ApdComPort1 DO}
   BEGIN
 //IF((ph>ph0)AND(OutBuffFree>=1))THEN Button6Click(Self) {Increase Vel}
 //                               ELSE Button2Click(Self);{Decrease Vel}
   END;
  END;
 END;
END;
PROCEDURE GetPhase(VAR p:INTEGER);
VAR s:STRING; w:WORD; i:INTEGER;
BEGIN p:=0; i:=Pos('Phase = ',sbuf);
IF(i=0)THEN sb1:='Error'
       ELSE
 BEGIN s:=Copy(sbuf,i+8,4); HexaToWord(s,w); p:=w; sb1:=s;
 END;
END;
PROCEDURE TForm1.Button3Click(Sender: TObject); {Output the phase}
BEGIN comm:='C'; nchar:=41;
WITH ApdComPort1 DO
 BEGIN
 IF(OutBuffFree>=1)THEN
  BEGIN PutChar('C'); Memo1.Lines.Add('C-phase output command sent');
  END              ELSE Memo1.Lines.Add('C-command not accepted');
 END;
{Debug}IF(TestV)THEN
 BEGIN sbuf:='1234567890123a256'; GetPhase(ph); ShowMess(IntToStr(ph));
 END;
END;
PROCEDURE TForm1.Button1Click(Sender: TObject); {Get the Phase}
VAR ch:CHAR; i,j:INTEGER; s:STRING; r:REAL;
BEGIN {ActivateDeviceLayer;} {DSR:=true; WITH ApdComPort1 DO
 BEGIN StartS:=false; IF(CharReady)THEN ch:=GetChar ELSE ch:='F';
 Memo1.Lines.Add('Got from port= '+ch);
 END;}
i:=ComboBox1.ItemIndex+1;
s:=ComboBox1.Text; IF(i<>0)THEN s:=CB1rec.ar[i]; Zval(s,r);
IF(r>53248)THEN r:=53248; ph0:=Round(r);
Inc(phak); FOR j:=phak DOWNTO 2 DO pha[j]:=pha[j-1]; pha[1]:=ph0;
MakePhaseCombo;
Memo1.Lines.Add('Max phase= '+IntToStr(ph0));
END;
PROCEDURE TForm1.Button2Click(Sender: TObject); {Decrease}
BEGIN comm:='A'; nchar:=25; WITH ApdComPort1 DO
 BEGIN
 IF(OutBuffFree>=1)THEN
  BEGIN Memo1.Lines.Add('A-command sent (decrease)'); PutChar('A');
  END              ELSE Memo1.Lines.Add('A-command not accepted');
 END;
{Debug}IF(TestV)THEN ph:=MAX0(ph-123,100);
END;
PROCEDURE TForm1.Button6Click(Sender: TObject);  {Increase}
BEGIN comm:='B'; nchar:=25; WITH ApdComPort1 DO
 BEGIN
 IF(OutBuffFree>=1)THEN
  BEGIN Memo1.Lines.Add('B-command sent (increase)'); PutChar('B');
  END              ELSE Memo1.Lines.Add('B-command not accepted');
 END;
{Debug}IF(TestV)THEN ph:=MIN0(ph+132,ph0);
END;
PROCEDURE TForm1.Button8Click(Sender: TObject);{STOP}
BEGIN Timer1.Enabled:=false; Memo1.Lines.Add('Stopped');
END;

PROCEDURE TForm1.Button9Click(Sender: TObject);{Test mode}
BEGIN TestV:=NOT TestV;
s:='Test mode off'; IF(TestV)THEN s:='Test mode on'; Memo1.Lines.Add(s);
END;

PROCEDURE TForm1.Button10Click(Sender: TObject);{Set timer int}
VAR i,j:INTEGER;
BEGIN i:=ComboBox2.ItemIndex+1;
s:=ComboBox2.Text; IF(i<>0)THEN s:=CB1rec.ar[i]; Zval(s,r);
tin:=MAX0(Round(r),1);
IF(i=0)THEN
 BEGIN Inc(tink); FOR j:=tink DOWNTO 2 DO tina[j]:=tina[j-1];
 tina[1]:=tin;
 END;
MakeTimerCombo;
Memo1.Lines.Add('Timer interval= '+IntToStr(tin));
Form1.Timer1.Interval:=tin;
END;
PROCEDURE TForm1.Settings1Click(Sender: TObject);
VAR i:INTEGER;
BEGIN i:=RadioGroup1.ItemIndex;
CASE i OF
0: scrsize:=1;
1: scrsize:=1.25;
2: scrsize:=1.5;
ELSE END;
HideComponents; InitializeMemo;
END;
PROCEDURE TForm1.Exit1Click(Sender: TObject);
VAR i:INTEGER;
BEGIN AssignFile(ft,'vsync.sav'); Rewrite(ft);
WITH Memo1.Lines DO FOR i:=1 TO Count DO
 BEGIN s:=Strings[i-1]; Writeln(ft,s);
 END;
CloseFile(ft);
Application.Terminate;
END;



END.


PROCEDURE TForm1.OnTrigger(CP: TObject; Msg, TriggerHandle, Data: Word);
VAR ch:CHAR; i,m,j:INTEGER; r:REAL;
BEGIN j:=0; IF(IFirst)THEN sbuf:=''ELSE j:=1;
CASE Msg OF

APW_TRIGGERAVAIL:
 BEGIN Memo1.Lines.Add('TriggerAvail'+'  '+IntToStr(j)); m:=Data;
 FOR i:=1 TO m DO WITH ApdComPort1 DO
  BEGIN IF(CharReady)THEN
   BEGIN ch:=ApdComPort1.GetChar;
   {IF(ch=#0)THEN
    BEGIN m:=i-1; BREAK;
    END;}
   IF(NOT((ch=#13)OR(ch=#10)))THEN sbuf:=sbuf+ch;
   END               ELSE Memo1.Lines.Add('Character not ready');
  END;
 IF(IFirst)THEN mc:=m ELSE mc:=mc+m;
 Memo1.Lines.Add(sbuf+' '+IntToStr(mc)+' items');
 {IF(NOT IFirst)THEN}
  BEGIN IF(comm='C')THEN GetPhase(ph);
  Memo1.Lines.Add('Trig: '+sbuf+'phase='+IntToStr(ph));
  END;
 IFirst:=NOT IFirst;
 END;

APW_TRIGGERDATA:   ShowMess('Data');
APW_TRIGGERTIMER:  BEGIN FOR i:=1 TO SQR(100) DO r:=178*45;
                   ShowMess('Timer');
                   END;
APW_TRIGGERSTATUS: ShowMess('Status');
ELSE END;
END;
PROCEDURE GetPhase(VAR p:INTEGER);
VAR i:INTEGER; ch:CHAR; cs:ARRAY[1..2] OF BYTE;
BEGIN WITH Form1 DO FOR i:=1 TO 2 DO WITH ApdComPort1 DO
 BEGIN IF(CharReady)THEN
  BEGIN ch:=ApdComPort1.GetChar; cs[i]:=Ord(ch);
  END               ELSE Memo1.Lines.Add('Character not ready');
 END;
{Debug}IF(TestV)THEN p:=ph ELSE p:=256*cs[1]+cs[2];
Form1.Memo1.Lines.Add('2b phase= '+IntToStr(p)+'- '+
 IntToStr(cs[1])+IntToStr(cs[2]));
END;
PROCEDURE Toggle(VAR i:INTEGER);
BEGIN
CASE i OF
0: i:=1;
1: i:=0;
ELSE END;
END;

