UNIT vzlocom;
INTERFACE
USES Windows, Messages, Dialogs, Forms, Graphics, ExtCtrls, SysUtils,
     Classes, Controls;
TYPE LREC   = RECORD ar:ARRAY[1..13] OF STRING; nitems,indx:INTEGER;END;
     LBREC  = RECORD ar:ARRAY[1..2005] OF STRING; nitems:INTEGER; END;
     SPECREC= RECORD y,x,e:REAL; END;
     POINTREC = RECORD x,y,z:REAL; END;
     MARKREC = RECORD i1,i2,k1,k2:INTEGER; END;
     VECTOR = RECORD x,y,z:REAL; END;
     BOUNDA = RECORD bl,br:REAL; END;
     ASPDAT = RECORD y,e:ARRAY[1..120] OF REAL; a1,a2:INTEGER;
              spin:BOOLEAN; sfn:STRING; spx,spn:REAL; END;
     DEBUGLOG = RECORD cbipr:BOOLEAN; aniso:BOOLEAN; indtest:BOOLEAN;
                activ:BOOLEAN; powdmath:BOOLEAN; peaksear:BOOLEAN;
                magnetic:BOOLEAN; hkli:BOOLEAN;
                uparith:ARRAY[1..7] OF BOOLEAN;
                END;
TYPE PERAR  = RECORD area,pos,width,per:REAL; END;
CONST radian:REAL = 57.29578;
      iradian:REAL =1.745329E-2; {1/radian}
      pi2:REAL = 6.283185307179586476;
      tofcon=505.556{2.*252.778};
      bblank:STRING = '        ';
      dblank:STRING = '                ';
      tblank:STRING = '                        ';
      wrnum:STRING = ' Error, wrong numbers ';
      selops:STRING = ' Select the Option ';
      cliops:STRING = ' Click on the Option ';
      Num4Rec:LREC = (ar:(' 1',' 2',' 3',' 4',
      '5','6','','','','','','',''); nitems:4; indx:1;);
      ModelNRec:LREC = (ar:('Model 0(Bckg)','Model 1','Model 2',
       'Model 3','Model 4','Model 5','Model 6','','','','','','');
       nitems:7; indx:2;);
      SpTypeRec:LREC = (ar:(' 2 bytes per word binary',
        ' 4 bytes per word binary',' ASCII free field format',
       ' ASCII  threes:  X,  Y,  [ error ]','','','','','','','','','');
       nitems:4; indx:1;);
      crc:STRING = #10+#13;
      sn01:STRING = 'Smoother not within [0,1]. Still proceed?';
      insd:STRING = 'If no, set to default';
      cola:ARRAY[1..5] OF INTEGER =
       (clRed,clFuchsia,clAqua,clYellow,clLime);
CONST alnums: SET OF CHAR = ['0'..'9','+','-',',','.',';'];
CONST DOSCyr:STRING[64] =
 '';
CONST WINCyr:STRING[64] =
     '';
      BlankH_n:INTEGER = -1;
      BlankH:ARRAY[1..1] OF STRING = (' ');
      x1graph:INTEGER = 2; y1graph:INTEGER = 100;
      hgraph:INTEGER = 272; wgraph:INTEGER = 620;
VAR sedz:STRING;
    onl:ARRAY[1..16384] OF REAL;
    buf4:ARRAY[1..128] OF INTEGER;
    buf2:ARRAY[1..256] OF WORD;
    inifn:STRING;    {INI-file name}
    fntsize:INTEGER; {font size 8,10,12}
    scrsize:REAL;    {coefficient for screen size}
    helpa:ARRAY[1..100] OF STRING; {buffer for help-array}
    lhelp:INTEGER;                 {number of help strings}
    RusHelp:BOOLEAN = false;       {flag for eng/rus}
    debugV:DEBUGLOG;
    q1,q2,q3,q4:REAL;
    s,fn,fn1,fn2:STRING;
    r,ff,fz,fzz,chi,eps,err,det:REAL;
    fex,fth,sigi,step,chio,dp1,dp2,dp3:REAL;
    pa,pal,pau,dp,ffr:ARRAY[1..3] OF REAL;
    ch,ch1,ch2:CHAR;
    i,j,k,iter:INTEGER;
    l,lx,ly:LONGINT;
    ModalRes:INTEGER;
    ok,fail:BOOLEAN;
    ft,fo,fout:TEXTFILE;
    fbyt:FILE OF BYTE;
    har:ARRAY[0..21] OF REAL; jja:ARRAY[0..21] OF INTEGER;
    LB1rec:LBREC; {ListBox1 text}
    CB1rec:LREC;  {Radio, ComboBox1 text}
    L0rec:STRING; {Caption text}
    L1rec:STRING; {Label1 text}
    L2rec:STRING; {Label2 text}
    L3rec:STRING; {Label3 text}
    L4rec:STRING; {Label4 text}
    E1rec:STRING; {Edit1 text}
    E2rec:STRING; {Edit2 text}
    E3rec:STRING; {Edit3 text}
    E4rec:STRING; {Edit4 text}
    strgrT:ARRAY[1..100] OF STRING; {Captions for 2-column grid table}
    strgrH:ARRAY[1..10] OF STRING; {Horiz. captions for n-column table}
    strgrW:ARRAY[0..10] OF INTEGER; {Widths of cells}
    strgrN:ARRAY[1..100] OF REAL;   {Numbers for 2-column grid table}
    strgrNn:ARRAY[1..100,1..10] OF REAL; {Numbers for n-column table}
    msinf,sinf:STRING;    {for communications of programs}
    Bitmap:TBitmap;
    ListBsav:BOOLEAN;     {List Box saved?}
    click1:BOOLEAN;       {Wait while Message Processing}
    pixelm:INTEGER;       {pixel token. 0=point, 1=5 points, 2-line}
    nscale:INTEGER;       {Number of scale 0=normal, 1=sqrt, 2=log}
    xscale:BOOLEAN;       {X normal or logarithmic}
    trimm:REAL;           {trimming level}
    jxg1,jxg2,jyg1,jyg2:ARRAY[1..5] OF INTEGER;{bounds for several graph
                          1-4 spectra,5 err}

PROCEDURE Wait(VAR click:BOOLEAN);
FUNCTION MaxZ(x,y:REAL):REAL;
FUNCTION FLOAT(i:INTEGER):REAL;
PROCEDURE GetCapitals(CONST s1:STRING; VAR s2:STRING);
FUNCTION infun(i,i1,i2:INTEGER):BOOLEAN;
FUNCTION rinfun(r,r1,r2:REAL):BOOLEAN;
FUNCTION MAX0(i,j:INTEGER):INTEGER;
FUNCTION MAX1(i,j:REAL):INTEGER;
FUNCTION MIN0(i,j:INTEGER):INTEGER;
FUNCTION MIN1(i,j:REAL):INTEGER;
FUNCTION AMAX1(x,y:REAL):REAL;
FUNCTION AMIN1(x,y:REAL):REAL;
FUNCTION AMIN0(x,y:INTEGER):REAL;
FUNCTION AMAX0(x,y:INTEGER):REAL;
FUNCTION AMAX3(x,y,z:REAL):REAL;
FUNCTION AMIN3(x,y,z:REAL):REAL;
FUNCTION sign(x:REAL):INTEGER;
FUNCTION Entier(x:REAL):INTEGER;
FUNCTION AMOD(r:REAL; y:REAL):REAL;
FUNCTION InInt(a,b,c:INTEGER):BOOLEAN;
FUNCTION LoCaze(ch:CHAR):CHAR;
FUNCTION UpCaze(ch:CHAR):CHAR;
PROCEDURE UpCaseStr(VAR s:STRING);
PROCEDURE LoCaseStr(VAR s:STRING);
PROCEDURE FCompress(VAR s:STRING);
PROCEDURE Compress(VAR s:STRING);
PROCEDURE BCompress(VAR s:STRING);
PROCEDURE HCompress(VAR s:STRING);
FUNCTION PosB(CONST s1,s2:STRING):INTEGER;
FUNCTION powerRI(x:REAL; n:INTEGER):REAL;
FUNCTION powerRR(x,y:REAL):REAL;
PROCEDURE ConvertStr(r:REAL; nt,nc:INTEGER);
PROCEDURE IConvertStr(n:INTEGER; nt:INTEGER);
PROCEDURE GetComprNum(r:REAL; nfr:INTEGER);
FUNCTION arcsin(x:REAL):REAL;
FUNCTION arccos(x:REAL):REAL;
PROCEDURE GetRealRootCubic(a,b,c,d:REAL; VAR x:REAL);
PROCEDURE fffin(VAR fs:TEXT; k1,k2:INTEGER; VAR kkk:INTEGER;
                VAR ar:ARRAY OF REAL);
PROCEDURE EnterStr(VAR ft:TEXTFILE);
PROCEDURE fffins(VAR kkk:INTEGER; CONST fn:STRING);
PROCEDURE Arrange2(VAR a1,a2:REAL);
PROCEDURE Irrange2(VAR a1,a2:INTEGER);
PROCEDURE ftoa(r:REAL; nd,nf:INTEGER; VAR s:STRING);
PROCEDURE ftos(r:REAL; nd,nf:INTEGER; VAR s:STRING);
PROCEDURE Valz(CONST st:STRING; VAR r:REAL; VAR fail:INTEGER);
FUNCTION syngon(nsg,sett:INTEGER):INTEGER;
PROCEDURE fltostr(rr:REAL; nd:INTEGER; VAR s:STRING);
FUNCTION Even(n:INTEGER):BOOLEAN;
FUNCTION Odd(n:INTEGER):BOOLEAN;
PROCEDURE AdjustSt(VAR s:STRING; n:INTEGER);
PROCEDURE marran(VAR n:INTEGER; l:INTEGER);
PROCEDURE mcleanz(VAR n:INTEGER; m:INTEGER);
PROCEDURE ExtractFN(CONST s1:STRING; VAR s2:STRING);
PROCEDURE BubbleSort(n:INTEGER);
FUNCTION CheckBlank(CONST s:STRING):BOOLEAN;
FUNCTION Factorial(n:INTEGER):REAL;
PROCEDURE ErrorMessage(m:INTEGER; CONST s:STRING);
PROCEDURE Zval(CONST s:STRING; VAR x:REAL);
PROCEDURE ZExchange(VAR a,b:REAL);
PROCEDURE GraphSpecAndModel(CONST Im:TImage; m,ng,npo:INTEGER);
PROCEDURE ShowMess(CONST s:STRING);
FUNCTION EuclNorm(CONST v:VECTOR):REAL;
FUNCTION exs(i:INTEGER):INTEGER;
PROCEDURE SaveHelp(n:INTEGER; CONST h:ARRAY OF STRING);
PROCEDURE RecodeDtoW(VAR s:STRING);
PROCEDURE GetSetInfo(CONST sf:STRING);
PROCEDURE SaveSettings(CONST s:STRING);
PROCEDURE EraseEmptyF(CONST fn:STRING);
FUNCTION OWriteFile(CONST s:STRING):BOOLEAN;
PROCEDURE ErrMark;
PROCEDURE HexaToWord(CONST s:STRING; VAR w:WORD);
PROCEDURE DrawPixelPr(cl,li,lj,i,ic1,n:INTEGER);
PROCEDURE MakeBMFrame(amx,amn:REAL);
FUNCTION CalcOrdinate(z,amx,amn:REAL):LONGINT;
PROCEDURE ExchangeStr(VAR s1,s2:STRING);
FUNCTION LogToStr(x:BOOLEAN):STRING;
FUNCTION FltoSt(x:REAL; n:INTEGER):STRING;
PROCEDURE ComplexDiv(re1,im1,re2,im2:REAL; VAR reo,imo:REAL);
PROCEDURE ComplexMult(re1,im1,re2,im2:REAL; VAR reo,imo:REAL);
IMPLEMENTATION
{-----------------------------------------------}
PROCEDURE SaveHelp(n:INTEGER; CONST h:ARRAY OF STRING);
VAR i,j:INTEGER; rus:BOOLEAN;
BEGIN rus:=RusHelp AND(n>0);
j:=0; IF(rus)THEN j:=n; lhelp:=MIN0(ABS(n),100);
FOR i:=1 TO lhelp DO
 BEGIN helpa[i]:=h[i-1+j]; IF(rus)THEN RecodeDtoW(helpa[i]);
 END;
END;
PROCEDURE RecodeDtoW(VAR s:STRING); {DOS to Windows}
VAR i,j,k:INTEGER;
BEGIN FOR i:=1 TO Length(s) DO
 BEGIN ch:=s[i]; FOR k:=1 TO 64 DO
  BEGIN j:=Pos(ch,DOSCyr); IF(j<>0)THEN s[i]:=WINCyr[j];
  END;
 END;
END;
FUNCTION exs(i:INTEGER):INTEGER;
BEGIN exs:=Round(i*scrsize);
END;
FUNCTION EuclNorm(CONST v:VECTOR):REAL;
BEGIN WITH v DO EuclNorm:=SQRT(SQR(x)+SQR(y)+SQR(z));
END;
PROCEDURE EnterStr(VAR ft:TEXTFILE);
VAR   s:STRING[255];
LABEL L1;
BEGIN sedz:=' ';
L1: IF(NOT EoF(ft))THEN Readln(ft,s) ELSE Exit;
IF(s[1]='*')THEN GOTO L1 ELSE sedz:=s;
END;
PROCEDURE Wait(VAR click:BOOLEAN);
BEGIN click:=false; WHILE(NOT click)DO Application.ProcessMessages;
END;
FUNCTION MaxZ(x,y:REAL):REAL;
BEGIN MaxZ:=x; IF(y>x)THEN MaxZ:=y;
END;
FUNCTION FLOAT(i:INTEGER):REAL;
BEGIN FLOAT:=i;
END;
PROCEDURE GetCapitals(CONST s1:STRING; VAR s2:STRING);
VAR i:INTEGER; s:STRING;
BEGIN s:=s1; Compress(s); s2:='';
FOR i:=1 TO Length(s) DO IF(s[i] IN ['A'..'Z'])THEN s2:=s2+s[i];
END;
FUNCTION infun(i,i1,i2:INTEGER):BOOLEAN;
BEGIN infun:=false;
IF((i>=i1)AND(i<=i2))THEN infun:=true;
END;
FUNCTION rinfun(r,r1,r2:REAL):BOOLEAN;
BEGIN rinfun:=false;
IF((r>=r1)AND(r<=r2))THEN rinfun:=true;
END;
FUNCTION MAX0(i,j:INTEGER):INTEGER;
BEGIN max0:=i; IF(j>i)THEN max0:=j;
END;
FUNCTION MAX1(i,j:REAL):INTEGER;
BEGIN max1:=Round(i); IF(j>i)THEN max1:=Round(j);
END;
FUNCTION MIN0(i,j:INTEGER):INTEGER;
BEGIN min0:=i; IF(j<i)THEN min0:=j;
END;
FUNCTION MIN1(i,j:REAL):INTEGER;
BEGIN min1:=Round(i); IF(j<i)THEN min1:=Round(j);
END;
FUNCTION AMAX1(x,y:REAL):REAL;
BEGIN amax1:=x; IF(y>x)THEN amax1:=y;
END;
FUNCTION AMIN1(x,y:REAL):REAL;
BEGIN amin1:=x; IF(y<x)THEN amin1:=y;
END;
FUNCTION AMIN0(x,y:INTEGER):REAL;
BEGIN amin0:=x; IF(y<x)THEN amin0:=y;
END;
FUNCTION AMAX0(x,y:INTEGER):REAL;
BEGIN amax0:=x; IF(y>x)THEN amax0:=y;
END;
FUNCTION AMAX3(x,y,z:REAL):REAL;
BEGIN amax3:=AMAX1(x,AMAX1(y,z));
END;
FUNCTION AMIN3(x,y,z:REAL):REAL;
BEGIN amin3:=AMIN1(x,AMIN1(y,z));
END;
FUNCTION sign(x:REAL):INTEGER;
BEGIN IF(x=0)THEN sign:=0 ELSE IF(x<0)THEN sign:=-1 ELSE sign:=1;
END;
FUNCTION Entier(x:REAL):INTEGER;
VAR i:INTEGER; r:REAL;
BEGIN i:=Round(x); r:=i; IF(ABS(r)>ABS(x))THEN i:=i-sign(x); Entier:=i;
END;
FUNCTION InInt(a,b,c:INTEGER):BOOLEAN;
BEGIN IF((a>=b)AND(a<=c))THEN InInt:=true ELSE InInt:=false; END;
PROCEDURE TakeNum(VAR a:INTEGER);
VAR i,j:INTEGER; str:STRING[12];
BEGIN Readln(str); IF str<>'' THEN
 BEGIN Val(str,j,i); IF i=0 THEN a:=j;
 END;
END;
FUNCTION LoCaze(ch:CHAR):CHAR;
VAR i:INTEGER;
BEGIN i:=Ord(ch); LoCaze:=ch;
IF((i IN [65..90])OR(i IN [128..143]))THEN LoCaze:=Chr(i+32);
IF(i IN [144..159])THEN LoCaze:=Chr(i+80);
END;
FUNCTION UpCaze(ch:CHAR):CHAR;
VAR i:INTEGER;
BEGIN i:=Ord(ch); UpCaze:=ch;
IF((i IN [97..122])OR(i IN [160..175]))THEN UpCaze:=Chr(i-32);
IF(i IN [224..239])THEN UpCaze:=Chr(i-80);
END;
PROCEDURE UpCaseStr(VAR s:STRING);
VAR i:INTEGER;
BEGIN FOR i:=1 TO Length(s) DO s[i]:=UpCaze(s[i]);
END;
PROCEDURE LoCaseStr(VAR s:STRING);
VAR i:INTEGER;
BEGIN FOR i:=1 TO Length(s) DO s[i]:=LoCaze(s[i]);
END;
PROCEDURE FCompress(VAR s:STRING);
BEGIN WHILE((Length(s)<>0)AND(s[1]=' '))DO Delete(s,1,1);
END;
PROCEDURE Compress(VAR s:STRING);
VAR i,j:INTEGER;
BEGIN j:=Length(s);
FOR i:=j DOWNTO 1 DO IF(s[i]=' ')THEN Delete(s,i,1);
END;
PROCEDURE BCompress(VAR s:STRING);
BEGIN WHILE((Length(s)<>0)AND(s[Length(s)]=' '))DO
      Delete(s,Length(s),1);
END;
PROCEDURE HCompress(VAR s:STRING);
VAR i:INTEGER;
BEGIN REPEAT i:=Pos('  ',s); IF(i<>0)THEN Delete(s,i,1); UNTIL i=0;
END;
FUNCTION PosB(CONST s1,s2:STRING):INTEGER;
VAR s:STRING[255]; i:INTEGER;
BEGIN s:=s2; PosB:=0;
REPEAT i:=Pos(s1,s); IF(i<>0)THEN
 BEGIN s[i]:=#0; PosB:=i;
 END;
UNTIL i=0;
END;
FUNCTION powerRI(x:REAL; n:INTEGER):REAL;
{To raise x to n,  Mar 25 1999, Nov 10 2000}
VAR i,k:INTEGER; p:REAL;
BEGIN p:=1; k:=ABS(n); IF(k>300)THEN
 BEGIN powerRI:=1E300; Exit;
 END;
IF(x=0)THEN p:=0 ELSE
 FOR i:=1 TO k DO IF(n>0)THEN p:=p*x ELSE p:=p/x;
IF(n=0)THEN p:=1; powerRI:=p;
END;
FUNCTION powerRR(x,y:REAL):REAL;
{To raise x to y,  Mar 25 1999}
BEGIN powerRR:=0; IF(x=0)THEN Exit;
{IF(x<0)THEN ShowMess('Error: raising negative to real')
       ELSE}
powerRR:=EXP(y*LN(ABS(x)));
END;
PROCEDURE ConvertStr(r:REAL; nt,nc:INTEGER);
CONST s0:STRING[23] = '***********************'; ml:REAL = 2.302585;
VAR   i:INTEGER; log:BOOLEAN;
BEGIN sedz:=Copy(s0,1,nt); i:=nt-nc-1; log:=((r>0)AND((ln(r)/ml)<=i));
log:=log OR ((r<0)AND((ln(ABS(r))/ml)<=(i-1))) OR (r=0);
IF(log)THEN Str(r:nt:nc,sedz);
REPEAT i:=Length(sedz); IF(sedz[i]=' ')THEN
 BEGIN Delete(sedz,i,1); sedz:=' '+sedz;
 END;
UNTIL sedz[i]<>' ';
END;
PROCEDURE IConvertStr(n:INTEGER; nt:INTEGER);
VAR i:INTEGER;
BEGIN sedz:=IntToStr(n); FOR i:=1 TO nt-Length(sedz) DO sedz:=' '+sedz;
IF(Length(sedz)>nt)THEN
 BEGIN sedz:=Copy(sedz,1,nt); FOR i:=1 TO nt DO sedz[i]:='*';
 END;
END;
PROCEDURE GetComprNum(r:REAL; nfr:INTEGER);
BEGIN ConvertStr(r,25,nfr); Compress(sedz);
END;
FUNCTION arcsin(x:REAL):REAL;
VAR arg:REAL;
BEGIN IF((x<-1)OR(x>1))THEN
 BEGIN {ShowMess('Wrong arcsin argument');} x:=sign(x);
 END;
IF(x=-1)THEN arg:= 4.71238875 ELSE
IF(x= 1)THEN arg:= 1.57079625 ELSE
 BEGIN arg:=arctan(ABS(x)/SQRT(ABS(1-x*x)));
 IF(x<0)THEN arg:=arg+3.1415925;
 END;
arcsin:=arg;
END;
FUNCTION arccos(x:REAL):REAL;
VAR r,arg:REAL;
BEGIN IF((x<-1)OR(x>1))THEN x:=sign(x);
IF(ABS(x)<0.0001)THEN arg:=pi/2{1.57079625} ELSE
IF(x>= 1)THEN arg:=0          ELSE
IF(x<=-1)THEN arg:=pi{3.1415925}  ELSE
 BEGIN r:=SQRT(ABS(1-x*x))/ABS(x); arg:=arctan(r);
 IF(x<0)THEN arg:=3.1415925-arg;
 END;
arccos:=arg;
END;
PROCEDURE Arrange2(VAR a1,a2:REAL);
VAR r:REAL;
BEGIN IF(a2<a1)THEN
 BEGIN r:=a1; a1:=a2; a2:=r;
 END;
END;
PROCEDURE Irrange2(VAR a1,a2:INTEGER);
VAR i:INTEGER;
BEGIN IF(a2<a1)THEN
 BEGIN i:=a1; a1:=a2; a2:=i;
 END;
END;
PROCEDURE fffin(VAR fs:TEXT; k1,k2:INTEGER; VAR kkk:INTEGER;
                VAR ar:ARRAY OF REAL);
{Reads into Ar from k1 to k2; /=endfile, then kkk items
 if *, comment}
VAR   i,j,k,L:INTEGER; str,s:STRING; r:REAL;
BEGIN i:=k1; WHILE(NOT EoF(fs))DO
 BEGIN Readln(fs,str); IF(str='')THEN CONTINUE;
 IF(str[1]='*')THEN CONTINUE; IF(str[1]='/')THEN BREAK;
 k:=Pos('*',str); IF(k<>0)THEN str:=Copy(str,1,k-1); str:=str+' ';
 FOR j:=1 TO Length(str) DO
  IF((str[j]=',')OR(str[j]='	'))THEN str[j]:=' ';
 REPEAT FCompress(str); IF(Length(str)<>0)THEN
  BEGIN j:=Pos(' ',str); IF(j<>0)THEN
   BEGIN L:=j-1; s:=Copy(str,1,L); Delete(str,1,L+1); r:=0;
   IF s[1]='.' THEN s:='0'+s; Valz(s,r,k); ar[i-1]:=r;
   Inc(i); kkk:=i-k1;
   END;
  IF(i>k2)THEN Exit;
  END;
 UNTIL Length(str)=0;
 END;
END;
PROCEDURE fffins(VAR kkk:INTEGER; CONST fn:STRING);
{Program transforms the string sedz into real array ar from k1 to k2
 if endfile then only kkk items}
VAR   i,j,k,L:INTEGER; str,s:STRING; r:REAL;
LABEL Lend;
BEGIN i:=0; str:=fn+' ';
REPEAT FOR j:=1 TO Length(str) DO
 IF((str[j]=',')OR(str[j]='	'))THEN str[j]:=' ';
FCompress(str); IF(Length(str)=0)THEN GOTO Lend;
 j:=Pos(' ',str); IF(j=0)THEN GOTO Lend; L:=j-1;
 s:=Copy(str,1,L); Delete(str,1,L+1); r:=0;
 IF s[1]='.' THEN s:='0'+s; Valz(s,r,k); Inc(i); onl[i]:=r;
UNTIL false;
Lend: kkk:=i;
END;
PROCEDURE ftoa(r:REAL; nd,nf:INTEGER; VAR s:STRING);
{To convert float r (nd digits, nf after comma) to a string.
 Version Jul 9 1997, corrected by Oct 17 2000. Delphi = Nov 10 2000}
BEGIN ConvertStr(r,nd,nf); s:=sedz;
END;
PROCEDURE ftos(r:REAL; nd,nf:INTEGER; VAR s:STRING);
{To transform a float number to the scientific format, 8.11.00}
VAR i,j,ord:INTEGER; frac,rr,z:REAL; st:STRING;
BEGIN s:='0'; ord:=0; frac:=0;
IF(r<>0)THEN
 BEGIN z:=ABS(r); rr:=(LN(z)/2.30258509); IF(rr>0)THEN rr:=rr+1;
 ord:=Entier(ABS(rr)); ord:=sign(rr)*ord; frac:=powerRI(10,ord);
 frac:=z/frac; IF(frac=1)THEN
  BEGIN frac:=frac/10; ord:=ord+1;
  END;
 IF(r<0)THEN frac:=-frac;
 END;
rr:=ord; ConvertStr(rr,4,0); st:=sedz; FCompress(st);
IF(st[1]<>'-')THEN st:='+'+st;
ConvertStr(frac,nf+2,nf); s:=sedz+st; Compress(s); j:=Length(s);
IF(j<nd)THEN FOR i:=1 TO nd-j DO s:=' '+s;
END;
PROCEDURE Valz(CONST st:STRING; VAR r:REAL; VAR fail:INTEGER);
{Purpose: to convert a string st into a float r; OK=1,
 Fortran Version: January 6 1992, c++ one = July 10 2000
 DELPHI Nov 12 2000 }
VAR   i,k,ls,nstat,i0:INTEGER; c,fra,order,siord,sg,den:REAL; ch:CHAR;
      s:STRING;
LABEL L1,L2;
BEGIN IF(st[1]='*')THEN
 BEGIN r:=0; fail:=0; Exit;
 END;
nstat:=-1; c:=0; fail:=1; fra:=0; den:=10;
IF((st='')OR(st=' '))THEN GOTO L2;
siord:=1; order:=0; s:=st; FCompress(s); ls:=Length(s);
CASE s[1] OF
'+': BEGIN sg:=1; i0:=2;
     END;
'-': BEGIN sg:=-1; i0:=2;
     END;
ELSE sg:=1; i0:=1; END;
FOR i:=i0 TO ls DO
 BEGIN ch:=s[i]; k:=Ord(ch)-48;
 IF((ch='e')OR(ch='D')OR(ch='d'))THEN ch:='E'; IF(ch<>' ')THEN
  CASE nstat OF
  -1: { STATE=form the entire part of the number }
    IF((k>=0)AND(k<=9))THEN c:=c*10+k ELSE
     CASE ch OF
     '-': BEGIN siord:=-1; nstat:=1;
          END;
     '+': BEGIN siord:=1; nstat:=1;
          END;
     '.',',': nstat:=0;
     'E': nstat:=1;
     ELSE fail:=0; END;
   0: { STATE=form the fractional part of the number }
    IF((k>=0)AND(k<=9))THEN
     BEGIN fra:=fra+k/den; den:=den*10;
     END               ELSE
     IF((ch='E')OR(ch='+')OR(ch='-'))THEN
      BEGIN nstat:=1; GOTO L1;
      END                            ELSE fail:=0;
   1: { STATE=form the order }
    L1:IF((k>=0)AND(k<=9))THEN order:=order*10+k ELSE
     CASE ch OF
     '-': siord:=-1;
     '+': siord:=1;
     'E': nstat:=1;
     ELSE fail:=0; END;
  ELSE END;
 END;
c:=sg*(c+fra); k:={Entier}Trunc(siord*order);
IF(nstat>0)THEN c:=c*powerRI(10,k);
L2: r:=c;
END;
FUNCTION syngon(nsg,sett:INTEGER):INTEGER;
{Purpose: To determine the crystal symmetry;  Version: January 31 1995}
BEGIN syngon:=1;
CASE nsg OF
1,2: syngon:=1; {triclinic}
3..15: syngon:=2; {monoclinic}
16..74: syngon:=3; {orthorhombic}
75..142: syngon:=4; {tetragonal}
143..167: IF(nsg IN [146,148,155,160,161,166,167])THEN {trigonal}
     IF(sett=1)THEN syngon:=7 {rhombohedral}
               ELSE syngon:=6 {hexagonal}   ELSE syngon:=6; {hexagonal}
168..194: syngon:=6; {hexagonal}
195..230: syngon:=5; {cubic}
ELSE END;
END;
PROCEDURE fltostr(rr:REAL; nd:INTEGER; VAR s:STRING);
VAR ip,fp:INTEGER; uu:REAL;
BEGIN uu:=rr-Trunc(rr);
ConvertStr(rr,25,0); Compress(sedz); fp:=Length(sedz); ip:=MAX0(nd,fp);
IF(ABS(rr)>powerRI(10,nd-3))THEN ftos(rr,12,7,sedz) ELSE
IF(rr=0)THEN sedz:='0' ELSE
IF(uu=0)THEN ConvertStr(rr,ip,0) ELSE ConvertStr(rr,ip,MAX0(0,nd-1-fp));
Compress(sedz); s:=sedz;
END;
FUNCTION Even(n:INTEGER):BOOLEAN;
BEGIN IF((n DIV 2)*2=n)THEN Even:=true ELSE Even:=false;
END;
FUNCTION Odd(n:INTEGER):BOOLEAN;
BEGIN IF(Even(n))THEN Odd:=false ELSE Odd:=true;
END;
PROCEDURE AdjustSt(VAR s:STRING; n:INTEGER);
VAR i,j:INTEGER;
BEGIN Compress(s); j:=n-Length(s); FOR i:=1 TO j DO s:=' '+s;
END;
PROCEDURE marran(VAR n:INTEGER; l:INTEGER);
{Purpose: to arrange the array onl in an increasing (l>0)
          or a decreasing (l<0) order
          or delete the coinciding neighbors (l=0)
          Version: Dec 11 1996}
CONST d:REAL = -0.123456789012;
VAR   i,j,k:INTEGER; r:REAL;
BEGIN IF(n<=1)THEN Exit;
CASE l OF
0: BEGIN FOR i:=1 TO n-1 DO IF(onl[i]=onl[i+1])THEN onl[i]:=d;
   k:=0; FOR i:=1 TO n DO IF(onl[i]<>d)THEN
    BEGIN Inc(k); onl[k]:=onl[i];
    END;
   n:=k;
   END;
1: BEGIN FOR i:=2 TO n DO FOR j:=1 TO n-i+1 DO IF(onl[j]>=onl[j+1])THEN
    BEGIN r:=onl[j+1]; onl[j+1]:=onl[j]; onl[j]:=r;
    END;
   END;
-1:BEGIN FOR i:=2 TO n DO FOR j:=1 TO n-i+1 DO IF(onl[j]<=onl[j+1])THEN
    BEGIN r:=onl[j+1]; onl[j+1]:=onl[j]; onl[j]:=r;
    END;
   END;
ELSE END;
END;
PROCEDURE ExtractFN(CONST s1:STRING; VAR s2:STRING);
VAR i:INTEGER;
BEGIN s2:=s1; i:=PosB('.',s2); IF(i<>0)THEN Delete(s2,i,4);
i:=PosB('\',s2); IF(i<>0)THEN Delete(s2,1,i);
END;
FUNCTION AMOD(r:REAL; y:REAL):REAL;
VAR x:REAL;
BEGIN AMOD:=0; IF(y<=0)THEN Exit; x:=r;
IF(ABS(r)<y)THEN x:=ABS(r) ELSE
IF(ABS(r)=y)THEN x:=0 ELSE
 REPEAT x:=ABS(x)-y;
 UNTIL x<y;
x:=x*sign(r); AMOD:=x;
END;
PROCEDURE BubbleSort(n:INTEGER);
VAR j:INTEGER; changed:BOOLEAN;
BEGIN REPEAT changed:=false; FOR j:=2 TO n DO{Bubble Sorting}
 BEGIN IF(onl[j-1]>onl[j])THEN
  BEGIN r:=onl[j-1]; changed:=true; onl[j-1]:=onl[j]; onl[j]:=r;
  END;
 END; UNTIL NOT changed;
END;
PROCEDURE mcleanz(VAR n:INTEGER; m:INTEGER);
{Purpose: purges positive (m=+1), negative (m=-1) or zero (m=0) values
          from array onl.   Nov 21 2003}
VAR i,k:INTEGER; ok:BOOLEAN;
BEGIN k:=0; FOR i:=1 TO n DO
 BEGIN ok:=false; CASE m OF
 -1: IF(onl[i]>=0)THEN ok:=true;
  0: IF(onl[i]<>0)THEN ok:=true;
  1: IF(onl[i]<=0)THEN ok:=true;
            ELSE END;
 IF(ok)THEN
  BEGIN Inc(k); onl[k]:=onl[i];
  END;
 END;
n:=k;
END;
FUNCTION CheckBlank(CONST s:STRING):BOOLEAN;
VAR i:INTEGER; ok:BOOLEAN;
BEGIN ok:=true; FOR i:=1 TO Length(s) DO IF(s[i]<>' ')THEN
 BEGIN ok:=false; BREAK;
 END;
CheckBlank:=ok;
END;
FUNCTION Factorial(n:INTEGER):REAL;
VAR i:INTEGER; ff:LONGINT;
BEGIN ff:=1; FOR i:=2 TO n DO ff:=ff*i; Factorial:=ff;
END;
PROCEDURE ErrorMessage(m:INTEGER; CONST s:STRING);
BEGIN ShowMess('Something wrong with file '+s);
IF(m=0)THEN Abort;
END;
PROCEDURE Zval(CONST s:STRING; VAR x:REAL);
VAR j:INTEGER; r:STRING;
BEGIN r:=s; IF((s='')OR(s=' '))THEN
 BEGIN x:=0; Exit;
 END;
Compress(r); DecimalSeparator:='.'; ModalRes:=1;
FOR j:=1 TO Length(r) DO IF(r[j]=',')THEN r[j]:='.';
Valz(r,x,j); IF(j=0)THEN
 BEGIN ModalRes:=0; {ShowMess(wrnum+' '+s);} x:=1.001;
 END;
END;
PROCEDURE ZExchange(VAR a,b:REAL);
VAR r:REAL;
BEGIN r:=a; a:=b; b:=r;
END;
PROCEDURE GraphSpecAndModel(CONST Im:TImage; m,ng,npo:INTEGER);
{Shows graphs of 2 histograms: from onl[1] and onl[m+1], m items;
 if ng=1, only 1 graph; npo - number of pointers from onl[2m+1]
 Form2 should be prepared and all its components closed.
 Not more than 5 strings (comments) from LB1rec.  Jan 17 2003}
VAR x1,y1,i,j,dh,n:INTEGER; amx,amn,rx,x,z,r:REAL;
    ii,jj,li,lj,ix1,ix2,iy1,iy2:LONGINT;
BEGIN x1:=exs(4); dh:=exs(70);
WITH Im DO
 BEGIN Left:=exs(5); Top:=1; Width:=exs(310);
 Height:=exs(380); Visible:=true; iy1:=Width; iy2:=Height;
 END;
WITH Im.Canvas DO WITH Brush DO
 BEGIN Color:=0; Style:=bsSolid; FillRect(Rect(0,1,iy1,exs(290)));
 Color:=clGreen; FillRect(Rect(0,1+exs(290),iy1,iy2));
 END;
L0rec:='Real peak model and its spectrum pattern';
y1:=0; amx:=-1E14; amn:=1E14; j:=2*m; IF(ng=1)THEN j:=m;
FOR i:=1 TO j DO
 BEGIN z:=onl[i]; amx:=AMAX1(amx,z); amn:=AMIN1(amn,z);
 END;
WITH Im.Canvas DO
 BEGIN Pen.Style:=psSolid; Font.Color:=clWhite; Brush.Color:=clGreen;
 Font.Style:=[fsBold]; Font.Size:=8; FOR i:=1 TO 5 DO
  BEGIN lj:=exs(283)-(i-1)*dh; li:=exs(x1+8);
  FOR j:=1 TO exs(75) DO Pixels[li+(j-1)*4-1,lj]:=clLime;
  END;
 Pen.Color:=clAqua; FOR i:=1 TO m DO
  BEGIN x:=exs(i*290); x:=x/m; j:=Trunc(x); li:=exs(x1+10)+j;
  rx:=AMAX1(amx-amn,0.000001); r:=(onl[i]-amn)/rx*exs(280);
  r:=exs(283)-r; lj:=y1+Round(r); FOR ii:=-1 TO 1 DO FOR jj:=-1 TO 1 DO
   IF((ABS(ii)+ABS(jj))<2)THEN Pixels[li+ii,lj+jj]:=clFuchsia;
  IF(ng=1)THEN CONTINUE;
  r:=(onl[i+m]-amn)/rx*exs(280); r:=exs(283)-r; lj:=y1+Round(r);
  IF(i=1)THEN
   BEGIN ix1:=li; iy1:=lj;
   END   ELSE
    BEGIN ix2:=li; iy2:=lj; Moveto(ix1,iy1); Lineto(ix2,iy2);
    ix1:=ix2; iy1:=iy2;
    END;
  END;
 FOR i:=1 TO 4 DO
  BEGIN li:=x1+(i-1)*exs(63)+exs(61);
  FOR j:=1 TO 57 DO Pixels[li,y1-4+Round((j-1)*5*scrsize)]:=clLime;
  END;
 WITH LB1rec DO FOR i:=1 TO MIN0(5,nitems) DO
  BEGIN TextOut(5,exs(295)+(i-1)*exs(15),LB1rec.ar[i]);
  END;
 ConvertStr(amx,10,0); Compress(sedz);
 TextOut(exs(5),exs(369),'Mx= '+sedz);
 ConvertStr(amn,10,0); Compress(sedz);
 TextOut(exs(260),exs(369),'Mn= '+sedz);
 END;
{Draw pointers} FOR i:=1 TO npo DO
 BEGIN jj:=Round(onl[2*m+i]); r:=ABS(jj)*exs(290); r:=r/m;
 j:=Trunc(r)+10+x1;
 WITH Im.Canvas DO
  BEGIN IF(jj>0)THEN Pen.Color:=clAqua ELSE Pen.Color:=clYellow;
  li:=j; MoveTo(li,exs(285)); LineTo(li,exs(295));
  END;
 END;
Im.Canvas.Font.Size:=fntsize;
END;
PROCEDURE ShowMess(CONST s:STRING);
VAR i:INTEGER;
BEGIN i:=MessageDlgPos(s,mtCustom,[mbOK],0,320,320);
END;
PROCEDURE GetSetInfo(CONST sf:STRING);
VAR r:REAL; i:INTEGER;
 PROCEDURE CheckSI(a,b:REAL);
 BEGIN Zval(Copy(sedz,1,i-1),r); IF(r>b)THEN r:=b; IF(r<a)THEN r:=a;
 END;
BEGIN AssignFile(ft,sf); {$I-} Reset(ft); {$I+};
IF(IOResult<>0)THEN Exit;
EnterStr(ft); inifn:=sedz;
EnterStr(ft); i:=Pos('*scrsize',sedz); IF(i<>0)THEN
 BEGIN CheckSI(0.64,1.56); scrsize:=r;
 END;
EnterStr(ft); i:=Pos('*fntsize',sedz); IF(i<>0)THEN
 BEGIN CheckSI(8,14); fntsize:=Round(r);
 END;
EnterStr(ft); i:=Pos('*RusHelp',sedz); IF(i<>0)THEN
 BEGIN CheckSI(0,1); RusHelp:=false; IF(r=1)THEN RusHelp:=true;
 END;
CloseFile(ft);
END;
PROCEDURE SaveSettings(CONST s:STRING);
BEGIN AssignFile(ft,s); {$I-} Rewrite(ft); {$I+};
IF(IOResult=0)THEN
 BEGIN Writeln(ft,inifn); Writeln(ft,scrsize:10:4,' *scrsize');
 Writeln(ft,fntsize:10,' *fntsize');
 Write(ft,' ':9); IF(RusHelp)THEN Write(ft,'1') ELSE Write(ft,'0');
 Writeln(ft,' *RusHelp');
 CloseFile(ft);
 END;
END;
PROCEDURE EraseEmptyF(CONST fn:STRING);
BEGIN AssignFile(fbyt,fn); {$I-} ReSet(fbyt); {$I+};
IF(FileSize(fbyt)<4)THEN
 BEGIN CloseFile(fbyt); Erase(fbyt);
 END;
END;
PROCEDURE GetRealRootCubic(a,b,c,d:REAL; VAR x:REAL);
VAR r,p,q:REAL;
BEGIN x:=0; IF(a=0)THEN
 BEGIN ShowMess('a=0 in cubic equ.'); Exit;
 END;
p:=-SQR(b)/(3*SQR(a))+c/a;
q:=(2/27)*PowerRI(b/a,3)-b*c/(3*SQR(a))+d/a;
r:=SQR(q/2)+PowerRI(p/3,3); IF(r<0)THEN
 BEGIN ShowMess('No real root'); Exit;
 END;
r:=SQRT(r); x:=PowerRR(-q/2+r,1/3)+PowerRR(-q/2-r,1/3);
END;
FUNCTION OWriteFile(CONST s:STRING):BOOLEAN;
VAR i:INTEGER; o:BOOLEAN;
BEGIN o:=true; IF(FileExists(s))THEN
 BEGIN i:=
  MessageDlg(s+' already exists.Overwrite?',MtWarning,[mbYes,mbNo],0);
 IF(i=mrNo)THEN o:=false ELSE o:=true;
 END;
OWriteFile:=o;
END;
PROCEDURE ErrMark;
BEGIN ShowMess('Error, the marking data is not correct');
END;
PROCEDURE HexaToWord(CONST s:STRING; VAR w:WORD);
VAR i,j,cs:INTEGER; ch:CHAR; s4:STRING[4];
BEGIN j:=Length(s); w:=0; s4:='0000';
FOR i:=j DOWNTO 1 DO s4[4-j+i]:=s[i];
FOR i:=1 TO 4 DO
 BEGIN ch:=s4[i];
 CASE ch OF
 'a','A': cs:=10;
 'b','B': cs:=11;
 'c','C': cs:=12;
 'd','D': cs:=13;
 'e','E': cs:=14;
 'f','F': cs:=15;
 '0'..'9': cs:=Ord(ch)-48;
 ELSE END;
 w:=w*16+cs;
 END;
END;
PROCEDURE DrawPixelPr(cl,li,lj,i,ic1,n:INTEGER);
VAR ii,jj:INTEGER;
BEGIN WITH Bitmap.Canvas DO
CASE pixelm OF
0: FOR ii:=-1 TO 1 DO FOR jj:=-1 TO 1 DO
    IF((ABS(ii)+ABS(jj))<2)THEN Pixels[li+ii,lj+jj]:=cl;
1: Pixels[li,lj]:=cl;
2: BEGIN Pen.Color:=cl;
   IF(i=ic1)THEN
    BEGIN jxg1[n]:=li; jyg1[n]:=lj;
    END     ELSE
    BEGIN jxg2[n]:=li; jyg2[n]:=lj;
    Moveto(jxg1[n],jyg1[n]); Lineto(jxg2[n],jyg2[n]);
    jxg1[n]:=jxg2[n]; jyg1[n]:=jyg2[n];
    END;
   END;
ELSE END;
END;
PROCEDURE MakeBMFrame(amx,amn:REAL);
VAR i,j,li,lj:INTEGER; r,del:REAL;
BEGIN WITH Bitmap.Canvas DO
 BEGIN Pen.Style:=psSolid; Pen.Color:=clLime; Font.Style:=[fsBold];
 Font.Size:=fntsize; Brush.Style:=bsSolid; Brush.Color:=0;
 FillRect(Rect(0,0,exs(wgraph-104),exs(323)));
 del:=(amx-amn)/4; FOR i:=1 TO 5 DO  {Horizontal}
  BEGIN r:=amx-(i-1)*del; IF(nscale=4)THEN r:=r*trimm;
  ConvertStr(r,7,0); lj:=exs({y1+}(i-1)*(hgraph DIV 4)+3); li:=0;
  FOR j:=1 TO 103 DO Pixels[exs(li+(j-1)*5),lj]:=clLime;
  END;
 FOR i:=1 TO 8 DO  {Vertical}
  BEGIN li:=exs(34+(i-1)*64);
  FOR j:=1 TO 57 DO Pixels[li,exs({y1}-4+(j-1)*5)]:=clLime;
  END;
 END;
END;
FUNCTION CalcOrdinate(z,amx,amn:REAL):LONGINT;
VAR r,rx:REAL; {hgraph=272}
BEGIN rx:=AMAX1(amx-amn,1); r:=z-amn;
CASE nscale OF
1: r:=r/rx;
2: r:=SQRT(ABS(r)/rx);
3: r:=LN(AMAX1(1,r))/LN(rx+1);
4: r:=AMIN1(r,rx*trimm)/(rx*trimm);
ELSE END;
r:=r*hgraph; r:=hgraph+3-r; CalcOrdinate:=Round(r);
END;
PROCEDURE ExchangeStr(VAR s1,s2:STRING);
VAR s:STRING;
BEGIN s:=s1; s1:=s2; s2:=s;
END;
FUNCTION LogToStr(x:BOOLEAN):STRING;
BEGIN IF(x)THEN LogToStr:='true' ELSE LogToStr:='false';
END;
FUNCTION FltoSt(x:REAL; n:INTEGER):STRING;
BEGIN ConvertStr(x,25,n); Compress(sedz); FltoSt:=sedz;
END;
PROCEDURE ComplexDiv(re1,im1,re2,im2:REAL; VAR reo,imo:REAL);
{To divide 2 complex numbers, Dec 21 2005}
VAR r:REAL;
BEGIN r:=SQR(re2)+SQR(im2); reo:=0; imo:=0; IF(r<>0)THEN
 BEGIN reo:=(re1*re2+im1*im2)/r; imo:=(im1*re2-im2*re1)/r;
 END;
END;
PROCEDURE ComplexMult(re1,im1,re2,im2:REAL; VAR reo,imo:REAL);
{To multiply 2 complex numbers, Dec 26 2005}
BEGIN reo:=re1*re2-im1*im2; imo:=re1*im2+re2*im1;
END;

{----}
BEGIN scrsize:=1; fntsize:=10;
WITH debugV DO
 BEGIN cbipr:=false; aniso:=false; indtest:=false; activ:=false;
 powdmath:=false; peaksear:=false; magnetic:=false; hkli:=false;
 FOR i:=1 TO 7 DO uparith[i]:=false;
 END;
END.



