PROGRAM vedz;
{Purpose: to edit texts.  Version: Jan 11 2001}
USES Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs,  Menus, StdCtrls, ExtCtrls, vedz0, vzlocom, vpmodel, vedz4,
  vedz1 in 'vedz1.pas' {Form1},
  vedz2 in 'vedz2.pas' {Form2},
  vedz3 in 'vedz3.pas' {Form3};

VAR ar,ar1:ARRAY[1..1000000] OF BYTE;
{$R *.RES}
PROCEDURE Initial;
VAR i,j:INTEGER; s:STRING;
BEGIN scrsize:=1.25; fntsize:=11; WITH Form1 DO
 BEGIN  Left:=0; Top:=0; Width:=exs(630); Height:=exs(470);
 Caption:='  VISUAL EDZ +++ 2007,    by Zlokazov V.B.';
 Color:=clBtnFace; Font.Size:=fntsize;
 END;
{WITH Form3 DO
 BEGIN Left:=0; Top:=0; Width:=exs(630); Height:=exs(470);
 END;}
IF(FileExists('vedz.ini'))THEN
 BEGIN AssignFile(ft,'vedz.ini'); {$I-} Reset(ft); {$I+};
 Readln(ft,s); UpCaseStr(s); IF(s[1] IN ['A'..'F'])THEN fldisk:=s[1];
 CloseFile(ft);
 END;
hbl:=dblank+dblank;
{EC-standard code}
{FOR i:=1 TO 128 DO CodC[i]:=Chr(i);
CodC[97]:=#160; CodC[98]:=#161; CodC[99]:=#230; CodC[100]:=#164;
CodC[101]:=#165; CodC[102]:=#228; CodC[103]:=#163; CodC[104]:=#229;
CodC[105]:=#168; CodC[106]:=#169; CodC[107]:=#170; CodC[108]:=#171;
CodC[109]:=#172; CodC[110]:=#173; CodC[111]:=#174; CodC[112]:=#175;
CodC[113]:=#239; CodC[114]:=#224; CodC[115]:=#225; CodC[116]:=#226;
CodC[117]:=#227; CodC[118]:=#166; CodC[119]:=#162; CodC[120]:=#236;
CodC[121]:=#235; CodC[122]:=#167;
FOR i:=1 TO 26 DO
 BEGIN j:=Ord(CodC[96+i]);
 IF(j IN [160..175])THEN CodC[64+i]:=Chr(j-32);
 IF(j IN [224..239])THEN CodC[64+i]:=Chr(j-80);
 END;
CodC[91]:=#232; CodC[123]:=#152; CodC[93]:=#233; CodC[125]:=#153;
CodC[39]:=#238; CodC[34]:=#158; CodC[96]:=#231; CodC[126]:=#151;
CodC[92]:=#237; CodC[124]:=#157;
ResetFile;}
{DEBUG}
END;

BEGIN
Application.Initialize;
Application.CreateForm(TForm1, Form1);
  Application.CreateForm(TForm2, Form2);
  Application.CreateForm(TForm3, Form3);
  Initial; HideComponents;
AssignFile(fout,'e.res'); Rewrite(fout);
pmod[1]:=TPeakModel.Create;
Application.Run;
END.

PROCEDURE Test2VGFit;
{Purpose: to test gfit  Version: Jun 28 1998}
VAR n,m,i,j,k:INTEGER; c,cmax,x,z:REAL;
{---------------------}
BEGIN n:=2; {Number of parameters}
m:=100; {Number of points}
tfit:=TParameter.Create(n,n,m);
c:=0.1;
{textfile FOUT should be opened}
WITH tfit DO
 BEGIN FormCB; FormParameters; WITH cb DO
  BEGIN gnit:=13; ipr:=1; step:=0.75; damp:=0.01;
  END;
 {Exact parameters}
 par[1].p:=1;    par[1].pl:=0.1;   par[1].pu:=10000000;
 par[2].p:=100; par[2].pl:=0.1; par[2].pu:=1000;
 {Build quasi-experimental values}
 FOR i:=1 TO m DO
  BEGIN x:=c*i; z:=par[1].p*x+par[2].p;
  onl[i]:=z+SIGN(Random-0.5)*SQRT(z);
  END;
 par[1].p:=2;    {Initial parameters}
 par[2].p:=59;
 LeastSquaresFit;
 prifch; {Fitting characteristics}
 cmax:=0;
 lsmprn(cmax); {Fitting graph; cmax= graph max; if 0,set auto}
 primat; {Correlation coefficients}
 END;
{results in FOUT; if FOUT then not needed should be closed}
tfit.Free;
END;
PROCEDURE Arith(VAR y,w,f:REAL; i,typ:INTEGER);
{The arithmetic procedure for least squares minimization;
    f  = a*x^b*exp(-g*x)
 computes function value + 1-st derivatives, May 11 1999}
VAR x,z:REAL;
BEGIN x:=Floa(i)*0.1; WITH tfit DO
 BEGIN f:=par[1].p*z+par[2].p; y:=onl[i]; w:=1/(ABS(y)+1);
 drv[1]:=z; drv[2]:=1;
 END;
END;
PROCEDURE Regul(VAR a,b:REAL);
BEGIN {Dummy}
END;
PROCEDURE ReadMusRecord;
BEGIN Readln(ft,comp); Readln(ft,opname); Readln(ft,optime);
Readln(ft,orch); Readln(ft,perf);
END;
PROCEDURE ReWriteSashinFile;
VAR i,j,kkk:INTEGER;
BEGIN AssignFile(ft,'\zlok\na_dos.txt'); {$I-} Reset(ft); {$I+};
j:=0; WHILE(NOT EoF(ft))DO
 BEGIN Readln(ft,s); IF(s[1]='*')THEN CONTINUE;
 FOR i:=1 TO Length(s) DO IF(s[i]=',')THEN s[i]:='.';
 FOR i:=1 TO Length(s) DO IF(s[i]='	')THEN s[i]:=' ';
 fffins(kkk,s);
 FOR i:=1 TO 6 DO Write(fout,onl[i]:12:4); Writeln(fout);
 END;
CloseFile(ft);
END;
PROCEDURE TestAuPar;
VAR i,h,k,l:INTEGER; r,a,b,c,dda,ddb,ddc,det:REAL; ok:BOOLEAN;
BEGIN
a:=5; b:=4; c:=3;
FOR h:=-7 TO 7 DO FOR k:=-7 TO 7 DO FOR l:=0 TO 7 DO
  IF((h<>0)OR(k<>0)OR(l<>0))THEN
 BEGIN r:=SQRT(SQR(h/a)+SQR(k/b)+SQR(l/c)); r:=r*r*r;
 dda:=-2*h*h/(a*a*a*r);
 ddb:=-2*k*k/(b*b*b*r);
 ddc:=-2*l*l/(c*c*c*r);
 mat3[1,1]:=mat3[1,1]+dda*dda;
 mat3[1,2]:=mat3[1,2]+dda*ddb;
 mat3[1,3]:=mat3[1,3]+dda*ddc;
 mat3[2,1]:=mat3[2,1]+ddb*dda;
 mat3[2,2]:=mat3[2,2]+ddb*ddb;
 mat3[2,3]:=mat3[2,3]+ddb*ddc;
 mat3[3,1]:=mat3[3,1]+ddc*dda;
 mat3[3,2]:=mat3[3,2]+ddc*ddb;
 mat3[3,3]:=mat3[3,3]+ddc*ddc;
 END;
FOR i:=1 TO 3 DO onl[i]:=mat3[i,i];
InvertSMatrix3(ok,det);
r:=0; FOR i:=1 TO 3 DO r:=r+onl[i]*mat3[i,i];
Writeln(fout,r:15:5,ok:6,' det= ',det:12:6);
FOR h:=-7 TO 7 DO FOR k:=-7 TO 7 DO FOR l:=0 TO 7 DO
  IF((h<>0)OR(k<>0)OR(l<>0))THEN
 BEGIN r:=SQRT(SQR(h/a)+SQR(k/b)+SQR(l/c)); r:=r*r*r;
 dda:=h*h;
 ddb:=k*k;
 ddc:=l*l;
 mat3[1,1]:=mat3[1,1]+dda*dda;
 mat3[1,2]:=mat3[1,2]+dda*ddb;
 mat3[1,3]:=mat3[1,3]+dda*ddc;
 mat3[2,1]:=mat3[2,1]+ddb*dda;
 mat3[2,2]:=mat3[2,2]+ddb*ddb;
 mat3[2,3]:=mat3[2,3]+ddb*ddc;
 mat3[3,1]:=mat3[3,1]+ddc*dda;
 mat3[3,2]:=mat3[3,2]+ddc*ddb;
 mat3[3,3]:=mat3[3,3]+ddc*ddc;
 END;
FOR i:=1 TO 3 DO onl[i]:=mat3[i,i];
InvertSMatrix3(ok,det);
r:=0; FOR i:=1 TO 3 DO r:=r+onl[i]*mat3[i,i];
Writeln(fout,'Par2: ',r:15:5,ok:6,' det= ',det:12:6);
a:=1/5; b:=1/4; c:=1/3;
FOR h:=-7 TO 7 DO FOR k:=-7 TO 7 DO FOR l:=0 TO 7 DO
  IF((h<>0)OR(k<>0)OR(l<>0))THEN
 BEGIN r:=SQRT(SQR(h/a)+SQR(k/b)+SQR(l/c)); r:=r*r*r;
 dda:=2*a*h*h;
 ddb:=2*b*k*k;
 ddc:=2*c*l*l;
 mat3[1,1]:=mat3[1,1]+dda*dda;
 mat3[1,2]:=mat3[1,2]+dda*ddb;
 mat3[1,3]:=mat3[1,3]+dda*ddc;
 mat3[2,1]:=mat3[2,1]+ddb*dda;
 mat3[2,2]:=mat3[2,2]+ddb*ddb;
 mat3[2,3]:=mat3[2,3]+ddb*ddc;
 mat3[3,1]:=mat3[3,1]+ddc*dda;
 mat3[3,2]:=mat3[3,2]+ddc*ddb;
 mat3[3,3]:=mat3[3,3]+ddc*ddc;
 END;
FOR i:=1 TO 3 DO onl[i]:=mat3[i,i];
InvertSMatrix3(ok,det);
r:=0; FOR i:=1 TO 3 DO r:=r+onl[i]*mat3[i,i];
Writeln(fout,'Par3:   ',r:15:5,ok:6,' det= ',det:12:6);
END;
PROCEDURE TestRatio;
{Check the distribution  of (n-m)/sqrt(n+m)}
VAR i,j,jj,n,m,nex:INTEGER; n1,n2,ex,v,si:REAL;
    dist:ARRAY[1..101] OF REAL;
BEGIN FOR i:=1 TO 101 DO dist[i]:=0; ex:=0; v:=0; nex:=0;
FOR jj:=1 TO 10000 DO
 BEGIN n:=10; n1:=0; n2:=0; FOR i:=1 TO n DO
  BEGIN rpois(m); n1:=n1+m; rpois(m); n2:=n2+m;
  END;
 n1:=n1*0.5; n2:=n2*0.5;
 IF((n1+n2)<>0)THEN
  BEGIN r:=(n1-n2)/SQRT(AMAX1(0.5*n1+0.5*n2,1));
  j:=Round(r*SQRT(2*Float(n)))+51; ex:=ex+r; v:=v+r*r;
  IF(infun(j,1,101))THEN dist[j]:=dist[j]+1; Inc(nex);
  END;
 END;
ex:=ex/nex; v:=v/nex-ex*ex; si:=SQRT(ABS(v));
Writeln(fout,nex:7,ex:10:4,v:10:2,si:8:4);
FOR i:=1 TO 101 DO Writeln(fout,i:5,dist[i]:8:2);
FOR i:=1 TO 101 DO onl[i]:=dist[i]; m:=101;
L0rec:=''; MakeFormV(250,20,330,430,0);
GraphSpecAndModel(Form2.Image1,m,0,0);
END;
PROCEDURE CalcEntropy(m2:MATRA; VAR en,sca:REAL; pr:INTEGER);
VAR i,j,k:INTEGER; r2:REAL;
BEGIN en:=0; sca:=0; r2:=nma*nma;
FOR i:=1 TO nma DO FOR j:=1 TO nma DO en:=en-m2[i,j]*ln(m2[i,j]);
r:=0; FOR i:=1 TO nma DO FOR j:=1 TO nma DO
 BEGIN r:=r+m2[i,j]; sca:=sca+SQR(m2[i,j]);
 END;
r:=r/r2; sca:=sca/r2-SQR(r);
IF(pr=1)THEN Writeln(fout,'Entropy= ',en:12:5,'  Scatt.= ',sca:12:5);
END;
{max,min,dif=  0.237608 0.001304 0.236304
Entropy=     20.80921  Scatt.=      0.00391
max,min,dif=  0.152463 0.041701 0.110762
    1         0    0        2000
Entropy=     22.61881  Scatt.=      0.00079
max,min,dif=  0.139343 0.057117 0.082225
    2         0    0        2000
Entropy=     22.65622  Scatt.=      0.00072
max,min,dif=  0.137832 0.060501 0.077331
    3         0    0        2000
Entropy=     22.65762  Scatt.=      0.00072
max,min,dif=  0.137529 0.060917 0.076611
    4         0    0        2000
Entropy=     22.65776  Scatt.=      0.00072
max,min,dif=  0.137479 0.060947 0.076533
    5         0    0        2000
Entropy=     22.65781  Scatt.=      0.00072
max,min,dif=  0.137472 0.060961 0.076511
    6         0    0        2000
Entropy=     22.65782  Scatt.=      0.00072
max,min,dif=  0.137471 0.060962 0.076509
    7         0    0        2000
Entropy=     22.65782  Scatt.=      0.00072
max,min,dif=  0.137470 0.060962 0.076509
    8         1    1        2000
Entropy=     22.65782  Scatt.=      0.00072
max,min,dif=  0.137470 0.060962 0.076508
    9         1    1        2000
Entropy=     22.65782  Scatt.=      0.00072
max,min,dif=  0.137470 0.060962 0.076508
   10         1    1        2000
Entropy=     22.65782  Scatt.=      0.00072
max,min,dif=  0.137470 0.060962 0.076508
   11         1    1        2000
Entropy=     22.65782  Scatt.=      0.00072
max,min,dif=  0.137470 0.060962 0.076508
   12         1    1        2000
Entropy=     22.65782  Scatt.=      0.00072
max,min,dif=  0.137470 0.060962 0.076508
   13         0    0        2000    }
PROCEDURE TestMutations;
{Check the model "mutations+selection"}
VAR   i,j,k,nl,nc,n,nt,ii,jj,nc1:INTEGER; pra:ARRAY[1..1000] OF REAL;
      ax,an,a,b,sc,en,mxm,mnm:REAL;
 PROCEDURE SendMatr(a:MATRA; VAR b:MATRA);
 VAR i,j:INTEGER;
 BEGIN FOR i:=1 TO nma DO FOR j:=1 TO nma DO b[i,j]:=a[i,j];
 END;
LABEL Lend,Lpart2,Lend1;
BEGIN nl:=1000{0000}; n:=5; nc:=0; nt:=13; GOTO Lpart2;
                   {Part 1}
b:=rndm(-1);{FOR k:=1 TO nt DO}
 BEGIN n:=k; nc:=0; n:=1; FOR i:=1 TO nl DO
  BEGIN b:=1; FOR j:=1 TO 1000 DO
   BEGIN {rannor(r,b);} r:=rndm(-1); {r:=rndexp(1);}
   {IF(j=1)THEN pra[j]:=r;
   IF(j>1)THEN IF(r>pra[j-1])THEN pra[j]:=r ELSE GOTO Lend ELSE ;}
   b:=b*r;
   IF(b=0)THEN GOTO Lend;
   END;
  Inc(nc);
  Lend:;
  END;
 Writeln(fout,k:5,nc:10,nl:12,(Float(nl)/Factorial(k)):10:0);
 END;
ShowMess('Done'); Exit;
                   {Part 2} {Matrix evolution}
Lpart2: FormProbMatrix(mat,0); FindMatrixMaxMin(ax,an,mat);
SendMatr(mat,m1); FOR k:=1 TO 32 DO
 BEGIN nc:=0; nc1:=0; CalcEntropy(mat,b,a,1);
 FormProbMatrix(m1,0); MultiMatr(m1,mat,m2);
 FindMatrixMaxMin(ax,an,m2); SendMatr(m2,mat);
 END;
ShowMess('Done');
END;
PROCEDURE CalcProbExp;
VAR i,j,N,m:INTEGER; B,bc,b0,r,lb,T,lc,p,p0,pt,te,ve,v:REAL;
BEGIN N:=150000; T:=100; B:=100{*ln(2)}; lc:=1/T; lb:=1/B;
m:=0; p:=0; v:=0; FOR j:=1 TO N DO
 BEGIN r:=rndexp(lc); {event}
 b0:=rndexp(lb); {observation interv}
 IF(r>b0)THEN
  BEGIN Inc(m); p:=p+b0; v:=v+b0*b0;
  END;
 END;
p:=p/FLOAT(m); p0:=FLOAT(m)/FLOAT(N); pt:=T/(T+B); v:=v/m-p*p;
ShowMess('Pr '+FloatToStr(p)+'  '+FloatToStr(p0)+'  '+IntToStr(m));
te:=(T*B)/(B+T);
ShowMess('E= '+FloatToStr(p)+'  '+FloatToStr(te)); lb:=l*B;
ve:=2*SQR(T*B)/SQR(B+T)-te*te;
ShowMess('V= '+FloatToStr(v)+'  '+FloatToStr(ve));
END;

