UNIT vactiv1;

INTERFACE

USES  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
      Dialogs, Menus,    StdCtrls, Grids,   ExtCtrls, vactiv0,  vzlocom,
      vactiv2, varfun,   vactsg,   vacthlp, vactfit,  vactfl,   vactinf,
      vactda,  vactmrk,  vspectr,  vpmodel, vpeaksr,  vgfit,   vstdcons,
      vactiv3;
PROCEDURE ResizeF1(sc1,sc2:REAL);
PROCEDURE ResizeF2(sc1,sc2:REAL);
PROCEDURE HideComponents;
PROCEDURE ClearForm(col:INTEGER);
PROCEDURE SetCadre;
PROCEDURE AFitting(mo:INTEGER);
PROCEDURE ClearArea(lx1,ly1,lx2,ly2,c:LONGINT);
PROCEDURE GraphMain(VAR amx0:REAL);
FUNCTION PointChan(x:INTEGER):REAL;
PROCEDURE MakePeakMarking;
PROCEDURE DisplPoint(x1,y1,x2,y2:LONGINT; r:REAL);
PROCEDURE DisplVal(x1,y1,x2,y2:LONGINT; a,r,w:REAL);
PROCEDURE Block4Buttons;
PROCEDURE DisplArea(x1,y1,x2,y2:LONGINT; a,r,w,e:REAL);
PROCEDURE GettheBounds(VAR ic1,ic2,cadl:INTEGER);
PROCEDURE HideLabels;
PROCEDURE LabelOut(CONST s1,s2:STRING);
TYPE
  TForm1 = CLASS(TForm)
    MainMenu1: TMainMenu;
  {File}File1: TMenuItem;
     InputtheSpectrum1: TMenuItem;
     CorrectforBlunders1: TMenuItem;
     CompresstheSpectrum1: TMenuItem;
     SmooththeSpectrum1: TMenuItem;
     BuildtheBackground1: TMenuItem;
     SimulatetheSpectrum1: TMenuItem;
     N1: TMenuItem;
     SavetheSummarytable1: TMenuItem;
     SavetheInitfile1: TMenuItem;
     SaveEnergyCalibration1: TMenuItem;
     SaveEfficiencyCalibration1: TMenuItem;
     N2: TMenuItem;
     Exit1: TMenuItem;
  {Settings}Settings1: TMenuItem;
     SettheSpectrumdata1: TMenuItem;
     SettheMarkingData1: TMenuItem;
     SettheFitData1: TMenuItem;
     N5: TMenuItem;
     CleartheForm1: TMenuItem;
     SetWidthDependence1: TMenuItem;
     SetGraphScale1: TMenuItem; {Cancel}
     SettheNextSpectrumName1: TMenuItem;
     ToggletheFormSize1: TMenuItem;
  {Graph}Graph1: TMenuItem;
     GraphtheSpectrum2: TMenuItem;
     GraphaCadre1: TMenuItem;
     ClickaCadre1: TMenuItem;
     GraphPeakModel1: TMenuItem;
     GraphEnergyCalibration1: TMenuItem;
  {Mark}Mark1: TMenuItem;
     CuttheInterval1: TMenuItem;
     MarkPeaksonGraph1: TMenuItem;
     MarkandBuildthePeakModel1: TMenuItem;
     CheckforPeakandAdd1: TMenuItem;
  {Operation}Operation1: TMenuItem;
     Reset1: TMenuItem;
     MakeaSpecialPeakModel1: TMenuItem;
     N4: TMenuItem;
     AutomaticSpectrumMarking1: TMenuItem;
     MarkbyEnergies1: TMenuItem;
     MarkbyLines1: TMenuItem;
     MarkbyData1: TMenuItem;
     N3: TMenuItem;
     IntervalFit1: TMenuItem;
     ContinueFit1: TMenuItem;
     SpectrumFit1: TMenuItem;
     FitLoop1: TMenuItem;
     FitforGraphs1: TMenuItem;
  {Data}Data1: TMenuItem;
     EnterMarkingEnergies1: TMenuItem;
     InputMarkingData1: TMenuItem;
     EditMarkingData1: TMenuItem;
     InputSpecFileNames1: TMenuItem;
  {Calibration}Calibration1: TMenuItem;
     InputEnergyCalbrData1: TMenuItem;
     InputEffCalibrData1: TMenuItem;
     EnterEnergycalibrData1: TMenuItem;
     EnterEffCalibrData1: TMenuItem;
     AutoEnergyCalibration1: TMenuItem;
  {Info}Info1: TMenuItem;
     ShowSpFilenames1: TMenuItem;
     ShowMarkedPeaks1: TMenuItem;
     ShowResultTable1: TMenuItem;
  {Help}Help1: TMenuItem;
     CommonHelp1: TMenuItem;
     GetStarted1: TMenuItem;
  {Test}Test1: TMenuItem;
          { D E V I C E S}
    OpenDialog1: TOpenDialog; {OK}
           {Addi}
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    {Change}Button1: TButton;
    {Next Fit}Button2: TButton;
    {Previous Fit}Button4: TButton;
    {Fit -> BMP}Button9: TButton;
    {OK}Button10: TButton;
    {Canc}Button11: TButton;
    {Next Int}Button12: TButton;
    {Prev Int}Button13: TButton;
    {Graph single peaks}Button14: TButton;
    StringGrid6: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;

    PROCEDURE InputtheSpectrum1Click(Sender: TObject);
    PROCEDURE CompresstheSpectrum1Click(Sender: TObject);
    PROCEDURE SmooththeSpectrum1Click(Sender: TObject);
    PROCEDURE CorrectforBlunders1Click(Sender: TObject);
    PROCEDURE SimulatetheSpectrum1Click(Sender: TObject);
    PROCEDURE Exit1Click(Sender: TObject);
    PROCEDURE SettheSpectrumdata1Click(Sender: TObject);
    PROCEDURE SettheMarkingData1Click(Sender: TObject);
    PROCEDURE ShowMarkedPeaks1Click(Sender: TObject);
    PROCEDURE Button2Click(Sender: TObject);
    PROCEDURE SettheFitData1Click(Sender: TObject);
    PROCEDURE GraphtheSpectrum2Click(Sender: TObject);
    PROCEDURE CleartheForm1Click(Sender: TObject);
    PROCEDURE SavetheSummarytable1Click(Sender: TObject);
    PROCEDURE GraphaCadre1Click(Sender: TObject);
    PROCEDURE Button4Click(Sender: TObject);
    PROCEDURE MarkbyEnergies1Click(Sender: TObject);
    PROCEDURE ClickaCadre1Click(Sender: TObject);
    PROCEDURE SetWidthDependence1Click(Sender: TObject);
    PROCEDURE MarkbyLines1Click(Sender: TObject);
    PROCEDURE SetGraphScale1Click(Sender: TObject);
    PROCEDURE Reset1Click(Sender: TObject);
    PROCEDURE IntervalFit1Click(Sender: TObject);
    PROCEDURE SpectrumFit1Click(Sender: TObject);
    PROCEDURE ShowResultTable1Click(Sender: TObject);
    PROCEDURE EnterMarkingEnergies1Click(Sender: TObject);
    PROCEDURE MarkbyData1Click(Sender: TObject);
    PROCEDURE InputMarkingData1Click(Sender: TObject);
    PROCEDURE FitLoop1Click(Sender: TObject);
    PROCEDURE InputSpecFileNames1Click(Sender: TObject);
    PROCEDURE ShowSpFilenames1Click(Sender: TObject);
    PROCEDURE CommonHelp1Click(Sender: TObject);
    PROCEDURE FitforGraphs1Click(Sender: TObject);
    PROCEDURE GraphPeakModel1Click(Sender: TObject);
    PROCEDURE MakeaSpecialPeakModel1Click(Sender: TObject);
    PROCEDURE SaveEnergyCalibration1Click(Sender: TObject);
    PROCEDURE SaveEfficiencyCalibration1Click(Sender: TObject);
    PROCEDURE GraphEnergyCalibration1Click(Sender: TObject);
    PROCEDURE Image1MouseDown(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
    PROCEDURE Button9Click(Sender: TObject);
    PROCEDURE MarkandBuildthePeakModel1Click(Sender: TObject);
    PROCEDURE MarkPeaksonGraph1Click(Sender: TObject);
    PROCEDURE AutomaticSpectrumMarking1Click(Sender: TObject);
    PROCEDURE Image3MouseDown(Sender: TObject; Button: TMouseButton;
              Shift: TShiftState; X, Y: Integer);
    PROCEDURE Button12Click(Sender: TObject);
    PROCEDURE Button13Click(Sender: TObject);
    PROCEDURE Button10Click(Sender: TObject);
    PROCEDURE Button11Click(Sender: TObject);
    PROCEDURE CheckforPeakandAdd1Click(Sender: TObject);
    PROCEDURE Button14Click(Sender: TObject);
    PROCEDURE CuttheInterval1Click(Sender: TObject);
    PROCEDURE SettheNextSpectrumName1Click(Sender: TObject);
    PROCEDURE GetStarted1Click(Sender: TObject);
    PROCEDURE Test1Click(Sender: TObject);
    PROCEDURE ToggletheFormSize1Click(Sender: TObject);
    PROCEDURE EditMarkingData1Click(Sender: TObject);
    PROCEDURE SavetheInitfile1Click(Sender: TObject);
    PROCEDURE FormClose(Sender: TObject; var Action: TCloseAction);
    PROCEDURE Button1Click(Sender: TObject);
    PROCEDURE ContinueFit1Click(Sender: TObject);
    PROCEDURE Calibration1Click(Sender: TObject);
    PROCEDURE InputEnergyCalbrData1Click(Sender: TObject);
    PROCEDURE InputEffCalibrData1Click(Sender: TObject);
    PROCEDURE EnterEnergycalibrData1Click(Sender: TObject);
    PROCEDURE EnterEffCalibrData1Click(Sender: TObject);
    PROCEDURE BuildtheBackground1Click(Sender: TObject);
    PROCEDURE AutoEnergyCalibration1Click(Sender: TObject);
  PRIVATE
    { Private declarations }
  PUBLIC
    { Public declarations }
  END;
VAR Form1: TForm1;
    ok1:BOOLEAN;
    xg,yg:INTEGER;
CONST ErrNoGr:STRING = 'Error, no graph';

IMPLEMENTATION
{$R *.DFM}
PROCEDURE ResizeF1(sc1,sc2:REAL);
BEGIN WITH Form1 DO
 BEGIN scrsize:=sc2; Left:=0; Top:=0; Width:=exs(630); Height:=exs(470);
 Caption:='  VISUAL ACTIV +++ 2007,    by Zlokazov V.B.';
 Color:=clBtnFace; scrsize:=sc1; Font.Size:=fntsize;
 WITH Image1 DO
  BEGIN Left:=0; Top:=0; Width:=exs(320); Height:=exs(264);
  Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
  END;
 WITH Image2 DO
  BEGIN Left:=exs(321); Top:=0; Width:=exs(300); Height:=exs(264);
  Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
  END;
 WITH Image3 DO
  BEGIN Left:=0; Top:=0; Width:=exs(600); Height:=exs(424);
  Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
  END;
 END;
END;
PROCEDURE ResizeF2(sc1,sc2:REAL);
BEGIN WITH Form2 DO
 BEGIN scrsize:=sc2; Left:=0; Top:=0; Width:=exs(320);
 Height:=exs(516); scrsize:=sc1; Font.Size:=fntsize;
 WITH Image1 DO
  BEGIN Left:=0; Top:=1; Width:=exs(310); Height:=exs(290);
  Font.Size:=fntsize; Canvas.Pixels[Left+Width-1,Top+Height-1]:=0;
  END;
 END;
END;
PROCEDURE EnableM(m:BOOLEAN);
BEGIN WITH Form1 DO
 BEGIN File1.Enabled:=m; Settings1.Enabled:=m; Graph1.Enabled:=m;
 Mark1.Enabled:=m; Operation1.Enabled:=m; Data1.Enabled:=m;
 Info1.Enabled:=m; Help1.Enabled:=m;
 END;
END;
PROCEDURE ClearArea(lx1,ly1,lx2,ly2,c:LONGINT);
BEGIN WITH Form1.Image3.Canvas DO
 BEGIN Brush.Color:=c; Brush.Style:=bsSolid;
 FillRect(Rect(exs(lx1),exs(ly1),exs(lx2),exs(ly2)));
 END;
END;
PROCEDURE AddDeleteP(r:REAL; mo:INTEGER);
VAR j:INTEGER; f:REAL; ix,l:LONGINT;
BEGIN j:=Round(r); f:=(j-ic1)+1; f:=f*exs(512)/(ic2-ic1+1);
j:=exs(60)+Round(f);
IF(mo=1)THEN l:=clLime ELSE l:=0;
WITH Form1.Image3.Canvas DO
 BEGIN Pen.Color:=l; ix:=j; MoveTo(ix,exs(355)); LineTo(ix,exs(364));
 END;
END;
PROCEDURE DeletePeaks;
VAR i:INTEGER; r:REAL;
BEGIN FOR i:=1 TO npeak DO
 BEGIN r:=marka[i]; AddDeleteP(r,0);
 END;
npeak:=0;
END;
PROCEDURE TForm1.CleartheForm1Click(Sender: TObject);
BEGIN HideComponents; ClearForm(clbtnFace);
END;
PROCEDURE HideComponents;
BEGIN WITH Form1 DO
 BEGIN StringGrid6.Visible:=false; HideLabels; Label3.Visible:=false;
 Button1.Visible:=false; Button2.Visible:=false; Button4.Visible:=false;
 Button9.Visible:=false; Button10.Visible:=false;
 Button11.Visible:=false; Button12.Visible:=false;
 Button13.Visible:=false; Button14.Visible:=false;
 Image1.Visible:=false; Image2.Visible:=false; Image3.Visible:=false;
 ClearForm(clbtnFace);
 END;
ncl:=0;
END;
PROCEDURE TForm1.Button1Click(Sender: TObject); {change fit conditions}
VAR i,i1,i2,im,lf,m:INTEGER;
BEGIN OnButtonChange(im,lf); m:=b2-b1+1;
CASE im OF
0,5,6:
   BEGIN OuttoLabel(Form1.Label3,390,190,
    clBlue,clWhite,' Click on the point. ');
   END;
1: BEGIN FOR i:=2 TO 4 DO WITH afit.par[i] DO
    BEGIN p:=0; pl:=-1E+11; pu:=1E+11;
    END;
   AFitting(1);
   END;
2: WITH spec DO
    BEGIN FOR i:=b1 TO b2 DO sa[i-b1+1]:=y[i];
    SmoothData(m,1); FOR i:=1 TO m DO y[i+b1-1]:=y[i+b1-1]-sd[i];
    AFitting(1); FOR i:=1 TO m DO y[i+b1-1]:=y[i+b1-1]+sd[i];
    END;
4: WITH spec DO
    BEGIN FOR i:=b1 TO b2 DO sa[i-b1+1]:=e[i];
    L0rec:=''; MakeFormV(250,20,330,430,0);
    OuttoLabel(Form2.Label1,5,20,clMaroon,clWhite,'Enter new bounds');
    strgrW[0]:=120; strgrW[1]:=100;
    strgrT[1]:=' i1='; strgrNn[1,1]:=b1;
    strgrT[2]:=' i2='; strgrNn[2,1]:=b2;
    PuttoTable(40,50,2,2,1,8);
    WITH Form2 DO
     BEGIN ShowModal; IF(ModalRes=0)THEN Exit;
     FOR i:=1 TO 2 DO Zval(StringGrid1.Cells[0,i-1],har[i]);
     i1:=Round(har[1]); i2:=Round(har[2]);
     END;
    mauxa[kcurr].i1:=i1; mauxa[kcurr].i2:=i2; AFitting(1);
    END;
ELSE END;
END;
PROCEDURE TForm1.Button2Click(Sender: TObject);  {Next fit}
BEGIN Inc(kcurr); AFitting(0);
END;
PROCEDURE TForm1.Button4Click(Sender: TObject);  {Previous fit}
BEGIN Dec(kcurr); AFitting(0);
END;
PROCEDURE TForm1.Button9Click(Sender: TObject);         {Fit -> BMP}
VAR i,j,ii:INTEGER; ok:BOOLEAN; l:LONGINT; x,xx:REAL;
BEGIN SaveHelp(blankH_n,blankH);
E1rec:='a.bmp'; GetFilename(E1rec,1); IF(ModalRes=0)THEN Exit;
i:=MessageDlg('Reverse the colors?',MtWarning,[mbYes,mbNo],0);
{Saveform(form1,E1rec);}
IF(i=mrYes)THEN WITH Image1.Canvas DO
 BEGIN ActivateForm2(100,400,50);
 Form2.Caption:='BMP-file forming proceeds. Wait...'; Form2.Show;
 FOR i:=0 TO exs(320) DO FOR j:=0 TO exs(265) DO
  BEGIN l:=Pixels[i,j]; IF(l=clBlack)THEN Pixels[i,j]:=clWhite;
  ok:=(l=clYellow)OR(l=clAqua)OR(l=clFuchsia)OR(l=clRed)OR(l=clLime);
  IF(ok)THEN Pixels[i,j]:=clBlack;
  END;
 Form2.Close;
 END;
GetDir(0,sedz); fn:=sedz+'\'+E1rec; Image1.Picture.SaveToFile(fn);
i:=PosB('.',fn); IF(i<>0)THEN Delete(fn,i+1,3); fn:=fn+'gph';
AssignFile(ft,fn); ReWrite(ft); FOR i:=b1 TO b2 DO
 BEGIN xx:=i-b1+1; arigax(x,xx); Write(ft,i:6,spec.y[i]:8:0,x:8:0);
 FOR ii:=1 TO npl DO Write(ft,rb0[2+ii]+rb0[1]:8:0); Writeln(ft);
 END;
CloseFile(ft);
END;
PROCEDURE TForm1.Button10Click(Sender: TObject);        {OK}
BEGIN ok1:=true; click1:=true; Button10.Enabled:=false;
Button11.Enabled:=false; IF(ncadr=1)THEN
 BEGIN Form1.Button12.Enabled:=true; Form1.Button13.Enabled:=true;
 END;
WITH Image3.Canvas DO
 BEGIN Brush.Color:=clMaroon; Brush.Style:=bsSolid;
 FillRect(Rect(exs(180),exs(60),exs(600),exs(94)));
 END;
END;
PROCEDURE TForm1.Button11Click(Sender: TObject);  {Cancel}
BEGIN IF(npeak>0)THEN
 BEGIN r:=marka[npeak]; AddDeleteP(r,0); Dec(npeak); nenm:=npeak;
 s:=tblank; IF(npeak>0)THEN
  BEGIN ConvertStr(marka[npeak],6,0); s:='  Chan='+sedz+bblank;
  END;
 Image3.Canvas.TextOut(exs(180),exs(75),
  'N of peaks = '+IntToStr(npeak)+s);
 END;
END;
PROCEDURE TForm1.Button12Click(Sender: TObject); {Next int}
BEGIN ic1:=ic2+1; ic2:=ic1+cadl-1; SetCadre;
END;
PROCEDURE TForm1.Button13Click(Sender: TObject); {Previous int}
BEGIN ic2:=ic1-1; ic1:=ic2-(cadl-1); SetCadre;
END;
PROCEDURE TForm1.Button14Click(Sender: TObject); {Graph components}
VAR x1,y1,i,j,m,i1,i2,ii,jj:INTEGER; amx,x,xx,step,r:REAL;
    li,lj:LONGINT; ixc1,iyc1,ixc2,iyc2:ARRAY[1..100] OF LONGINT;
BEGIN i1:=b1; i2:=b2; m:=i2-i1+1; r:=m;
step:=300/r; x1:=10; y1:=2;
amx:=amxgsp; Image1.Canvas.Pen.Style:=psSolid;
WITH Image1.Canvas DO FOR i:=i1 TO i2 DO FOR jj:=0 TO 2 DO
 BEGIN xx:=i-i1+1+jj*0.3333; j:=Round(xx*step); li:=exs(x1+j);
 Pen.Color:=clRed; FOR ii:=1 TO npl DO
  BEGIN arigax(x,xx); lj:=exs(y1+ACalcOrdinate(rb0[2+ii]+rb0[1],amx));
  IF(i=i1)THEN
   BEGIN ixc1[ii]:=li; iyc1[ii]:=lj;
   END    ELSE
    BEGIN ixc2[ii]:=li; iyc2[ii]:=lj; Moveto(ixc1[ii],iyc1[ii]);
    Lineto(ixc2[ii],iyc2[ii]);
    ixc1[ii]:=ixc2[ii]; iyc1[ii]:=iyc2[ii];
    END;
  END;
 END;
END;
PROCEDURE TForm1.Image3MouseDown(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
VAR cry,a,w,r,p,q,b,e,wic,c1,c2:REAL; i,j,k,m,l:INTEGER; ok:BOOLEAN;
BEGIN m:=spec.a2;
IF((x>=exs(60))AND(x<=exs(572))AND(y>=exs(100))AND(y<=exs(355)))THEN
CASE grst OF                                           {Common graph}
1..5: BEGIN i:=Round(PointChan(x))-1; r:=i; q:=spec.y[i]; p:=i;
      GetPeakWidthB(spec.y,m,r,w,a,b,ok); DisplVal(440,5,590,85,q,p,w);
      END;
13: BEGIN xg:=x; yg:=y; click1:=true;
    END;
ELSE END;
END;
PROCEDURE TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
          Shift: TShiftState; X, Y: Integer);
VAR   i,j:INTEGER; d,r:REAL;
LABEL Lend;
BEGIN r:=b2-b1+1; r:=Round(r*(x-exs(10))/exs(300)+b1-1); j:=Round(r);
CASE reacfit OF
0: DisplPoint(392,137,542,187,r);
1: BEGIN WITH spec DO y[j]:=(y[j-1]+y[j+1])/2; AFitting(0);
   END;
2: BEGIN FOR i:=ntab DOWNTO ki1+npl DO tab[i+1]:=tab[i]; Inc(ntab);
   Inc(npeak); marka[npeak]:=j; GOTO Lend;
   END;
3: BEGIN FOR i:=ki1+npl-1 TO ntab DO tab[i]:=tab[i+1]; Dec(ntab);
   r:=1E15; FOR i:=1 TO npeak DO
    BEGIN d:=ABS(marka[i]-Float(j)); IF(d<=r)THEN
     BEGIN k:=i; r:=d;
     END;
    END;
   marka[k]:=0; cleanz(marka,npeak,0); GOTO Lend;
   END;
ELSE END; Exit;
Lend: WITH spec DO peaksr.DivideTheInterval(a11,a22); AFitting(0);
END;
PROCEDURE ContinueGraph(S:TObject);
BEGIN IF(grst=1)THEN Form1.GraphtheSpectrum2Click(S) ELSE
IF(grst=3)THEN Form1.GraphaCadre1Click(S) ELSE ;
END;
PROCEDURE TForm1.InputtheSpectrum1Click(Sender: TObject);       {FILE}
BEGIN InputtheSpectrum; IF(ModalRes=1)THEN
 BEGIN ncl:=0; grst:=1; ContinueGraph(Self);
 END;
LabelOut(LB1rec.ar[1],'');
END;
PROCEDURE TForm1.CorrectforBlunders1Click(Sender: TObject);
BEGIN CorrectforBlunders; grst:=1; ContinueGraph(Self);
LabelOut(LB1rec.ar[1],'');
END;
PROCEDURE TForm1.CompresstheSpectrum1Click(Sender: TObject);
BEGIN CompresstheSpectrum; grst:=1; ContinueGraph(Self);
LabelOut(LB1rec.ar[1],'');
END;
PROCEDURE TForm1.SmooththeSpectrum1Click(Sender: TObject);
BEGIN SmoothASpectrum(0); grst:=1; ContinueGraph(Self);
LabelOut(LB1rec.ar[1],'');
END;
PROCEDURE TForm1.BuildtheBackground1Click(Sender: TObject);
BEGIN SmoothASpectrum(1); grst:=1; ContinueGraph(Self);
LabelOut(LB1rec.ar[1],'');
END;
PROCEDURE TForm1.SimulatetheSpectrum1Click(Sender: TObject);
BEGIN SimulateTheSpectrum; npeak:=0; kc:=0;
grst:=1; ContinueGraph(Self);
END;
PROCEDURE TForm1.SavetheSummaryTable1Click(Sender: TObject);
BEGIN IF(npeak=0)THEN
 BEGIN LabelOut('Error! No peaks fitted',''); Exit;
 END;
IF(ntab<>0)THEN SavetheSummaryTable;
END;
PROCEDURE TForm1.SavetheInitfile1Click(Sender: TObject);
BEGIN SaveIniFile; LabelOut('Ini file saved as vactiv.tmp','');
END;
PROCEDURE TForm1.SaveEnergyCalibration1Click(Sender: TObject);
BEGIN SaveEnergyCalibration;
END;
PROCEDURE TForm1.SaveEfficiencyCalibration1Click(Sender: TObject);
BEGIN SaveEfficiencyCalibration;
END;
PROCEDURE TForm1.Exit1Click(Sender: TObject);
VAR i:INTEGER;
BEGIN IF(nosaved)THEN
 BEGIN i:=MessageDlg
  ('Results not saved. Quit?',MtWarning,[mbYes,mbNo],0);
  IF(i=mrNo)THEN Exit;
 END;
peaksr.Free; pmod[1].Free; spec.Free; afit.Free;
IF(debugV.activ)THEN CloseFile(fout); SaveSettings(dirn+'\vactiv.fn');
Application.Terminate;
END;
PROCEDURE TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
BEGIN Exit1Click(Self);
END;
{***}
PROCEDURE TForm1.SettheSpectrumdata1Click(Sender: TObject);     {SET}
BEGIN SetSpectrumData; GraphaCadre1Click(Self);
END;
PROCEDURE TForm1.SettheMarkingData1Click(Sender: TObject);
BEGIN SetMarkingData;
END;
PROCEDURE TForm1.SettheFitData1Click(Sender: TObject);
BEGIN SetFitData;
END;
PROCEDURE TForm1.SetWidthDependence1Click(Sender: TObject);
BEGIN SetWidthDependence; WITH LB1rec DO LabelOut(ar[1],ar[2]);
END;
PROCEDURE TForm1.SetGraphScale1Click(Sender: TObject);
BEGIN SetScaleMode; ContinueGraph(Self);
END;
PROCEDURE TForm1.SettheNextSpectrumName1Click(Sender: TObject);
BEGIN SettheNextSpectrumName;
END;
PROCEDURE TForm1.ToggletheFormSize1Click(Sender: TObject);
BEGIN ToggletheFormSize; r:=scrsize; ResizeF1(r,r); ResizeF2(r,r);
HideComponents; ContinueGraph(Self);
END;
{***}
PROCEDURE TForm1.GraphtheSpectrum2Click(Sender: TObject);       {GRAPH}
BEGIN ic1:=spec.a1; ic2:=spec.a2; cadl:=ic2-ic1+1; ncadr:=0;
HideComponents; grst:=1; GraphMain(spec.spx);
END;
PROCEDURE {Graph Interv}TForm1.GraphaCadre1Click(Sender: TObject);
BEGIN HideComponents; grst:=3; ncadr:=1;
ic1:=spec.a11; ic2:=spec.a22; cadl:=ic2-ic1+1; SetCadre;
END;
PROCEDURE TForm1.ClickaCadre1Click(Sender: TObject);
BEGIN IF(grst=0)THEN
 BEGIN LabelOut(ErrNoGr,''); Exit;
 END;
GettheBounds(ic1,ic2,cadl); ncadr:=1; SetCadre;
END;
PROCEDURE TForm1.GraphPeakModel1Click(Sender: TObject);
BEGIN GraphPeakModel(1);
END;
PROCEDURE TForm1.GraphEnergyCalibration1Click(Sender: TObject);
BEGIN GraphEnergyCalibration;
END;
{***}                                                           {MARK}
PROCEDURE TForm1.{MakeInt}CuttheInterval1Click(Sender: TObject);
BEGIN IF(grst=0)THEN
 BEGIN LabelOut(ErrNoGr,''); Exit;
 END;
GettheBounds(ic1,ic2,cadl); ncadr:=1; SetCadre;
spec.a11:=ic1; spec.a22:=ic2;
END;
PROCEDURE TForm1.MarkPeaksonGraph1Click(Sender: TObject);
VAR i,j,k,i1,i2:INTEGER; a,w,r:REAL;
BEGIN IF((grst=2)OR(grst=0))THEN
 BEGIN LabelOut(ErrNoGr,''); Exit;
 END;
grst:=13; IF(npeak>0)THEN
 BEGIN i:=MessageDlg('Reset the counter?',MtWarning,[mbYes,mbNo],0);
 IF(i=mrYes)THEN DeletePeaks;
 END;
Button10.Enabled:=true; Button11.Enabled:=true; IF(ncadr=1)THEN
 BEGIN Button12.Enabled:=false; Button13.Enabled:=false;
 END;
k:=MIN0(3,(ic2-ic1+1)DIV 1024); EnableM(false); ok1:=false;
LabelOut(' Click on the peaks, at finish - on OK ','');
REPEAT s:=dblank; IF(npeak>0)THEN
 BEGIN ConvertStr(marka[npeak],6,0); s:='   Chan='+sedz+bblank;
 END;
LabelOut(Label1.Caption,'N of peaks = '+IntToStr(npeak)+s);
Wait(click1); r:=PointChan(xg)-1; j:=Round(r);
i1:=MAX0(j-k,ic1+1); i2:=MIN0(j+k,ic2-1);
IF(k>0)THEN FOR i:=i1 TO i2 DO IF(spec.y[i]>spec.y[j])THEN j:=i;
IF((NOT ok1)AND(InInt(j,ic1,ic2)))THEN
 BEGIN Inc(npeak); marka[npeak]:=j; enmlist[npeak]:=j;
 AddDeleteP(r,1);
 END;
UNTIL ok1;
grst:=1; EnableM(true); nenm:=npeak; HideLabels;
END;
PROCEDURE TForm1.MarkandBuildthePeakModel1Click(Sender: TObject);
VAR i:INTEGER;
BEGIN IF(grst=0)THEN
 BEGIN LabelOut(ErrNoGr,''); Exit;
 END;
GettheBounds(g1,g2,i); IF(ncadr=1)THEN
 BEGIN Button12.Enabled:=true; Button13.Enabled:=true;
 END;
TaketheModel; IF(ModalRes=0)THEN Exit;
LabelOut(' Real peak model set up','');
END;
PROCEDURE TForm1.CheckforPeakandAdd1Click(Sender: TObject);
VAR cry,a,w,r,b,wic,c1,c2:REAL; i,j1,j2:INTEGER; ok:BOOLEAN;
BEGIN LabelOut('Click on the peak top',''); grst:=13;
Wait(click1); r:=PointChan(xg)-1; WITH spec DO
 BEGIN GetPeakWidthB(y,a2,r,w,a,b,ok);
 c1:=(r-a1)/(a2-a1+1); c2:=1-c1; wic:=c2*w0+c1*w1;
 IF(NOT ok)THEN w:=wic; IF(w<4)THEN w:=4;
 j1:=MAX0(ic1,Round(r-1.5*w)); j2:=MIN0(ic2,Round(r+1.5*w));
 b:=(y[j1]+y[j1+1]+y[j2]+y[j2-1])*0.25*(j2-j1+1);
 a:=0; FOR i:=j1 TO j2 DO a:=a+y[i]; a:=AMAX1(0,a-b);
 END;
err:=SQRT(ABS(a)+ABS(b)+1); cry:=a/err; ConvertStr(cry,10,2);
s:='Interval '+IntToStr(j1)+' - '+IntToStr(j2)+crc+
   'Cryt= '+sedz+'     (if < 3, no effect)'+crc+
   'Backgr= '+IntToStr(Round(b))+crc+
   'Save to res-table? (Y,No)';
i:=MessageDlg(s,MtWarning,[mbYes,mbNo],0);
LabelOut('',''); grst:=1; IF(i=mrNo)THEN Exit;
IF(ntab+1>ntabx)THEN
 LabelOut('Error, too many peaks in the table','')
                ELSE
 BEGIN Inc(ntab); k:=ntab;
 tab[k].ch:=r; tab[k].ech:=0; tab[k].ss:=a;
 tab[k].ess:=err; tab[k].g:=w; tab[k].eg:=0;
 tab[k].chi2:=cry; tab[k].chip:=b;
 Inc(npeak); Inc(nint); marka[npeak]:=r; WITH mauxa[nint] DO
  BEGIN i1:=i; i2:=j; k1:=npeak; k2:=npeak;
  END;
 END;
END;
{***}                                                        {OPERATION}
PROCEDURE TForm1.Reset1Click(Sender: TObject);
VAR i:INTEGER;
BEGIN IF(nosaved)THEN i:=MessageDlg('Previous fit results not saved',
mtInformation,[mbOK,mbCancel],0); IF(i=mrCancel)THEN Exit;
ntab:=0; ntab0:=0; kc:=0; npeak:=0; nint:=0;
HideComponents; nosaved:=false;
END;
PROCEDURE TForm1.MakeaSpecialPeakModel1Click(Sender: TObject);
BEGIN FormSpecialPeakModel;
END;
PROCEDURE TForm1.AutomaticSpectrumMarking1Click(Sender: TObject);
BEGIN mrkmod:=0; {Auto-mark}MakePeakMarking;
END;
PROCEDURE TForm1.MarkbyEnergies1Click(Sender: TObject);
BEGIN mrkmod:=2; MakePeakMarking;
END;
PROCEDURE TForm1.MarkbyLines1Click(Sender: TObject);
BEGIN mrkmod:=3; MakePeakMarking;
END;
PROCEDURE TForm1.MarkbyData1Click(Sender: TObject);
BEGIN mrkmod:=4; MakePeakMarking;
END;
PROCEDURE FitPortion;
BEGIN IF(npeak*nint=0)THEN
 BEGIN ShowMess('No marking data'); Exit;
 END;
HideComponents; autofit:=1; nosaved:=true; grst:=2; AFitting(0);
IF(success)THEN Form1.ClickaCadre1.Enabled:=false ELSE nosaved:=false;
END;
PROCEDURE TForm1.IntervalFit1Click(Sender: TObject);
BEGIN IF(nosaved)THEN i:=MessageDlg('Previous fit results not saved',
mtInformation,[mbOK,mbCancel],0); IF(i=mrCancel)THEN Exit;
kcurr:=1; FitPortion;
END;
PROCEDURE TForm1.ContinueFit1Click(Sender: TObject);
BEGIN FitPortion;
END;
PROCEDURE TForm1.SpectrumFit1Click(Sender: TObject);
BEGIN IF(npeak=0)THEN
 BEGIN LabelOut('No marking data',''); Exit;
 END;
IF(nosaved)THEN
 BEGIN i:=MessageDlg('Previous fit results not saved',
  mtInformation,[mbOK,mbCancel],0); IF(i=mrCancel)THEN Exit;
 END;
gphmo:=0; autofit:=0; FitSpectrum(0,ft); nosaved:=true; HideComponents;
ClickaCadre1.Enabled:=false; WITH LB1rec DO
 BEGIN ar[1]:='The spectrum has been fitted.';
 ar[2]:='Save the results'; LabelOut(ar[1],ar[2]);
 END;
END;
PROCEDURE TForm1.FitLoop1Click(Sender: TObject);
VAR   i:INTEGER; ft:TEXTFILE; ok:BOOLEAN;
LABEL Lend;
BEGIN IF(nsfn=0)THEN
 BEGIN LabelOut('Error, no spectrum file names',''); Exit;
 END;
IF(npeak=0)THEN
 BEGIN LabelOut('Error, no marking data',''); Exit;
 END;
IF(NOT(spec.smosp IN [1,2]))THEN
 BEGIN LabelOut('Error, this file type not allowed',''); Exit;
 END;
gphmo:=0; AssignFile(ft,loopfn); Rewrite(ft);
Writeln(ft,
'   Channel  Energy     Area     Intensity    Width   Norm.int.'+
' Chi2/chi+');
HideComponents; FOR i:=1 TO nsfn DO WITH spec DO
 BEGIN sfn:=sfnar[i]; IF(NOT FileExists(sfn))THEN
  BEGIN LabelOut('No file '+sfn,''); GOTO Lend;
  END;
 spec.Read2Binary(ok);
 IF(NOT ok)THEN ShowMess('Spectrum '+spec.sfn+' is wrong')
           ELSE
  BEGIN Writeln(ft,' ':20,'Spectrum '+spec.sfn);
  WITH Image3.Canvas DO
   BEGIN Font.Color:=clRed; Brush.Color:=clbtnFace;
   TextOut(120,40,spec.sfn);  Font.Color:=clGreen;
   TextOut(120,20,'Processing');
   END;
  FitSpectrum(1,ft);
  END;
 Lend:;
 END;
CloseFile(ft);
L0rec:='FIT  LOOP'; MakeFormV(250,20,330,430,0);
WITH LB1rec DO
 BEGIN ar[1]:='LOOP  FIT  finished, Results saved to vactiv.tab';
 ar[2]:='  '+IntToStr(nsfn)+' spectra processed'; LabelOut(ar[1],ar[2]);
 END;
END;
PROCEDURE TForm1.FitforGraphs1Click(Sender: TObject);
BEGIN IF(npeak=0)THEN
 BEGIN LabelOut('No marking data',''); Exit;
 END;
FitforGraphs;
END;
{***}
PROCEDURE TForm1.EnterMarkingEnergies1Click(Sender: TObject);   {DATA}
BEGIN EnterMarkingEnergies;
END;
PROCEDURE TForm1.InputMarkingData1Click(Sender: TObject);
BEGIN InputMarkingData; IF(ModalRes=0)THEN Exit;
mrkmod:=1; MarkSpectrum;
LB1rec.ar[1]:=IntToStr(kc)+' items input.'; DisplayInfo3(1);
END;
PROCEDURE TForm1.EditMarkingData1Click(Sender: TObject);
VAR i:INTEGER;
BEGIN EditMarkingData; FOR i:=1 TO kc DO peak[i]:=onl[i];
CheckMarkCorrect(i);
LB1rec.ar[1]:=IntToStr(kc)+' items edited.'; DisplayInfo3(1);
END;
PROCEDURE TForm1.InputSpecFileNames1Click(Sender: TObject);
BEGIN InputSpecFileNames;
END;
{***}
PROCEDURE TForm1.Calibration1Click(Sender: TObject);            {CALIBR}
BEGIN {a}
END;
PROCEDURE TForm1.InputEnergyCalbrData1Click(Sender: TObject);
BEGIN EnterCalibrationData(0);
END;
PROCEDURE TForm1.InputEffCalibrData1Click(Sender: TObject);
BEGIN EnterCalibrationData(1);
END;
PROCEDURE TForm1.EnterEnergycalibrData1Click(Sender: TObject);
BEGIN ShowEnergyCalibration;
END;
PROCEDURE TForm1.EnterEffCalibrData1Click(Sender: TObject);
BEGIN ShowEfficiencyCalibration;
END;
PROCEDURE TForm1.AutoEnergyCalibration1Click(Sender: TObject);
BEGIN FittheRadCalibr;
END;
{***}
PROCEDURE TForm1.ShowSpFilenames1Click(Sender: TObject);        {INFO}
BEGIN ShowSpFilenames;
END;
PROCEDURE TForm1.ShowMarkedPeaks1Click(Sender: TObject);
BEGIN ShowMarkedPeaks;
END;
PROCEDURE TForm1.ShowResultTable1Click(Sender: TObject);
BEGIN ShowResultTable;
END;
{***}
PROCEDURE TForm1.CommonHelp1Click(Sender: TObject);             {HELP}
BEGIN SaveHelp(GeneralH_n,GeneralH); MakeHelp(0);
END;
PROCEDURE TForm1.GetStarted1Click(Sender: TObject);
BEGIN SaveHelp(GetStart_n,GetStart); MakeHelp(0);
END;
{***}
PROCEDURE TForm1.Test1Click(Sender: TObject);                   {TEST}
BEGIN SetTestSpectra;
END;
{*******}
PROCEDURE ClearForm(col:INTEGER);
BEGIN grst:=0; WITH Form1.Canvas DO
 BEGIN Brush.Color:=col; Brush.Style:=bsSolid;
 FillRect(Rect(0,0,exs(630),exs(470)));
 END;
END;
PROCEDURE AFitting(mo:INTEGER);
{Fit kcurr-th interval, m0=1-> max backgr. Version Feb 10 2000}
VAR   ii,jj,i,j,k,l,ll,ix,iy:INTEGER;
      rr,r,t1,t2,amin,rmin,c1,c2:REAL; log:BOOLEAN; lx,ly,ld:LONGINT;
      back,ratio,a,ea,ch,ech,g,eg,ss,ess,ai,eai,sc,en,een:REAL;
BEGIN {GetDatTim; t1:=cursec;} kcurr:=MAX0(1,MIN0(kcurr,nint));
ki1:=mauxa[kcurr].k1; ki2:=mauxa[kcurr].k2; reacfit:=0;
b1:=mauxa[kcurr].i1; b2:=mauxa[kcurr].i2;
npl:=ki2-ki1+1; ld:=17; success:=true; IF(npl=0)THEN
 BEGIN ShowMess('Error, no peaks in '+IntToStr(b1)+' '+IntToStr(b2));
 success:=false; Exit;
 END;
npl:=MIN0(npl,npimxc);
IF((b2-b1+1)>linx)THEN
 BEGIN LabelOut('Error, too long interval '+IntToStr(b1)+' '+
 IntToStr(b2),''); success:=false; Exit;
 END;
FOR i:=1 TO npl DO afit.par[4+npl+i].p:=marka[ki1+i-1];
WITH spec DO
 BEGIN c1:=(b1-a11)/(a2{2}-a1{1}+1); c2:=1-c1; width:=c2*w0+c1*w1;
 END;
FittheInterval(mo);
ClearForm(clGreen); ly:=exs(10); WITH Form1 DO {output of results}
 BEGIN Mark1.Enabled:=false; Image2.Visible:=true;Label3.Visible:=false;
 END;
WITH Form1.Image2.Canvas DO
 BEGIN Brush.Style:=bsSolid;
 Brush.Color:=clGreen; FillRect(Rect(0,0,exs(300),exs(265)));
 Brush.Color:=clbtnFace;
 FillRect(Rect(exs(13),exs(10),exs(287),exs(207)));
 Pen.Color:=clMaroon; Pen.Style:=psSolid;
 FOR ii:=0 TO 2 DO
  Rectangle(exs(10+ii),exs(7+ii),exs(290-ii),exs(210-ii));
 FOR ii:=0 TO 2 DO
  BEGIN MoveTo(exs(10),exs(45+ii)); LineTo(exs(290),exs(45+ii));
  END;
 lx:=exs(30); Font.Color:=clBlack; Font.Style:=[fsBold];
 Font.Size:=fntsize;
 i:=PosB('\',spec.sfn); s:='FILE= '+Copy(spec.sfn,i+1,72);
 TextOut(lx,ly,s); ly:=ly+exs(15);
 ConvertStr(b1,6,0); s:='INT.= '+sedz+' -';
 ConvertStr(b2,6,0); s:=s+sedz;
 r:=npl; ConvertStr(r,3,0); s:=s+'  '+sedz+' peak(s)';
 s:=s+'  DB='+IntToStr(rback); TextOut(lx,ly,s);
 Font.Color:=clRed; Brush.Color:=0; ly:=ly+exs(25);
 WITH afit DO
  BEGIN IF(nocnv)THEN
   BEGIN TextOut(lx,ly,gf_pnc); ly:=ly+exs(ld);
   END;
  IF(noinv)THEN
   BEGIN TextOut(lx,ly,gf_mni); ly:=ly+exs(ld);
   END;
  IF((noch)OR(noequ))THEN
   BEGIN TextOut(lx,ly,gf_fng); ly:=ly+exs(ld);
   END;
  log:=false; FOR i:=npl+5 TO 4+2*npl DO
   BEGIN log:=log OR(((par[i].p=par[i].pl)OR(par[i].p=par[i].pu))
   AND(par[i].p<>par[i].pu));
   END;
  IF(log)THEN
   BEGIN TextOut(lx+exs(20),ly,'Peak pos. on the boundary  ');
   ly:=ly+exs(15);
   END;
  log:=false; FOR i:=2*npl+5 TO npar DO WITH par[i] DO
   BEGIN log:=log OR(((p=pl)OR(p=pu))AND(pl<>pu));
   END;
  IF(log)THEN
   BEGIN TextOut(lx+exs(20),ly,'Peak width on the boundary  ');
   ly:=ly+exs(20);
   END;
  Font.Color:=clBlack; Brush.Color:=clbtnFace;
  ConvertStr(rb.chi2,7,2); s:='Ch2/df='+sedz; TextOut(lx,ly,s);
  ConvertStr(rb.chipl,5,2); s:='Ch+= '+sedz; TextOut(lx+exs(120),ly,s);
  END;
 IF((nint=kcurr)AND(nosaved))THEN OuttoLabel(Form1.Label3,
  345,190,0,clRed,'  Fitting finished. Save the results. ');
 END;
  {sc:=a*f0[nlb+1]; ratio:=ABS(sc/AMAX1(back,0.1));}
PrepareStrGrid(Form1.StringGrid6,npl,2,exs(267),exs(155));
WITH Form1.StringGrid6 DO
 BEGIN LeftCol:=1; FOR i:=1 TO npl DO
  BEGIN GetParValues(i,ch,ech,g,eg,ss,ess,ratio,back);
  k:=ki1+i-1+ntab0; ntab:=MAX0(k,ntab); k:=MIN0(k,ntabx);
  IF(ntab>ntabx)THEN ShowMess('Error, too many peaks in the table');
  tab[k].ch:=ch; tab[k].ech:=ech; tab[k].ss:=ss;
  tab[k].ess:=ess; tab[k].g:=g; tab[k].eg:=eg;
  tab[k].chi2:=ratio; tab[k].chip:=back;
  calibr(ch,ech,ss,ess,en,een,ai,eai);
  ConvertStr(ch,8,2); Cells[1,(i-1)*2+1]:=sedz;
  ConvertStr(ech,8,2); Cells[1,(i-1)*2+2]:=sedz;
  ConvertStr(en,8,2); Cells[2,(i-1)*2+1]:=sedz;
  ConvertStr(een,8,2); Cells[2,(i-1)*2+2]:=sedz;
  ConvertStr(ss,10,0); Cells[3,(i-1)*2+1]:=sedz;
  ConvertStr(ess,8,0); Cells[3,(i-1)*2+2]:=sedz;
  ConvertStr(ai,10,0); Cells[4,(i-1)*2+1]:=sedz;
  ConvertStr(eai,8,0); Cells[4,(i-1)*2+2]:=sedz;
  ConvertStr(g,8,2); Cells[5,(i-1)*2+1]:=sedz;
  ConvertStr(eg,8,2); Cells[5,(i-1)*2+2]:=sedz;
  ConvertStr(ratio,8,2); Cells[6,(i-1)*2+1]:=sedz;
  ConvertStr(back,8,0); Cells[6,(i-1)*2+2]:=sedz;
  END;
 END;
Form1.Image1.Visible:=true; Bitmap:=TBitmap.Create; WITH Bitmap DO
 BEGIN Width:=exs(320); Height:=exs(265);
 END;
grapc(b1,b2); Form1.Image1.Canvas.Draw(0,0,Bitmap); Bitmap.Free;
{Writeln('Elapsed time = ',(t2-t1):8:3,' sec');}
{GetDatTim; t2:=cursec;}
MaketheButton(Form1.Button4,335,211,75,25,'Previous');
MaketheButton(Form1.Button2,415,211,83,25,'Next');
MaketheButton(Form1.Button9,502,211,105,25,'Fit -> BMP+File');
MaketheButton(Form1.Button14,355,236,150,25,'Graph Single Peaks');
MaketheButton(Form1.Button1,510,236,75,25,'Change');
IF(kcurr<=1)THEN Form1.Button4.Enabled:=false;
IF(kcurr>=nint)THEN Form1.Button2.Enabled:=false;
Form1.Show;
END;
PROCEDURE SetCadre;
VAR i,j:INTEGER; ax:REAL;
BEGIN j:=spec.a1; IF(ic1<j)THEN
 BEGIN ic1:=j; ic2:=ic1+cadl-1;
 END;
j:=spec.a2; IF(ic2>j)THEN
 BEGIN ic2:=j; ic1:=ic2-cadl+1;
 END;
cadl:=ic2-ic1+1; ax:=0; FOR i:=ic1 TO ic2 DO ax:=AMAX1(ax,spec.y[i]);
GraphMain(ax);
END;
PROCEDURE MakePeakMarking;
BEGIN ic1:=spec.a11; ic2:=spec.a22; MarkSpectrum;
HideComponents; grst:=1; SetCadre; WITH LB1rec DO
 BEGIN ar[1]:=' '+IntToStr(npeak)+' peak(s) found. ';
 IF(NOT okwidth)THEN ar[1]:=ar[1]+pwdcomm+' ';
 IF(ModalRes=0)THEN ar[1]:=''; LabelOut(ar[1],'');
 END;
END;
PROCEDURE Block4Buttons;
BEGIN Form1.Button10.Enabled:=false; Form1.Button11.Enabled:=false;
Form1.Button12.Enabled:=false; Form1.Button13.Enabled:=false;
END;
PROCEDURE GraphMain(VAR amx0:REAL);
VAR x1,y1,i,j,np:INTEGER; amx,x,st,z,r,e:REAL;
    ii,jj,li,lj,col1,col2:LONGINT;
BEGIN np:=ic2-ic1+1; r:=np; st:=512/r; x1:=60; y1:=100;
Form1.Mark1.Enabled:=true; Form1.ClickaCadre1.Enabled:=true;
amx:=CompCurrMax(amx0);
Bitmap:=TBitmap.Create; WITH Bitmap DO
 BEGIN Width:=exs(600); Height:=exs(423);
 END;
r:=scrsize; ResizeF1(r,r); Form1.Image3.Visible:=true;
WITH Bitmap.Canvas DO
 BEGIN col1:=clMaroon; col2:=clBlue; Brush.Style:=bsSolid;
 Font.Style:=[fsBold]; Font.Size:=8; Pen.Style:=psSolid;
 Brush.Color:=col1; FillRect(Rect(0,0,exs(630),exs(92)));
 FillRect(Rect(0,exs(367),exs(630),exs(470)));
 Brush.Color:=0; FillRect(Rect(exs(58),exs(95),exs(577),exs(365)));
 Brush.Color:=col2;
 FillRect(Rect(0,exs(95),exs(55),exs(365)));
 FillRect(Rect(exs(581),exs(95),exs(600),exs(365)));
 Font.Color:=clYellow; Pen.Color:=clLime; Brush.Color:=col2;
 FOR i:=1 TO 5 DO
  BEGIN r:=amx-(i-1)*amx/4; ConvertStr(r,9,0); Compress(sedz);
  lj:=exs(y1+(i-1)*62+3); li:=x1-13;
  FOR j:=1 TO 106 DO Pixels[exs(li+(j-1)*5),lj]:=clLime;
  TextOut(exs(10),lj-6,sedz);
  END;
 FOR i:=ic1 TO ic2 DO
  BEGIN x:=i-ic1+1; j:=Round(x*st); li:=exs(x1+j);
  lj:=exs(y1+ACalcOrdinate(spec.y[i],amx));
  FOR ii:=-1 TO 1 DO FOR jj:=-1 TO 1 DO
  IF((ABS(ii)+ABS(jj))<2)THEN Pixels[li+ii,lj+jj]:=clFuchsia;
  END;
 ClearArea(0,exs(368),exs(600),exs(420),col1); Font.Color:=clWhite;
 z:=np; z:=z/512; Brush.Color:=col1; FOR i:=1 TO 9 DO
  BEGIN li:=exs(x1+(i-1)*64);
  FOR j:=1 TO 53 DO Pixels[li,exs(96+(j-1)*5)]:=clLime;
  r:=ic1+(i-1)*z*64; ConvertStr(r,6,0);
  TextOut(li-exs(10),exs(370),'          ');
  TextOut(li-exs(20),exs(370),sedz);
  calibr(r,0,1,0,e,x,x,x); ConvertStr(e,7,1);
  TextOut(li-exs(10),exs(385),'          ');
  TextOut(li-exs(20),exs(385),sedz);
  END;
 TextOut(0,exs(370),'Chan.:'); TextOut(0,exs(385),'Energy:');
 ClearArea(0,8,600,92,col1); Font.Size:=fntsize;
 TextOut(exs(121),exs(10),'SPECTRUM = ');
 TextOut(exs(121),exs(25),'CHANNELS  =  '+IntToStr(ic1)+'  -  '
  +IntToStr(ic2));
 ConvertStr(amx,15,0); Compress(sedz);
 TextOut(exs(121),exs(40),'MAX  ='+sedz);
 Font.Color:=clLime; TextOut(exs(220),exs(10),spec.sfn);
 Pen.Color:=clAqua; Brush.Color:=0;
 END;
Form1.Image3.Canvas.Draw(0,0,Bitmap); Bitmap.Free;
MaketheButton(Form1.Button10,5, 5,110,20,'OK');
MaketheButton(Form1.Button11,5,26,110,20,'Cancel');
MaketheButton(Form1.Button12,5,47,110,20,'Next cadre');
MaketheButton(Form1.Button13,5,68,110,20,'Previous cadre');
IF(ncadr=0)THEN Block4Buttons;
IF(ncadr=1)THEN
 BEGIN Form1.Button10.Enabled:=false; Form1.Button11.Enabled:=false;
 END;
i:=1; IF(npeak>0)THEN WHILE(i<=npeak)DO
 BEGIN j:=Round(marka[i]); Inc(i); r:=j;
 IF((j>0)AND(infun(j,ic1,ic2)))THEN AddDeleteP(r,1);
 END;
END;
FUNCTION PointChan(x:INTEGER):REAL;
VAR i:INTEGER;
BEGIN i:=x-exs(60); r:=(ic2-ic1+1); PointChan:=r*i/exs(512)+ic1;
END;
PROCEDURE DisplPoint(x1,y1,x2,y2:LONGINT; r:REAL);
VAR ch,e,d:REAL; i:INTEGER;
BEGIN WITH Form1.Canvas DO
 BEGIN Brush.Color:=0; Pen.Color:=clLime; ConvertStr(r,6,0);
 RoundRect(exs(x1),exs(y1),exs(x2),exs(y2),exs(20),exs(20));
 Font.Color:=clAqua; TextOut(exs(x1+10),exs(y1+5),'Channel = '+sedz);
 i:=Round(r); ConvertStr(spec.y[i],12,0); Compress(sedz);
 TextOut(exs(x1+10),exs(y1+18),'Counts  = '+sedz); IF(encm)THEN
  BEGIN ch:=i; calibr(ch,0,1,0,e,d,d,d); ConvertStr(e,7,2);
  TextOut(exs(x1+10),exs(y1+31),'Energy  = '+sedz);
  END;
 END;
END;
PROCEDURE DisplVal(x1,y1,x2,y2:LONGINT; a,r,w:REAL);
VAR e,d:REAL;
BEGIN WITH Form1.Canvas DO
 BEGIN Brush.Color:=0; Pen.Color:=clLime;
 RoundRect(exs(x1),exs(y1),exs(x2),exs(y2),exs(20),exs(20));
 Font.Color:=clAqua;
 ConvertStr(spec.y[Round(r)],12,0); Compress(sedz);
 TextOut(exs(x1+10),exs(y1+4),'Counts= '+sedz);
 ConvertStr(r,8,1); TextOut(exs(x1+10),exs(y1+18),'Position = '+sedz);
 calibr(r,0,1,0,e,d,d,d); ConvertStr(e,7,2);
 TextOut(exs(x1+10),exs(y1+32),'Energy  = '+sedz);
 ConvertStr(a,10,0); Compress(sedz);
 TextOut(exs(x1+10),exs(y1+48),'Area  = '+sedz);
 ConvertStr(w,6,1); TextOut(exs(x1+10),exs(y1+62),'Width  = '+sedz);
 END;
END;
PROCEDURE DisplArea(x1,y1,x2,y2:LONGINT; a,r,w,e:REAL);
BEGIN WITH Form1.Canvas DO
 BEGIN Brush.Color:=0; Pen.Color:=clLime;
 RoundRect(exs(x1),exs(y1),exs(x2),exs(y2),exs(20),exs(20));
 Font.Color:=clAqua;
 ConvertStr(r,8,1); TextOut(exs(x1+10),exs(y1+5),'Position = '+sedz);
 ConvertStr(a,10,0); TextOut(exs(x1+10),exs(y1+18),'Area  = '+sedz);
 ConvertStr(e,6,0); TextOut(exs(x1+10),exs(y1+31),'Error  = '+sedz);
 ConvertStr(w,6,1); TextOut(exs(x1+10),exs(y1+44),'Width  = '+sedz);
 END;
END;
PROCEDURE HideLabels;
BEGIN Form1.Label1.Visible:=false; Form1.Label2.Visible:=false;
END;
PROCEDURE LabelOut(CONST s1,s2:STRING);
BEGIN WITH Form1 DO
 BEGIN IF(s1='')THEN Label1.Visible:=false
                ELSE OuttoLabel(Label1,121,59,clBlue,clYellow,s1);
 IF(s2='')THEN Label2.Visible:=false
          ELSE OuttoLabel(Label2,121,74,clBlue,clYellow,s2);
 END;
END;
PROCEDURE GettheBounds(VAR ic1,ic2,cadl:INTEGER);
VAR i:INTEGER;
BEGIN DeletePeaks;  EnableM(false); Block4Buttons; grst:=13;
LabelOut(' Click on the beginning ','');
Wait(click1); i:=Round(PointChan(xg));
LabelOut(Form1.Label1.Caption,' Click on the end ');
Wait(click1); ic2:=Round(PointChan(xg)); ic1:=i; Irrange2(ic1,ic2);
grst:=1; HideLabels; cadl:=ic2-ic1+1; EnableM(true);
END;




END.
